var app = angular.module( 'uiApp', [
		'ngRoute',
		'ngCookies',
		'login',
		//'dashboard', 'dashStorage', 'dashAlerts', 'dashJobs', 'dashBackup', 'dashRecover', 'dashReplication',
		'ChartAngular',
		'configure', 'configLicense', 'configAppliances', 'configAssets',
		'jobs',
		'reports',
		'constants',
        'help',
	    'options',
		'protect',
		'recover',
		'quickStartWizard',
		'mgo-angular-wizard',
		'recover',
        'dynamicdashboardapp',
		'archiveSummaryWidgetModule',
		'backupSummaryWidgetModule',
		'activeJobWidgetModule',
		'topForumPostsWidgetModule',
        "storageWidgetModule",
		"alertWidgetModule",
		'dailyFeedWidgetModule',
		'ngSanitize',
        'nsPopover',
        'angulartics',
        'angulartics.google.analytics',
        'tour-module',
		'retention',
        'replicationThrottleScheduleModule',
        'backupCopyOptionDialogModule'
]);

app.factory('Page', ['$cookieStore','$rootScope', function($cookieStore,$rootScope){
    var title = 'Unitrends UI';
    return {
        title: function() {
           if($rootScope.user.eulaWizardFlag){
                return "Unitrends End User License Agreement";
            }else if($rootScope.user.showSetupWizFlag){
                return "Unitrends QuickSetup Wizard";
            }else{
                return location.host + ' - ' + title;
            }
        },
        setTitle: function(newTitle, update_cookies) {
            if (update_cookies === undefined || update_cookies === true) {
                $cookieStore.put('Page', newTitle);
            }
            title = newTitle;
        }
    };
}]);

/*
modal dialog for alert
*/
app.directive('alertDialog', function () {
    return {
        restrict: 'E',
        scope: {
            show: '='
        },
        replace: true, // Replace with the template below
        transclude: true, // we want to insert custom content inside the directive
        link: function (scope, element, attrs) {
            scope.dialogStyle = {};
            if (attrs.width)
                scope.dialogStyle.width = attrs.width;
            if (attrs.height)
                scope.dialogStyle.height = attrs.height;
            scope.hideModal = function () {
                scope.show = false;
            };
        },
        template: "<div class='ng-modal' ng-show='show'><div class='ng-alertmodeldialog-dialog' ng-style='dialogStyle'><div class='ng-alertmodeldialog-dialog-content' ng-transclude></div></div></div>"
    };
});



/*
 * Items controlled at the global level.
 */
app.controller('GlobalCtrl', ['$scope', '$rootScope', '$window', '$location', '$cookieStore', '$http', 'Page',
		function($scope, $rootScope, $window, $location, $cookieStore, $http, Page) {
	
	$scope.Page = Page;
	
	/*open and close dailog*/
	$scope.modalShown = false;
	  
	$scope.toggleModal = function() {
        if($scope.modalShown == true)
        {
        $('.ng-alertmodeldialog-dialog').css("display","none");
            $scope.modalShown = !$scope.modalShown;
        }
        else
        { $('.ng-alertmodeldialog-dialog').css("display","block");
             $scope.modalShown = !$scope.modalShown;
        }
		
	};
	
	
	// user name should be passed from login
	$rootScope.backupTimer=10000;
    $rootScope.maintenance_mode = false;
    $rootScope.saveTimers = [];
    $rootScope.saveJobTimer = 0;
    $rootScope.saveJobTimer = 0;

	$scope.user = {};
	$scope.user.name = '';
	$scope.user.loggedIn = false; // start logged in right now.
	$scope.user.token = '';
	// set preferences for user, refresh rates, get user id.
	// track whether or not they have seen the tour (tour_activated)
	// track whether or not the eula is accepted (sula_accepted)
	// track the timezone: (timezone = 'US/Eastern')
	// track username, first and last name, email, active_user
	// is_superuser, is_staff?
	// date_user_created
	// tz string for timezone (tz='-0400')
	
	$rootScope.user = $scope.user;
    global_user = $rootScope.user;
		
	$scope.user.logout = function() {

        var userout = {};

        userout.cookie = $scope.user.token;

        $http.post('/api/logout', userout)
            .success(function(data, status, headers) {
                $scope.logoutUser();
            })
            .error(function(data, status, headers) {
                // Tap into PHD.throwError function here.
                // No need to display this.  There is nothing a user can do.  Log to the console and if logins fail, the user will see the errors.
                //window.PHD.throwError(data);
                if (data != undefined && data.result != undefined && data.result[0] != undefined && data.result[0].message != undefined) {
                    console.log("user.logout: error, message = " + data.result[0].message);
                }
                $scope.logoutUser();
            })
	};

    $scope.logoutUser = function() {
        // Send an event on logout.
        var e = $.Event('logout');
        $(document).trigger(e);

        // remove cookies if present.
        $cookieStore.remove('username');
        $cookieStore.remove('password');
        $cookieStore.remove('remember_me');
        $cookieStore.put('autologin', false);

        $scope.user.loggedIn = false;
        $rootScope.user.loggedIn = false;
        $rootScope.user.token = '';

        // force reload on logout to clean up Timers.
        $window.location.href = "#";
        $window.location.reload();
    };
	
	$scope.credentials = {
		username: '',
		password: ''
	};

	$rootScope.setIfDefined = function(obj, widget, variable, value) {
		if (typeof value !== 'undefined') {
            rate = value * 1000;
			obj[variable] = rate;
            $(document).trigger("userpreferencesave." + widget, [variable, rate]);
		}
	}
	
	$scope.bodyIsReady = function() {
		// Send an event to the jQuery listeners on login.
		console.log('body is ready');
	}
	
}]);

/*
 * Items controlled at the global level.
 */
app.controller('AppCtrl', ['getPreferencesFactory', 'getClientFactory', 'getStorageFactory', '$scope', '$rootScope', '$location', '$cookieStore', '$route', '$http', 'Page',
	function(getPreferencesFactory, getClientFactory, getStorageFactory, $scope, $rootScope, $location, $cookieStore, $route, $http, Page) {

	 /*Event to handle preferences*/
	   $scope.$on("update-userPrefrence", function(event, widgetName,refreshKey) {
	 			var dataObj ={};
				var url = '/api/preferences/' + $rootScope.user.name + '/';
				var dropdownKey="#id_"+widgetName.toLowerCase()+"Refresh";
                var my_dropid= "id_"+widgetName.toLowerCase()+'Refresh';
                var dropdown_id= "[id='"+my_dropid+"']";
				dataObj[refreshKey]=$(dropdown_id).val();
		 		$http({
					   url: url, 
					   data: JSON.stringify(dataObj),
					   method: 'PUT'
					}).success(function(data, status, headers){
						console.log("success");
						console.log(data);
					}).error(function(response){
						console.log(response);
					}); 
	});
	
	/*
	Initializing the variable at rootScopeLevel to implement Timer and save userPreference for refresh rate
    * 1) Stores function need to be called to refresh data.
	* 2) Stores time period after refresh function need to be called
	* 3) Stores ID return by setInterval function
	* 4) Stores ID of refresh Icon
	* 5) Stores controller of Widgets
	* 6) Stores widget specific refreshKey for saving userPreference
	*/
	$rootScope.listOfFunction=["$rootScope.getBackupRefereshData","$rootScope.getActiveJobData",
                               "$rootScope.getStorageData","$rootScope.getAlertsRefereshData",
                               "$rootScope.getTopForumPosts","$rootScope.getDailyFeed"];
	$rootScope.listOfTimer=[0,0,0,0,0,0,0,0,0];
	$rootScope.listOfWidgetName=["Backup","Active Job","Storage","Alerts","Post","Daily Feed"];
	$rootScope.listOfTimerFunction=["Backup","Active Job","Storage","Alerts","Post","Daily Feed"];
	$rootScope.listOfID=["[id='IDBACKUP SUMMARY']","[id='IDACTIVE JOBS']","[id='IDSTORAGE']",
                         "[id='IDAlerts']","[id='IDCOMMUNITY']","[id='IDDAILY FEED']"];
	$rootScope.listOfController=["[ng-controller=BackupWidgetContorller]","[ng-controller=ActiveJobsDashCtrl]",
                                 "[ng-controller=storageWidgetCtrl]","[ng-controller=AlertWidgetContorller]",
                                 "[ng-controller=TopForumPostsWidgetCtrl]","[ng-controller=DailyFeedWidgetController]"];
	$rootScope.listOfRefreshKey=["dash_backup_refresh","dash_active_job_refresh","dash_storage_refresh",
                                 "dash_alert_refresh","dash_forum_posts_refresh","dash_daily_feed_refresh"];

    /* Timer for refresh of Jobs Page */
    $rootScope.JobsTimer = PHD.Timer({
        namespace: "jobspage",
        interval: 0,
        refreshControl: null
    });

    /* Timer for refresh of Protect Page */
    $rootScope.ProtectTimer = PHD.Timer({
        namespace: "protectpage",
        interval: 0,
        refreshControl: null
    });

    /* Timer for refresh of Protect Page */
    $rootScope.RecoverTimer = PHD.Timer({
        namespace: "recoverpage",
        interval: 0,
        refreshControl: null
    });

    $rootScope.disableTimers = function() {
        if (!$rootScope.maintenance_mode) {
            var nTimers = $rootScope.listOfTimer.length;
            $rootScope.saveTimers = $rootScope.listOfTimer;
            for (var i = 0; i < nTimers; i++) {
                $rootScope.listOfTimer[i] = 0;
                clearInterval($rootScope.listOfTimerFunction[i]);
            }
            $rootScope.saveJobTimer = $rootScope.JobsTimer.getInterval();
            $rootScope.saveProtectTimer = $rootScope.ProtectTimer.getInterval();
            $rootScope.saveRecoverTimer = $rootScope.RecoverTimer.getInterval();
            $rootScope.JobsTimer.setInterval(0);
            $rootScope.ProtectTimer.setInterval(0);
            $rootScope.RecoverTimer.setInterval(0);
            $rootScope.maintenance_mode = true;
        }
    };

    $rootScope.enableTimers = function() {
        var nSavedTimers = $rootScope.saveTimers.length;
        var nTimers = $rootScope.listOfTimer.length;
        $rootScope.listOfTimer = $rootScope.saveTimers;
        for (var i = 0; i < nTimers && i < nSavedTimers; i++) {
            $rootScope.listOfTimer[i] = 300 * 1000;
            $rootScope.listOfTimerFunction[i] = setInterval(eval($rootScope.listOfFunction[i]), $rootScope.listOfTimer[i]);
        }
        $rootScope.JobsTimer.setInterval($rootScope.saveJobTimer);
        $rootScope.ProtectTimer.setInterval($rootScope.saveProtectTimer);
        $rootScope.RecoverTimer.setInterval($rootScope.saveRecoverTimer);
        $rootScope.maintenance_mode = false;
    };
	
	/* function to hide/show manual refresh control for widget 
	 * and also refresh widget based on time selected by user
	 * Parameters : refresh_rate and Widget Name
    */
        $rootScope.manualRefreshControl  = function(refresh_rate,widgetName){
            var index = $rootScope.listOfWidgetName.indexOf(widgetName);
            var my_id =$rootScope.listOfID[index];
            var dropDownID='#id_' +widgetName.toLowerCase() +'Refresh';
            var my_dropid= "id_"+widgetName.toLowerCase()+'Refresh';
            var dropdown_id= "[id='"+my_dropid+"']";
           
            /*check for refresh rate , if it is zero we need to show manual refresh icon
             else we need to call function for updating Widget data using setInterval method,
             whereas on change of user Preference we need to clear previous timer Function
             */
            $(dropdown_id).val(refresh_rate); // set the value of dropDown with selected value
            if (refresh_rate == 0){
                $rootScope.listOfTimer[index]=refresh_rate;
                clearInterval($rootScope.listOfTimerFunction[index]);
                $(my_id).css("display","inline-block");
            } else {
                $(my_id).css("display","none");
                clearInterval($rootScope.listOfTimerFunction[index]);
                refresh_rate = refresh_rate * 1000;
                $rootScope.listOfTimer[index]=refresh_rate;
                $rootScope.listOfTimerFunction[index] = setInterval(eval($rootScope.listOfFunction[index]), $rootScope.listOfTimer[index]);
            }
        };
	
	/*save User Preference*/
	$rootScope.userPreferenceParentSave = function (widgetName) {
        var index = $rootScope.listOfWidgetName.indexOf(widgetName);
        var dropDownID='#id_' +widgetName.toLowerCase() +'Refresh';
        var my_dropid= "id_"+widgetName.toLowerCase()+'Refresh';
        var dropdown_id= "[id='"+my_dropid+"']";
        var refresh_rate= parseInt($(dropdown_id).val());
        var scope = $($rootScope.listOfController[index]).scope();
        scope.toggleModal();
        $rootScope.manualRefreshControl(refresh_rate,widgetName);
        $scope.$broadcast("update-userPrefrence", widgetName,$rootScope.listOfRefreshKey[index]);
	};

	// available languages
	$scope.languages = [
		{ code: 'en', language: 'English' },
		{ code: 'de', language: 'German' },
		{ code: 'ja', language: 'Japanese' }
	];
	// set default language, overriden by user preference.
	$scope.language = $scope.languages[0];
	// update the language on request, must use async in case a digest is in progress.
	$scope.$on("update-language", function(event, code) {
		for (var i = 0; i < $scope.languages.length; i++) {
			var lang = $scope.languages[i];
			if (lang.code === code) {
				$scope.$evalAsync(function() {
					$scope.language = lang;
				});
				break;
			}
		}
	});

	$scope.Page = Page;

    // lmc - TODO - commenting out until timers cleaned up, as this causes multiple instances.
	//$route.reload();
	
	// Initialize navigation to expanded.
	// lmc - TODO load from user preferences.
	$cookieStore.put('nav', 'nav-expanded');
	var navExpanded = {
			cookieNav: 'nav-expanded',
			arrowNav: 'icon-arrowleft',
			navTitle: 'Collapse Left Navigation'
	};
	var navCollapsed = {
			cookieNav: 'nav-collapsed',
			arrowNav: 'icon-arrowright',
			navTitle: 'Expand Left Navigation'
	};

	// set default view, overridden by user preference.
	$scope.navbar = navExpanded;

	$scope.showSelected = function(selectedItem) {
	    var currentLocation = $location.path().substring(1) || 'dynamic-dashboard';
	    return (currentLocation.indexOf(selectedItem) !== -1) ? 'selected' : '';
	};
	
	/*
	 * Send an event to the rest of the system when a subsystem is selected.
	  */
	$scope.selectNav = function(selectedItem) {
		var e = $.Event('uinav.' + selectedItem);
		$(document).trigger(e);
	};
	
	/*
	 * Collapse or exapand the menu/navigation on the left-hand-side.
	  */
	$scope.toggleNav = function() {
		if ($scope.navbar.cookieNav == 'nav-expanded') {
			$scope.navbar = navCollapsed;
		} else if ($scope.cookieNav = 'nav-collapsed') {
			$scope.navbar = navExpanded;
		}
		$cookieStore.put('nav', $scope.navbar.cookieNav);
	};


    // Login the user, passing in credentials, autologin, or from the cookie store (if remember_me).
    $rootScope.loginUser = function(username, password, auto, remember) {
        var redirectToDash = false;
        var autologin = auto || false;
        var remember_me = remember || false;

        if (username === undefined || password === undefined) {
            if (remember_me) {
                $scope.credentials.username = $cookieStore.get("username");
                $scope.credentials.password = $cookieStore.get("password");
            } else {
                return;
            }
        }  else {
            $scope.credentials.username = username;
            $scope.credentials.password = password;
        }

        var load;
        if (!autologin) {
            $loginButton = $("#login-button");
            load = window.PHD.showLoadingIndicator($loginButton, false);
        }

        $http.post('/api/login', $scope.credentials)
            .success(function(data, status, headers) {

                $rootScope.user.name = $scope.credentials.username;
                //$rootScope.user.loggedIn = true;  // set loggin flag

                // for the CE features we want to hide. We will be loading this using GET /capabilities in the future.
                $rootScope.isCE = true;

                // See if we should remember or clear the credentials.
                if (remember_me) {
                    $cookieStore.put('username', $scope.credentials.username);
                    $cookieStore.put('password', $scope.credentials.password);
                    $cookieStore.put('remember_me', true);
                } else {
                    $cookieStore.remove('username');
                    $cookieStore.remove('password');
                    $cookieStore.remove('remember_me');
                }

                // set the default headers for the $http service.
                $http.defaults.headers.common['AuthToken'] = data.auth_token;

                // get this user's preferences
                getPreferencesFactory.async($scope,$rootScope).then(function(result) {
                    data = result.data.data[0];

                    // update the language to be used based on user preference.
                    var language = data.language;
                    $scope.$broadcast("update-language", language);

                    //For QuickStartWizard Flag
                    $rootScope.user.loggedIn = true;  // set loggin flag

                    // clear the logged in status on the login page
                    if (!autologin) {
                        window.PHD.hideLoadingIndicator(load);
                    }

                    $rootScope.passwd = $scope.credentials.password; // setting current password to root variable for quick start wizard.
                    var flag = data.show_setup_wizard;
                    if(flag === "false"){
                        $rootScope.user.showSetupWizFlag = false;
                        var apppage = angular.element(document.getElementById("app"));
                        var injector = apppage.injector();
                        var route = injector.get('$route');
                        route.reload();
                    }else{
                        $rootScope.user.showSetupWizFlag = true;
                    }
                    //For EULA Flag
                    var eulaFlag = data.show_eula;
                    $rootScope.eulaFlag = eulaFlag;
                    if(eulaFlag === "true"){
                        $rootScope.user.eulaWizardFlag =true;
                    }else{
                        $rootScope.user.eulaWizardFlag =false;
                    }

                    //For Tour Flag
                    var tourFlag = data.show_help_overlay;
                    if(tourFlag === "true") {
                        $rootScope.user.showTour = true;
                    } else {
                        $rootScope.user.showTour = false;
                    }
                    //Set current tour step
                    $rootScope.user.tourStep = 1;

                    if($rootScope.user.showSetupWizFlag){
                        $rootScope.loadDateTimeWizardData();
                    }

                    $rootScope.setIfDefined($scope.Preferences, "backupwidget", "dash_backup_refresh", data.dash_backup_refresh);
                    $rootScope.setIfDefined($scope.Preferences, "alertswidget", "dash_alert_refresh", data.dash_alert_refresh);
                    $rootScope.setIfDefined($scope.Preferences, "replicationwidget", "dash_replication_refresh", data.dash_replication_refresh);
                    $rootScope.setIfDefined($scope.Preferences, "recoverwidget", "dash_restore_refresh", data.dash_restore_refresh);
                    $rootScope.setIfDefined($scope.Preferences, "activejobswidget", "dash_active_job_refresh", data.dash_active_job_refresh);
                    $rootScope.setIfDefined($scope.Preferences, "storagewidget", "dash_storage_refresh", data.dash_storage_refresh);
                    $rootScope.setIfDefined($scope.Preferences, "jobspage", "page_jobs_refresh", data.page_jobs_refresh);

                    refreshRates.dash_backup_refresh = $scope.Preferences.dash_backup_refresh;
                    refreshRates.dash_replication_refresh = $scope.Preferences.dash_replication_refresh;
                    refreshRates.dash_restore_refresh = $scope.Preferences.dash_restore_refresh;
                    refreshRates.dash_active_job_refresh = $scope.Preferences.dash_active_job_refresh;
                    refreshRates.dash_alert_refresh = $scope.Preferences.dash_alert_refresh;
                    refreshRates.dash_storage_refresh = $scope.Preferences.dash_storage_refresh;
                    refreshRates.page_jobs_refresh = $scope.Preferences.page_jobs_refresh;
                    $rootScope.listOfTimer[0] = data.dash_backup_refresh * 1000;
                    $rootScope.listOfTimer[1] = data.dash_active_job_refresh * 1000;
                    $rootScope.listOfTimer[2] = data.dash_storage_refresh * 1000;
                    $rootScope.listOfTimer[3] = data.dash_alert_refresh * 1000;
                    $rootScope.listOfTimer[4] = data.dash_forum_posts_refresh * 1000;
                    $rootScope.listOfTimer[5] = data.dash_daily_feed_refresh * 1000;
                    $rootScope.JobsTimer.setInterval(data.page_jobs_refresh * 1000);
                    $rootScope.ProtectTimer.setInterval(data.page_protect_refresh * 1000);
                    $rootScope.RecoverTimer.setInterval(5000); // lmc - hardcode to 5. data.page_restore_refresh * 1000);

                    if($rootScope.user.showSetupWizFlag == false) {
                        // remember subsystem the user was in last.
                        if ($cookieStore.get('Page') !== undefined) {
                            var Page = $cookieStore.get('Page');
                            location.href = "#/" + Page.toLowerCase();
                        }
                    } else {
                        $scope.disableTimers();
                    }

                    /* Triggering Event once user has logged-in
                     * $rootScope.$broadcast is used as there is no parent-child relation
                     * between login and alert module
                     */
                    $rootScope.$broadcast("loged-in");
                });

                getClientFactory.async($scope,$rootScope).then(function(result) {
                    $scope.tourClients = result.data.data.length;
                    if ($scope.tourClients >= 1) {
                        $rootScope.tourBackupDisabled = false;
                    } else {
                        $rootScope.tourBackupDisabled = true;
                    }
                });

                getStorageFactory.async($scope, $rootScope).then(function(result){
                    var storage = result.data.storage;
                    if (storage.usage == "stateless" && storage.stateless_type === null) {
                        $rootScope.tourHostDisabled = true;
                    } else {
                        $rootScope.tourHostDisabled = false;
                    }
                });

                // Send an event to the jQuery listeners on login.
                var e = $.Event('login');
                e.name = $scope.user.name;
                e.token = data.auth_token;
                e.version = '8.1';
                // Not great practice, but this is timing between Angular and Ajax calls.
                // We must set rootScope first so that global_user will be set in PHD ajax calls.
                $rootScope.user.token = e.token;
                $(document).trigger(e);

            })
            .error(function(data, status, headers) {
                if (!autologin) {
                    // Remove the loading indicator and tap into PHD.throwError function here.
                    window.PHD.hideLoadingIndicator(load);
                    window.PHD.throwError(data);
                }
            })
    };

    angular.element(document).ready(function() {
        var autologin = $cookieStore.get('autologin');
        if (autologin == undefined) {
            $http.get("app/login/autologin.json").success(function (data) {
                autologin = data.autologin;
                $cookieStore.put('autologin', autologin);
                if (autologin) {
                    console.log("************app ready, auto login user********");
                    $rootScope.loginUser('root', 'unitrends1', true, false);
                }
            });
        } else if (autologin) {
            console.log("************app ready, auto login user********");
            $rootScope.loginUser('root', 'unitrends1', true, false);
        } else {
            var remember_me = $cookieStore.get('remember_me');
            if (remember_me) {
                console.log("************app ready, remember_me login user********");
                $rootScope.loginUser(undefined, undefined, false, true);
            }
        }
    });

}]);

app.config(function($routeProvider, $analyticsProvider) {
	$routeProvider.when('/', {
		//templateUrl: "app/dashboard/dashboard.html",
		//controller: 'DashboardCtrl'
        templateUrl: "app/dynamic-dashboard/dynamicDashboard.html",
        controller: 'DynamicDashboardController'
	})
	.when('/protect', {
		templateUrl: "app/protect/protect.html",
		controller: 'ProtectCtrl'
	})
	.when('/recover', {
		templateUrl: "app/recover/recover.html",
		controller: 'RecoverCtrl'
	})
	.when('/jobs', {
		templateUrl: "app/jobs/jobs.html",
		controller: 'JobsCtrl'
	})
	.when('/reports', {
		templateUrl: "app/reports/reports.html",
		controller: 'ReportsCtrl'
	})
	.when('/configure', {
		templateUrl: "app/configure/configure.html",
		controller: 'ConfigCtrl'
	})
	.when('/reports/:id/:days/:sid', {
		templateUrl: "app/reports/reports.html",
		controller: 'ReportsCtrl'
	})
	.otherwise({ redirectTo: '/' });
});

app.factory('getPreferencesFactory', function($http) {
    return {
        async: function($scope, $rootScope) {
            var DEFAULT_REFRESH = 5000;
            $scope.Preferences = {};
            pref = $scope.Preferences;
            pref.dash_backup_refresh = DEFAULT_REFRESH;
            pref.dash_replication_refresh = DEFAULT_REFRESH;
            pref.dash_restore_refresh = DEFAULT_REFRESH;
            pref.dash_active_job_refresh = DEFAULT_REFRESH;
            pref.dash_alert_refresh = DEFAULT_REFRESH;
            pref.dash_storage_refresh = DEFAULT_REFRESH;
            pref.page_protect_refresh = DEFAULT_REFRESH;
            pref.page_restore_refresh = DEFAULT_REFRESH;
            pref.page_jobs_refresh = DEFAULT_REFRESH;

            $url = '/api/preferences/' + $scope.user.name + '/';
            console.log("*************************"+$scope.user.name+"***************"+$url);
            var promise = $http({
                method: 'GET',
                url: $url
            }).success(function(data, status, headers) {
                // per the JSON returned, get the first array element.

            }).error(function(data, status, headers) {

            });
            return promise;
        }
    };
});

app.factory('getClientFactory', function($http) {
    return {
        async: function($scope, $rootScope) {
            $scope.tourClients = 0;
            $url = '/api/clients/';
            console.log("*****" + $url + "*****");
            var promise = $http({
                method: 'GET',
                url: $url
            }).success(function (data, status, headers) {

            }).error(function (data, status, headers) {

            });
            return promise;
        }
    };
});

app.factory('getStorageFactory', function($http) {
    return {
        async: function($scope, $rootScope) {
            $url = '/api/storage/1/?sid=1';
            console.log("*****" + $url + "*****");
            var promise = $http({
                method: 'GET',
                url: $url
            }).success(function (data, status, headers) {

            }).error(function (data, status, headers) {

            });
            return promise;
        }
    };
});

app.directive('ngElementReady', [function() {
	return {
		priority: -1000,
		restrict: "A",
		link: function(scope, element, attributes) {
			scope.$eval(attributes.ngElementReady);
		}
	}
}]);
