(function($, PHD, window, undefined) {

    var $form = $("#form-add-appliance");
    var applianceForm,
        FQDN_REGEXP = /^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])$/i;

    function initForm() {
        // Copy system name to host.
        $("#id_name").focusout(function() {
            console.log("in function, name = " + $("#id_name").val());
            $("#id_host").val($("#id_name").val());
            console.log("in function, host = " + $("#id_host").val());
        });

        $form.find(".definition").popover({
            appendTo: $form
        });

        applianceForm = PHD.FormController($form, {
            serialize: function($form) {
                return $form.find("input").serialize();
            }
        });

        applianceForm = PHD.FormController($form, {})
            .validate({
                rules: {
                    ip: {
                        required: true,
                        pattern: FQDN_REGEXP
                    },
                    name: {
                        required: true
                    }
                },
                messages: {
                    ip: {
                        required: gettext("IP Address is required"),
                        pattern: gettext("IP Address is not a valid address")
                    },
                    name: {
                        required: gettext("Name is required")
                    }
                }
            })
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                var start = new Date().getTime();
                  for (var i = 0; i < 1e7; i++) {
                    if ((new Date().getTime() - start) > 1000){
                      break;
                    }
                }

                PHD.currentDialog.wizard("close");
                if(typeof data.result !== 'undefined' && data.result[0].code != AJAX_RESULT_SUCCESS) {
                    PHD.throwNotice(data);
                }
            });
        
            applianceForm.submit = function() {
                var self = this;

                if (selectedAppliance.local) {
                    this.$buttons.blur().disable();

                    var sid = (PHD.appliance_sid === null) ? "" : "?sid=" + PHD.appliance_sid;
                    var url = "/api/hostname/" + sid;

                    var hostObj = {};

                    hostObj.name = $('#id_name').val(); 
                    hostObj.long_name = $('#id_longname').val();

                    hostObj = JSON.stringify(hostObj);

                    PHD.Ajax
                        .put(url, hostObj)
                        .done(function(data) {
                            //self.$form.trigger("formsubmit", [data, self.$form, self]);
                        })
                        .always(function() {
                            self.$buttons.enable();
                        });
                } else {
                    self.$form.trigger("formcancel");
                }
                return this;
            }
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        PHD.currentDialog.one("wizardfocus", function() {
            initForm();
        });
    });

})(jQuery, window.PHD || (window.PHD = {}), window);