(function($, PHD, window, undefined) {


    var   tabs = [],
        initialTab = 0,
        currentTabIndex = 0,
        slugs = ['general', 'email','datetime','encryption'];


    var $form = $("#form-add-appliance");

    var applianceForm,
        FQDN_REGEXP = /^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])$/i;

    function initForm() {
        $form.find(".definition").popover({
            appendTo: $form
        });

        applianceForm = PHD.FormController($form, {
            serialize: function($form) {
                return $form.find("input").serialize();
            }
        });

        if (selectedAppliance.local) {
            $(".managed-system-username").hide();
            $(".managed-system-password").hide();
        }

        applianceForm
            .validate({
                rules: {
                    ip: {
                        required: true,
                        pattern: FQDN_REGEXP
                    }
                },
                messages: {
                    ip: {
                        required: gettext("IP Address is required"),
                        pattern: gettext("IP Address is not a valid address")
                    }
                }
            })
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                //$(document).trigger("vbaadd");
                PHD.currentDialog.wizard("close");
                if(typeof data.result !== 'undefined' && data.result[0].code != AJAX_RESULT_SUCCESS) {
                    PHD.throwNotice(data);
                }
            });

       applianceForm.submit = function() {
            var self = this;
                        
            if (selectedAppliance.local && submitData.name != selectedAppliance.name) {
                //var load = PHD.showLoadingIndicator("body", true, "Saving Appliance Changes...");
                this.$buttons.blur().disable();
                
                var sid1 = (PHD.appliance_sid === null) ? "" : "?sid=" + PHD.appliance_sid;
                var sid =  "?sid=" + selectedAppliance.id;
                var url = "/api/hostname/" + sid;

                var hostObj = {};
                
                hostObj.name = $('#id_name').val(); 
                hostObj.long_name = $('#id_longname').val();
                
                hostObj = JSON.stringify(hostObj);
                console.log("hostname set now with obj ");
                console.log(hostObj);
                
                PHD.Ajax
                    .put(url, hostObj)
                    .done(function(data) {
                        self.$form.trigger("formsubmit", [data, self.$form, self]);
                    })
                    .always(function() {
                        self.$buttons.enable();
                    });
            } else {
                self.$form.trigger("formcancel");
            }

            return this;
        }
    }
    var EditTab = function (index, panel, slug) {
        this.index = index;
        this.$panel = panel;
        this.$table = this.$panel.find(".active-table");
        this.$buttons = this.$panel.find(".button-bar");
        this.$form = (index == 0) ? $("#form-add-appliance") : ((index == 1) ? $("#email-edit-form") : $("#encryption-edit-form"));
    };

    EditTab.prototype.init = function () {
        var self = this;
        return this;
    };


    EditTab.prototype.activate = function () {
        this.isActive = true;
        //this.update(false, true);
        console.log("Current Tab Index = " + currentTabIndex);
        if (currentTabIndex == 0) {
            var respHostname = PHD.Ajax.get("/api/hostname/?sid=" + PHD.appliance_sid + "/")
            var respSystems = PHD.Ajax.get("/api/systems/" + PHD.appliance_sid + "/")
            
            respSystems.done(function (data) {
                if (data.appliance !== undefined && data.appliance.length > 0) {
                    for (var i = 0; i < data.appliance.length; i++) {
                        obj = data.appliance[i];
                        if (obj.id == PHD.appliance_sid) {
                            $("#id_name").val(obj.name);
                            $("#id_ip").val(obj.host);
                            $("#edit_object_id").text(obj.id);
                            if(obj.local){
                                $('#id_name').removeAttr('disabled');
                                $('#id_longname').removeAttr('disabled');
                            }else{
                                $('#id_name').attr('disabled','disabled');
                                $('#id_longname').attr('disabled','disabled');
                            }
                            break;
                        }
                    }
                }
            })
            
            respHostname.done(function (data){
                if (data !== undefined) {
                    obj = data.data;
                    if (obj.system_id == PHD.appliance_sid) {
                        $("#id_longname").val(obj.long_name);
                    }
                }
            })
            
        } else if (currentTabIndex == 1) {
            var resp = PHD.Ajax.get("/api/mail-config/?sid=" + PHD.appliance_sid);

            resp.done(function (data) {
                data = data.data;
                if (data.smtp !== undefined) {
                    $("#id_email_host").val(data.smtp);
                    $("#id_send_email").prop('checked', true);
                    $("#id_email_host").prop('disabled', false);
                      
                }
                if (data.authinfo !== undefined) {
                    $("#id_server_requires_credentials").prop('checked', data.authinfo);

                    if (data.authinfo == true) {
                        $("#id_email_host_user").prop('disabled', false);
                        $("#id_email_host_password").prop('disabled', false);
                        $("#id_email_host_user").val(data.user);
                    }
                }
                var mail = new Array();
                if (data.schedule !== undefined && data.schedule !== "") {
                    var scheduleRecipients = data.schedule.split(" ");
                    angular.forEach(scheduleRecipients, function(scheduleRecipient, key) {
                        var fetchedRecipient = null;
                        for(var i=0; i<mail.length; i++){
                            if(mail[i].email===scheduleRecipient){
                                fetchedRecipient = mail[i];
                                break;
                            }
                        }
                        if(fetchedRecipient !=null){
                            fetchedRecipient.jobs =true;
                        }else{
                            fetchedRecipient = {
                                email:scheduleRecipient,
                                system:false,
                                jobs:true,
                                failures:false
                            };
                            
                            mail.push(fetchedRecipient);
                        }
                     });
                }
                if (data.bp !== undefined && data.bp !== "") {
                    var bpRecipients = data.bp.split(" ");
                    angular.forEach(bpRecipients, function(bpRecipient, key) {
                        var fetchedRecipient = null;
                        for(var i=0; i<mail.length; i++){
                            if(mail[i].email===bpRecipient){
                                fetchedRecipient = mail[i];
                                break;
                            }
                        }
                        if(fetchedRecipient !=null){
                            fetchedRecipient.system =true;
                        }else{
                            fetchedRecipient = {
                                email:bpRecipient,
                                system:true,
                                jobs:false,
                                failures:false
                            };
                            mail.push(fetchedRecipient);
                        }
                     });   
                }
                if (data.failure !== undefined && data.failure !== "") {
                    var failureRecipients = data.failure.split(" ");
                    angular.forEach(failureRecipients, function(failureRecipient, key) {
                        var fetchedRecipient = null;
                        for(var i=0; i<mail.length; i++){
                            if(mail[i].email===failureRecipient){
                                fetchedRecipient = mail[i];
                                break;
                            }
                        }
                        if(fetchedRecipient !=null){
                            fetchedRecipient.failures =true;
                        }else{
                            fetchedRecipient = {
                                email:failureRecipient,
                                system:false,
                                jobs:false,
                                failures:true
                            };
                            mail.push(fetchedRecipient);
                        }
                     });
                }
                console.log("Mail object after convert from backend----"+ JSON.stringify(mail));
                for(var i =0; i<mail.length;i++){

                    var id = "[name='mail["+i+"].email']";
                    $(id).val(mail[i].email);
                    $("[name='mail["+i+"].system']").prop('checked', mail[i].system);
                    $("[name='mail["+i+"].jobs']").prop('checked', mail[i].jobs);
                    $("[name='mail["+i+"].failures']").prop('checked', mail[i].failures);

                    $(".btn-add-recipient").click();   
                    if(i !== mail.length-1){
                        $(".btn-add-recipient").click();   
                    }
                }

            })
        }else if (currentTabIndex == 2) {
            var resp = PHD.Ajax.get("/api/date-time/?sid=" + PHD.appliance_sid);
            
            var timezoneresponse = PHD.Ajax.get("/api/date-time/timezones/");
            
            /* Set timezone combo box data. */
            timezoneresponse.done(function (data){
                $.each(data.timezone, function(id,timezone){
                    $("#appliance_timezone").append('<option id="' + id + '" value="' + timezone + '">' + timezone + '</option>');
                })
            })
            
            /* Set appliance date time data */
            resp.done(function (data) {
                if (data !== undefined) {
                    var appdate = data.month + "/" + data.day + "/" + data.year;
                    var hour = timeFormat(data.hour.toString());
                    var min = timeFormat(data.minute.toString());
                    var sec = timeFormat(data.second.toString());
                    var apptime = hour + ":" + min + ":" + sec;
                    
                    $("#appliance_date").val(appdate);
                    $("#appliance_time").val(apptime);
                    $("#appliance_timezone").val(data.tz);
                    if((data.ntp !== undefined) && (data.ntp.servers.length > 0)){
                        $("#appliance_ntpserver").val(data.ntp.servers[data.ntp.servers.length -1]);
                        var options = '';
                        for(var i = 0; i < data.ntp.servers.length; i++){
                            options += '<option value="'+data.ntp.servers[i]+'" />';
                        }
                        $('#ntpServer').empty(); 
                        $('#ntpServer').append(options);
                    }

                    if(data.ntp.enabled){
                        $('#app_ntpserver_radioselection').prop('checked','true');
                        document.getElementById("appliance_ntpserver").disabled = false;
                        $('#appliance_date').attr('disabled','disabled');
                        $('#appliance_time').attr('disabled','disabled');
                        $('#appliance_timezone').attr('disabled','disabled');
                    }else{
                        $('#app_datetime_radioselection').prop('checked','true');
                        $('#appliance_ntpserver').attr('disabled','disabled');
                        $('#appliance_date').removeAttr('disabled');
                        $('#appliance_time').removeAttr('disabled');
                        $('#appliance_timezone').removeAttr('disabled');
                    }
                }
            })
        } else if (currentTabIndex == 3) {
            var resp = PHD.Ajax.get("/api/encryption/?sid=" + PHD.appliance_sid);

            resp.done(function (data) {
                data = data.data[0];
                console.log("data = " + JSON.stringify(data));
                if (data.has_passphrase == true) {
                    console.log("Has Passphrase");
                    if(data.state != "off") {
                        $('#id_enable_encryption').prop('checked', true);
                        $('#id_current_passphrase').prop('disabled', false);
                        $("#id_change_passphrase").prop('disabled', false);
                    }
                    $("#encryption_passphrase_not_set").hide();
                    $("#encryption_passphrase_set").show();
                } else {
                    console.log("No Passphrase");
                    $("#encryption_passphrase_not_set").show();
                    $("#encryption_passphrase_set").hide();
                }
            })
        } else {

        }
    };

    EditTab.prototype.deactivate = function () {
        this.isActive = false;
       // JobsTimer.stop();
    };

    function timeFormat(time){
        if(time.charAt(1) == ''){
            time = "0"+time;
            return time;
        }
        return time;
    }

    function handleTabChange() {
        $(document).trigger("tabchange", ["appliance" + slugs[currentTabIndex]]);
    }

    function initTabs() {
        $(".ui-tabs-panel").each(function (index) {
            tabs[index] = new EditTab(index, $(this), slugs[index]).init();
        });

        tabs[currentTabIndex].activate();
    }

    // Initialize the tabs
    $('.tabs-wrapper').tabs({
        active: initialTab,
        create: function (event, ui) {
            currentTabIndex = ui.tab.index();
            initTabs();
            handleTabChange();
        },
        activate: function (event, ui) {
            currentTabIndex = ui.newTab.index();
            $.cookie("initial_tab_jobs", currentTabIndex, {expires: 365, path: '/'});
            tabs[ui.oldTab.index()].deactivate();
            tabs[currentTabIndex].activate();
            handleTabChange();
        }
    });

    

    /*
    *   DOM Ready Function
    */
    $(function() {
        PHD.currentDialog.one("wizardfocus", function() {
            initForm();
        });
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
