angular.module('replicationThrottleScheduleModule', ['ngDialog',"checklist-model"])
.controller('replicationThrottleController', ['$scope', '$rootScope', '$http','ngDialog', function($scope, $rootScope, $http,ngDialog) {
     $scope.processScheduleModel = function (dataArray){
        for (var i =0 ; i <dataArray.length ; i ++){
            dataArray[i].show = false;
           return  dataArray;
        }
     }
     $scope.init = function () {
     $scope.throttleSchedulesList =[];
     $scope.item={};  
     $scope.connectionTypes=[];
     $scope.connectionType={};
     $scope.showSchedule=[];
     $scope.throttleLabel="Throttle";
     $scope.connectionTypeLabel="Connection Type";
     $scope.daysLabel="Days";
     $scope.typesLabel="Type";
     $scope.percentOptions = [
     { id : 0, name: "--" },  
     { id : 10, name: "10%" },
     { id : 20, name: "20%" },
     { id : 30, name: "30%" },
     { id : 40, name: "40%" },
     { id : 50, name: "50%" },
     { id : 60, name: "60%" },
     { id : 70, name: "70%" },
     { id : 80, name: "80%" },
     { id : 90, name: "90%" },
     { id : 100,name: "100%"}
     ];
     $scope.timeOptions = [
     { id : 0,  name: "12AM" },  
     { id : 1,  name: "1AM" },
     { id : 2,  name: "2AM" },
     { id : 3,  name: "3AM" },
     { id : 4,  name: "4AM" },
     { id : 5,  name: "5AM" },
     { id : 6,  name: "6AM" },
     { id : 7,  name: "7AM" },
     { id : 8,  name: "8AM" },
     { id : 9,  name: "9AM" },
     { id : 10, name: "10AM"},
     { id : 11, name: "11AM" },
     { id : 12, name: "12PM" },
     { id : 13, name: "1PM" },
     { id : 14, name: "2PM" },
     { id : 15, name: "3PM" },
     { id : 16, name: "4PM" },
     { id : 17, name: "5PM" },
     { id : 18, name: "6PM" },
     { id : 19, name: "7PM" },
     { id : 20, name: "8PM" },
     { id : 21, name: "9PM" },
     { id : 22, name: "10PM" },
     { id : 23, name: "11PM" }
     ];
     $scope.typeOptions=[
     { id : 0,  name: "Hours" },  
     { id : 1,  name: "All Day" }
     ]
     $scope.scheduleDays=[
     {'name':'Monday',   'value' : 1},
     {'name':'Tuesday',  'value' : 2},
     {'name':'Wednesday','value' : 3},
     {'name':'Thursday', 'value' : 4},
     {'name':'Friday',   'value' : 5},
     {'name':'Saturday', 'value' : 6},
     {'name':'Sunday',   'value' : 0}
     ];     
     };
     $http({
         method: 'GET',
         url: 'app/configure/appliances/replication_speed.json',
         params:$rootScope.replicationApplianceId
              
     }).success(function(resultdata, status, headers){
         var speedArray=[];
           for (var i = 0 ; i < resultdata.data.length ; i++){
               speedArray[i]=resultdata.data[i].target1.speed;
           }
           $scope.connectionTypes = speedArray;
           $http({
                 method: 'GET',
                 url: 'app/configure/appliances/replicationThrottle_RESTAPI.json',
                 params:$rootScope.replicationApplianceId

            }).success(function(data, status, headers) {
             var dataArray = data.throttle;
             $scope.throttleSchedulesList =$scope.processScheduleModel(dataArray);
             $scope.connectionType=$scope.connectionTypes[0];
          });
     });
    $scope.updateTypeModel =function(index){
       if( $scope.throttleSchedulesList[index].type ==1){
           $scope.throttleSchedulesList[index].starttime=0
           $scope.throttleSchedulesList[index].endtime=0;
       }
    }
    $scope.addSchedule =function(){
        var dataObjArray=[{
             "percentage":10,
             "days" :[0],
             "type":"Hours",
             "endtime":12,
             "starttime":1
             
         }]
         var dataObj=  $scope.processScheduleModel(dataObjArray);
         $scope.throttleSchedulesList.push(dataObj[0]);
         $scope.showHideSchedule( $scope.throttleSchedulesList.length-1,"showSchedule"); 
    }
    $scope.removeSchedule = function(index){
        $scope.throttleSchedulesList.splice(index,1);
        $scope.throttleSchedulesList = $scope.throttleSchedulesList;
    }
    $scope.showHideSchedule = function(index,flag){
         if (typeof(flag) != "undefined"){
             for (var i =0 ; i < $scope.throttleSchedulesList.length ; i++){
                       $scope.throttleSchedulesList[i].show = false;   
             }
             $scope.throttleSchedulesList[index].show = true;
         } else {
             if ($scope.throttleSchedulesList[index].show){
                $scope.throttleSchedulesList[index].show = !$scope.throttleSchedulesList[index].show;
              } else {
                for (var i =0 ; i < $scope.throttleSchedulesList.length ; i++){
                       $scope.throttleSchedulesList[i].show = false;   
                }
                $scope.throttleSchedulesList[index].show = true;
              }
         }
    }
    $scope.validateform = function(){
        $scope.validForm = true;
        $scope.iteration=0;
        for (var i =0 ;  i < $scope.throttleSchedulesList.length ; i++){
              if ($scope.throttleSchedulesList[i].type== 0 && $scope.throttleSchedulesList[i].starttime >= $scope.throttleSchedulesList[i].endtime){
                  $scope.validForm =false;
                  console.log("error1");
                  $scope.iteration=i;
                  break;
              } else if ( $scope.throttleSchedulesList[i].days.length ==0  ){
                  $scope.validForm =false;
                  $scope.iteration=i;
                  console.log("error2" +$scope.iteration );
                  break;
              } else if ($scope.throttleSchedulesList[i].percentage == 0){
                  $scope.validForm =false;
                  $scope.iteration=i;
                  console.log("error2" +$scope.iteration );
                  break;
              }
        }
    }
    $scope.saveThrottleSchedule = function(){
      $scope.validateform();
      if ($scope.validForm ){
        console.log($scope.throttleSchedulesList);
        ngDialog.close('replication-bandwidth-dailog');
      } else{
        $scope.showHideSchedule($scope.iteration,"showSchedule");  
      }
    }           
 }]);