(function($, PHD, window, undefined) {

    var $form = $("#creds-edit-form"),
        credentialsForm;

    function initForm() {

        credentialsForm = PHD.FormController($form, {})
            .validate({
                rules: {
                    password: {
                        minlength: 1,
                        maxlength: MAX_PASSWORD_LENGTH
                    },
                    confirm_password: {
                        equalTo: "#id_password"
                    }
                },
                messages: {
                    password: {
                        maxlength: gettext("Password must not be more than 48 characters")
                    },
                    confirm_password: {
                        equalTo: gettext("Your password must be the same in both fields")
                    }
                }
            })


            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                if(data.result[0].code === AJAX_RESULT_SUCCESS) {
                    var return_data = {
                        "set_or_not_set": $form.find("[name=cifs_new_password]").val() ? gettext("Set") : gettext("Not Set")
                    };
                    //$(document).trigger("cifscredsformsave", return_data);
                    PHD.currentDialog.wizard("close");
                }
            });
    }
    /*
     *   DOM Ready Function
     */
    $(function() {
        PHD.currentDialog.one("wizardfocus", function() {
            initForm();
        });

    });

})(jQuery, window.PHD || (window.PHD = {}), window);
