(function($, PHD, window, undefined) {
    
    var $form = $("#encryption-edit-form"),
        EncryptionForm,
        $enabled = $("#id_enable_encryption"),
        $passphrase = $("#id_encryption_passphrase, #id_confirm_passphrase"),
        $newPassphrase = $("#id_encryption_passphrase_change, #id_confirm_passphrase_change"),
        $currentPassphrase = $('#id_current_passphrase'),
        $changePassphrase = $('#id_change_passphrase'),
        EncryptionTable;
    var scope = $("[ng-controller=GlobalCtrl]").scope();


    function handleEncryption() {
       //var val = parseInt($encryption.val(), 10);
       // $port.val(ports[val]);
    }

    function handlePassphrase() {
        $passphrase.prop("disabled", !$enabled.prop("checked"));
        $changePassphrase.prop("disabled", !$enabled.prop("checked"));
        if($changePassphrase.is("disabled")) {
            $changePassphrase.prop("checked", false);
        }
        $currentPassphrase.prop("disabled", !$enabled.prop("checked"));
        $newPassphrase.prop("disabled", !$changePassphrase.prop("checked"));

    }


    function initForm() {

        $enabled.on("change", handlePassphrase).trigger("change");
        $currentPassphrase.on("change", handlePassphrase).trigger("change");
        $changePassphrase.on("change", handlePassphrase).trigger("change");

        /*$(".btn-change-passphrase").on("click", function(event) {
            event.preventDefault();
            $("#encryption_passphrase_not_set").show();
            $("#encryption_passphrase_change").hide();
        });*/

        $(".btn-save-master-key").on("click", function(event) {
            event.preventDefault();
            var resp = PHD.Ajax.post("/api/encryption/keys");

            var message = "The master key file has been saved successfully ";
            message += scope.isCE ? " to the <i>read_only</i> share on the appliance." : "to CD.";
            resp.done(function (data) {
                PHD.throwNotice({"result": [{"message": message }]}, {
                    width: 350,
                    height: 150
                });
            });
        });

        EncryptionForm = PHD.FormController($form, {})
            .validate({
                errorLabelContainer: ".encryption-dialog-error-list",
                errorContainer: ".encryption-dialog-errors",
                showErrors: function(errorMap, errorList) {
                    $(".encryption-dialog-errors").find(".summary")
                        .html(gettext("Correct the following errors:"));
                    this.defaultShowErrors();
                },
                rules: {
                    //for new
                    encryption_passphrase: {
                        required: function() { return $("#id_enable_encryption:checked") && $("#id_encryption_passphrase_not_set:visible"); }
                    },
                    encryption_confirm_passphrase: {
                        required: function() { return $("#id_enable_encryption:checked") && $("#id_encryption_passphrase_not_set:visible"); },
                        equalTo: "#id_encryption_passphrase"
                    },
                    //for change
                    current_passphrase: {
                        required: function() { return $("#id_enable_encryption:checked") && $("#id_encryption_passphrase_set:visible"); }
                    },
                    encryption_passphrase_change: {
                        required: function() { return $("#id_enable_encryption:checked") && $("#id_encryption_passphrase_set:visible") && $('#id_change_passphrase:checked'); }
                    },
                    encryption_confirm_passphrase_change: {
                        required: function() { return $("#id_enable_encryption:checked") && $("#id_encryption_passphrase_set:visible") && $('#id_change_passphrase:checked'); },
                        equalTo: "#id_encryption_passphrase_change"
                    }
                },
                messages: {
                    encryption_passphrase: {
                        required: gettext("Please enter your passphrase")
                    },
                    encryption_confirm_passphrase: {
                        required: gettext("Please re-enter your passphrase"),
                        equalTo: gettext("Your passphrase must be the same in both fields")
                    },
                    current_passphrase: {
                        required: gettext("Please enter your current passphrase")
                    },
                    encryption_passphrase_change: {
                        required: gettext("Please enter your new passphrase")
                    },
                    encryption_confirm_passphrase_change: {
                        required: gettext("Please re-enter your new passphrase"),
                        equalTo: gettext("Your new passphrase must be the same in both fields")
                    }
                }
            })
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                PHD.currentDialog.wizard("close");
            });

            EncryptionForm.submit = function() {
                var self = this;

                if ($form.valid()) {
                    this.$buttons.blur().disable();

                    var encryptionData = {};
                    var type = "";
                    var post = false;
                    /* There are four cases for encryption
                        1. Passphrase has never been set (turning encryption on and setting passphrase)
                        2. Changing Passphrase
                        3. Turning encryption on (if turned off with passphrase set)
                        4. Turning encryption off
                     */
                    console.log($('#encryption_passphrase_not_set').is(':visible'));
                    if($('#id_enable_encryption').prop("checked") == true && $('#encryption_passphrase_not_set').is(':visible') == true) {
                        encryptionData.new_passphrase = $('#id_encryption_passphrase').val();
                        type = "passphrase/";
                        post = true;
                    } else if ($('#id_enable_encryption').prop("checked") == true && $('#id_change_passphrase').prop("checked") == true) {
                        encryptionData.current_passphrase = $('#id_current_passphrase').val();
                        encryptionData.new_passphrase = $('#id_encryption_passphrase_change').val();
                        type = "passphrase/";
                    } else if ($('#id_enable_encryption').prop("checked") == true) {
                        encryptionData.passphrase = $('#id_current_passphrase').val();
                        type = "persistent/";
                    } else {
                        type = "disable/";
                    }

                    encryptionData = JSON.stringify(encryptionData);

                    var url = "/api/encryption/";
                    var sid = (PHD.appliance_sid === null) ? "" : "?sid=" + PHD.appliance_sid;
                    url += type + sid;
                    var load = PHD.showLoadingIndicator($form);
                    if(post) {
                        console.log("POSTing encryption data");
                        PHD.Ajax
                            .post(url, encryptionData, load)
                            .done(function(data) {
                                var url = "/api/encryption/persistent/";
                                var sid = (PHD.appliance_sid === null) ? "" : "?sid=" + PHD.appliance_sid;
                                url += sid;
                                var persistData = {};
                                persistData.passphrase = $('#id_encryption_passphrase').val();
                                persistData = JSON.stringify(persistData);
                                load = PHD.showLoadingIndicator($form);
                                PHD.Ajax
                                    .put(url, persistData, load)
                                    .done(function(data) {
                                        self.$form.trigger("formsubmit", [data, self.$form, self]);
                                    })
                                    .always(function() {
                                        self.$buttons.enable();
                                    });
                            })
                            .always(function() {
                                self.$buttons.enable();
                            });

                    } else {
                        console.log("PUTing encryption data");
                        PHD.Ajax
                            .put(url, encryptionData, load)
                            .done(function(data) {
                                self.$form.trigger("formsubmit", [data, self.$form, self]);
                            })
                            .always(function() {
                                self.$buttons.enable();
                            });
                    }

                    return this;
                }
            };
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        /*PHD.currentDialog.one("wizardfocus", function() {
            initForm();
        }); */
        //console.log("---->initialize encryption dialog");
        initForm();
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
