(function($, PHD, window, undefined) {
    var $form = $("#email-edit-form"),
        EmailForm,
        $required = $("#id_server_requires_credentials"),
        $credentials = $("#id_email_host_user, #id_email_host_password"),
        $btnTest = $(".btn-test-email"),
        $emailTest = $(".test-email"),
        //$encryption = $("#id_email_encryption"),
        //$port = $("#id_email_port"),
        $btnTestCancel = $emailTest.find(".btn-test-email-cancel"),
        $btnTestSend = $emailTest.find(".btn-test-email-send"),
        EmailTable;
        // ports = {};

    //ports[EMAIL_ENCRYPTION_NONE] = 25;
    //ports[EMAIL_ENCRYPTION_TLS] = 587;
    //ports[EMAIL_ENCRYPTION_SSL] = 465;

    function handleCreds() {
        $credentials.prop("disabled", !$required.prop("checked"));
    }

    function handleTest() {
        $btnTest.hide({
            effect: "fade", 
            duration: "fast", 
            complete: function() {
                $emailTest.show({effect: "slide", direction: "left", duration: "fast"});
            }
        });
    }

    function handleCancel() {
        $emailTest.hide({
            effect: "slide", 
            direction: "left",
            duration: "fast",
            complete: function() {
                $btnTest.show({effect: "fade", duration: "fast"});
            }
        });
    }

    function handleSend() {

        var url = "/api/mail-config/";
        var sid = (PHD.appliance_sid === null) ? "" : "?sid=" + PHD.appliance_sid;
        url += sid;

        if ($form.valid()) {
            var submitData = form2js($form.attr("id"), '.', false);
            var backendData = {};

            if(submitData.smtp != undefined && submitData.smtp != null && submitData.smtp != ''){
                backendData.smtp = submitData.smtp;
            }
            if(submitData.test_mail != undefined && submitData.test_mail != null && submitData.test_mail != ''){
                backendData.test_mail = submitData.test_mail;
            }
            if(submitData.authinfo != undefined && submitData.authinfo != null && submitData.authinfo) {
                backendData.authinfo = true;
                backendData.user = submitData.user;
                backendData.password = submitData.password;
            }
            backendData.schedule = "";
            backendData.bp = "";
            backendData.failure = "";
            backendData = JSON.stringify(backendData);

            console.log("submitData is " + backendData);

            var resp = PHD.Ajax.put(url, backendData);

            resp.done(function(data, textStatus, jqXHR) {
                //PHD.alert("Test Email Successfully Sent.");
                handleCancel();
            });
        }
    }

    /*function handleEncryption() {
        var val = parseInt($encryption.val(), 10);
        $port.val(ports[val]);
    }

    function handlePort() {
        if($port.val() === "") {
            handleEncryption();
        }
    }*/

    function initForm() {

        $required.on("change", handleCreds).trigger("change");

        $btnTest.on("click", handleTest);
        $btnTestCancel.on("click", handleCancel);
        $btnTestSend.on("click", handleSend);
        //$encryption.on("change", handleEncryption);
        //$port.on("focus", handlePort);

        EmailForm = PHD.FormController($form, {})
            .validate({
                errorLabelContainer: ".email-dialog-error-list",
                errorContainer: ".email-dialog-errors",
                showErrors: function(errorMap, errorList) {
                    $(".email-dialog-errors").find(".summary")
                        .html(gettext("Correct the following errors:"));
                    this.defaultShowErrors();
                },
                rules: {
                    smtp: {
                        required: true
                    },
                    
                    email_host: {
                        required: true
                    },
                    test_email: {
                        required: true,
                        email: true
                    },
                    email_host_user: {
                        required: "#id_server_requires_credentials:checked"
                    },
                    email_host_password: {
                        required: "#id_server_requires_credentials:checked"
                    }
                },
                messages: {
                    smtp: {
                        required: gettext("SMTP server is required")
                    },
                    email_host: {
                        required: gettext("SMTP server host is required")
                    },
                    test_email: {
                        required: gettext("Please enter test email recipient's email address"),
                        email: gettext("Please enter a valid email address")
                    },
                    email_host_user: {
                        required: gettext("Please enter your username")
                    },
                    email_host_password: {
                        required: gettext("Please enter your password")
                    }
                }
            })
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                console.log("Form submit: Data = " + JSON.stringify(data));
                PHD.currentDialog.wizard("close");
                /*if(data.result[0].code === AJAX_RESULT_SUCCESS) {
                    var formdata = {
                        "email_host": $form.find("[name=email_host]").val(),
                        "email_port": $form.find("[name=email_port]").val(),
                        "email_encryption": $form.find("[name=email_encryption] :selected").text(),
                        "send_email": $form.find("[name=send_email]").prop("checked")
                    };
                    //$(document).trigger("emailformsave", [formdata]);

                    PHD.currentDialog.wizard("close");
                } else if(data.result[0].code === AJAX_RESULT_ERROR) {
                    PHD.throwError(data);
                }*/
            });

            EmailTable = PHD.EmailTable($form);
            EmailTable.$table.scrollTable({"height": 100, "resize": false});
            EmailTable.$table.on("emailtabledelete", function() {
            EmailTable.$table.scrollTable({"height": 100, "resize": false});
        });

        EmailForm.submit = function() {

            var self = this,
                load = PHD.showLoadingIndicator("body", true, "Saving Mail Configuration...");

            this.$buttons.blur().disable();

            var submitData = form2js($form.attr("id"), '.', false);
            console.log("in submit, submitData = " + JSON.stringify(submitData));
            var backendData = {};

            if(submitData.smtp != undefined && submitData.smtp != null && submitData.smtp != ''){
                backendData.smtp = submitData.smtp;
            }
            if(submitData.test_mail != undefined && submitData.test_mail != null && submitData.test_mail != ''){
                backendData.test_mail = submitData.test_mail;
            }
            if(submitData.authinfo != undefined && submitData.authinfo != null && submitData.authinfo) {
                backendData.authinfo = true;
                backendData.user = submitData.user;
                backendData.password = submitData.password;
            }
            backendData.schedule = "";
            backendData.bp = "";
            backendData.failure = "";
            var i;
            if (submitData.mail !== undefined) {
                for (i = 0; i < submitData.mail.length; i++){
                    var obj = submitData.mail[i];
                    if (obj.email != '') {
                        if (obj.jobs === true){
                            backendData.schedule = (backendData.schedule === "") ? obj.email : (backendData.schedule + " " + obj.email);
                        }
                        if (obj.system === true){
                            backendData.bp = (backendData.bp === "") ? obj.email : (backendData.bp + " " + obj.email);
                        }
                        if (obj.failures === true){
                            backendData.failure = (backendData.failure === "") ? obj.email : (backendData.failure + " " + obj.email);
                        }
                    }
                }
            }
            backendData = JSON.stringify(backendData);
            console.log("in submit, backendData = " + backendData);

            var url = "/api/mail-config/";
            var sid = (PHD.appliance_sid === null) ? "" : "?sid=" + PHD.appliance_sid;
            url += sid;

            PHD.Ajax
                .put(url, backendData, load)
                .done(function(data) {
                    self.$form.trigger("formsubmit", [data, self.$form, self]);
                })
                .always(function() {
                    self.$buttons.enable();
                    PHD.hideLoadingIndicator(load);
                });

            return this;
        }
    }

    /* function initValues() {
        var sid = 1; // lmc - TODO
        console.log("appliance id is " + PHD.appliance_sid);
        var resp = PHD.Ajax.get("/api/mail-config/?sid=" + PHD.appliance_sid);

        resp.done(function (data) {
            data = data.data;
            if (data.smtp !== undefined) {
                $("#id_email_host").val(data.smtp);
            }
            if (data.authinfo !== undefined) {
                $("#id_server_requires_credentials").prop('checked', data.authinfo);
            }
            // add email recipients if set
        })
    }
    */

    /*
    *   DOM Ready Function
    */
    $(function() {
        initForm();
        /*PHD.currentDialog.one("wizardfocus", function() {
            initForm();
            //initValues();
            //handlePort();
        });*/

    });

})(jQuery, window.PHD || (window.PHD = {}), window);
function onEnableReportingChange(isChecked){
     
     if($(isChecked).is(':checked')) {
           $("#id_email_host").prop('disabled', $("#id_email_host").prop("checked"));
      } else {
          $("#id_email_host").prop('disabled', !$("#id_email_host").prop("checked"));
      }
        
}