angular.module('configAssets', ['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])

    .controller('AssetsCtrl', ['$scope', '$rootScope', '$http', 'ngDialog', function($scope, $rootScope, $http, ngDialog) {

        $scope.initCtrl = function () {
            $scope.Assets = {};
            processAssets(PHD, window);
        };
        
        $scope.listViewFlag =false;
        $scope.tableView = true;
        $scope.getView = function(tabular) {
            var view = tabular || $scope.tableView;
            return (view  ===true ? "Table" : "List");
        };
        
        $scope.toggleView = function() {
            $scope.tableView = !$scope.tableView;
            
            if(!$scope.tableView){
                $scope.selectProtectedAssetsFromList($scope.selectedID);
                $("#" + ($scope.selectedID)).css("background-color","#f5f5f5");
            }else{
                ($(".environment-assets").find(".assets-table")).load($scope.protectedAssetsDataArr);
                ($(".environment-assets").find(".assets-table")).resize();
            }
        };

        $scope.display = 'All';
        $scope.getDisplay = function(view) {
            var view = $scope.display;
            return view;
        };

        $scope.launchRetentionManager = function() {
            ngDialog.open({
                template: 'app/configure/retention/retentionpolicy.html',
                scope: $scope,
                overlay:true,
                name: 'Retention-Policy',
                ngDialogStyle:'width:700px; height:400px;',
                closeByDocument: false,
                closeByEscape: false
            });
        };


        
        $scope.displayAll = function() {
            $scope.display = 'All';
            this.AssetsTable.load($scope.protectedAssetsAllDataArr);
            $scope.protectedAssetsDataArr = $scope.protectedAssetsAllDataArr;
        };

        $scope.displayVirtual = function() {
            $scope.display = 'Virtual';

            var virtualassets = ($scope.protectedAssetsAllDataArr).filter(function(obj){
                if (obj.asset_type && (obj.asset_type) != 'physical') {
                    return true;
                }
            });
            
            this.AssetsTable.load(virtualassets);   
            $scope.protectedAssetsDataArr = virtualassets;
        };

        $scope.displayPhysical = function() {
            $scope.display = 'physical';
            var physicalassets = ($scope.protectedAssetsAllDataArr).filter(function(obj){
                if (obj.asset_type && (obj.asset_type) === 'physical') {
                    return true;
                }
            });

            this.AssetsTable.load(physicalassets);
            $scope.protectedAssetsDataArr = physicalassets;
        };

        $scope.launchCredentialManager = function() {
            PHD.miniWizard("app/configure/credentials/credentials.html", "manage-credentials", {
                title: gettext("Manage Credentials"),
                helpArticle: PHD.App.getHelpLink("credentials", true),
                width: 800,
                height: 600,
                buttons: [
                    {
                        text: gettext("Close"),
                        click: function() {
                            $(this).dialog("close");
                        }
                    }
                ]
            });
            return true;
        };

        $scope.launchAssetManager = function() {
            $scope.Assets.assets.forEach(function(asset, index) {
                if (asset.id === $scope.Assets.selectedID) {
                    var edit_url = "app/configure/environments/" + ((asset.asset_type == 'VMware Host') ? "add-edit-hypervisor.html" : "add-edit.html");
                    var title = (asset.asset_type == 'VMware Host') ? "Edit Virtual Host" : "Edit Server";
                    PHD.wizard(edit_url, "manage-asset", {
                        title: gettext(title),
                        helpArticle: PHD.App.getHelpLink("editasset", true),
                        width: 700,
                        height: 340,
                        open: function (event, ui) {
                            $("#id_server").val(asset.name);
                            $("#id_ip").val(asset.ip);
                            $("#edit_object_id").text(asset.id);
                            $("#id_enabled").prop('checked', asset.is_enabled);
                            $("#id_encrypted").prop('checked', asset.is_encrypted);
                            serverEdit = true;
                            selectedCredential = asset.credentials != undefined ? asset.credentials.credential_id : 0;
                            if(asset.description === "VMware Host"){
                                EditDisabled = true;
                            }
                            else{
                                EditDisabled = false;
                            }
                        }
                    });
                }
            });
            return true;
        };

        $scope.installAgent = function() {
            console.log("install agent on " + $scope.Assets.selectedID);
            $scope.Assets.assets.forEach(function (asset, index) {
                if (asset.id === $scope.Assets.selectedID) {
                    var confirm = PHD.confirmDialog(
                        "<p>"+gettext("Are you sure you want to push an agent to " + asset.name + "?")+"</p>",
                        { title: gettext("Confirm Agent Push") }
                    );
                    confirm.done(function() {
                        var url = "/api/clients/agent-push";
                        var data = [];
                        obj = {};
                        obj.id = asset.id;
                        obj.system_id = asset.system_id;
                        obj.address = asset.ip;
                        obj.credential_id = asset.credential_id;
                        data[0] = obj;
                        var clientArray = {};
                        clientArray.clients = data;
                        data = JSON.stringify(clientArray);
                        PHD.Ajax.put(url, data)
                            .done(function (data) {
                                ;
                            });
                    });
                }
            })
        };

        $scope.addServer = function(add, selectedID) {
            var edit = (add == 0);
            PHD.wizard("app/configure/environments/add-edit.html", "manage-asset", {
                title: gettext("Add Server"),
                helpArticle: PHD.App.getHelpLink("addenvironment", true),
                width: 700,
                height: 340,
                open: function (event, ui) {
                    ;
                }
            });
            return true;
        };

        $scope.addHost = function(add, selectedID) {
            var edit = (add == 0);
            var id = selectedID || null;
            var resp = PHD.Ajax.get('/api/credentials/?sid=' + self.selectedID);
            resp.done(function(data){
                var credentialList = data.data;
                PHD.wizard("app/configure/environments/add-edit-hypervisor.html", "add-host", {
                    title: gettext("Add Virtual Host"),
                    helpArticle: PHD.App.getHelpLink("addasset", true),
                    width: 700,
                    height: 380,
                    beforeClose: function (event, ui) {
                        if(resetTour){
                            refreshPage();
                                setTimeout(function(){
                                     var $scope = $("[ng-controller=GlobalCtrl]").scope();
                                     $scope.user.showTour = true;
                                    window.location.href = "#/dashboard/";  
                                    resetTour = false;

                                }, 1000); 
                            }
                    }
                });
            });
            return true;
        };

        $scope.deleteAssetDialog = function() {
            var confirm = PHD.confirmDialog(
                "<p>"+gettext("Are you sure you want to remove this asset?")+"</p>",
                { title: gettext("Confirm Asset Removal") }
            );
            confirm.done($.proxy($scope.Assets.kill, $scope.Assets));
        };

        function processAssets(PHD, window) {
            var cellFormatter = {
                credentials: function (value, row) {
                    var display_name = row.credentials != undefined && row.credentials.display_name != undefined ? row.credentials.display_name : "None";
                    return display_name;
                }
            };

            var Assets = function($el) {
                $scope.el = $el;
                this.$el = $el;
                this.dbid = this.$el.data("dbid");
                this.$header = $el.children(".environment-header");
                this.$appliances = $el.children(".environment-assets");

                this.$buttons = $el.find(".button-bar a");
                $scope.buttons = this.$buttons;
                this.$options = this.$buttons.filter(".btn-environment-options");
                this.$el.find(".btn-group-display").flyout();
                this.$el.find(".btn-group-add-asset").flyout();

                this.appliancesInit = false;

                this.$applianceTable = this.$appliances.find(".assets-table");
                var defaultAssetOptions = {
                    integerIDs: false,
                    resize:true
                };
                this.AssetsTable = PHD.DataTable(this.$applianceTable, defaultAssetOptions).registerFormatters(cellFormatter);
                $scope.AssetsTable = this.AssetsTable;

                this.assets = [];
                this.$selectedAppliance = $();
                this.selectedID = null;
                $scope.selectedID = null;

                this.applianceProcess = null;
                this.detailProcess = null;

                this.timestamp = 0;
                this.refreshInterval = null;
                this.isActive = false;
            };

            Assets.prototype.init = function() {
                var self = this;

                this.initButtons();

                this.$applianceTable
                    .on("rowselect", function(event, dbid, $el, DataTable) {
                        self.$selectedAppliance = $el;
                        $scope.el = $el;
                        self.selectedID = dbid;
                        $scope.selectedID = self.selectedID;
                        self.selectedObj = _.find(self.assets, function(obj) { return obj.id == dbid });
                        PHD.appliance_sid = (self.selectedObj != null) ? self.selectedObj.system_id : null;
                        self.updateButtons();
                        //self.refresh(this.updateAssets, true);
                    })
                    .on("loadfinished updatefinished", function(event, newRows, DataTable) {
                        self.$applianceTable.scrollTable({"height": ".environment-assets"});
                        if(event.type === "loadfinished" && self.assets.length) {
                            //self.AssetsTable.selectByID(self.appliances[0].id);
                        }
                    });

                return this;
            };

            Assets.prototype.initButtons = function() {
                var self = this;
                return this;
            };

            Assets.prototype.updateButtons = function() {
                console.log("need to use scope to enable/disable buttons here.");
                /*this.$buttons.filter(".btn-edit-storage")
                    .toggleButton(this.selectedID && this.selectedStorageID && !this.$selectedStorage.is(".sync-status-pending"));
                this.$buttons.filter(".btn-remove-storage")
                    .toggleButton(this.selectedID && this.selectedStorageID && !this.$selectedStorage.is(".sync-status-pending"));
                this.$buttons.filter(".btn-edit-nic").toggleButton(this.selectedID && this.selectedNicID); */

                return this;
            };
            
            

            Assets.prototype.refresh = function(fn, updateDetails) {
                var self = this;
                if(this.isActive) {
                    fn = fn || this.updateAssets;
                    updateDetails = !(updateDetails === false);

                    this.applianceProcess = this.fetchAssets(fn);

                    $.when(this.applianceProcess).done(function() {
                        self.applianceProcess = null;
                        //if(!self.selectedID && self.appliances.length) self.AssetsTable.selectByID(self.appliances[0].state.id);
                        if(!self.selectedID && self.assets.length) self.AssetsTable.selectByID(self.assets[0].id);
                        //self.setRefreshInterval();
                    });
                }
            };

            Assets.prototype.fetchAssets = function(fn) {
                if(!_.isFunction(fn)) {
                    fn = this.buildAssets;
                }
                //this.AssetsTable.showLoadingIndicator();

                return PHD.Ajax
                    //lmc
                    .get("/api/assets/")
                    .done($.proxy(fn, this));
            };

            $scope.protectedAssetsDataArr = [];
            $scope.protectedAssetsAllDataArr = [];
            $scope.selectedAssets; 
            Assets.prototype.buildAssets = function(data) {
                if(data) {
                    this.assets = data.data;
                    $scope.protectedAssetsAllDataArr = this.assets;
                    this.assets.forEach(function(asset, index) {
                       asset.description = (asset.os_type != undefined) ? asset.os_type : asset.asset_type;
                    });
                    
                    if($scope.display == 'physical'){
                        $scope.displayPhysical();
                    }else if($scope.display == 'Virtual'){
                        $scope.displayVirtual();
                        
                    }else{
                        $scope.displayAll();
                    }

                    $scope.selectedAssets = $scope.protectedAssetsDataArr[0];
                    $("#" + ($scope.protectedAssetsDataArr[0].id)).css("background-color","#f5f5f5");
                }
                if(this.applianceProcess) this.applianceProcess.resolve();
            };

            Assets.prototype.updateAssets = function(data) {
                if(data) {
                    this.assets = data.data;
                    this.assets.forEach(function(asset, index) {
                        asset.description = (asset.os_type != undefined) ? asset.os_type : asset.asset_type;
                    });
                    this.timestamp = data.timestamp;
                    this.AssetsTable.update(this.assets, true);
                }
                if(this.applianceProcess) this.applianceProcess.resolve();
            };

            Assets.prototype.isReady = function() {
                return this.isActive && (this.applianceProcess === null || this.applianceProcess.state() === 'resolved') &&
                    (this.detailProcess === null || this.detailProcess.state() === 'resolved');
            };

            Assets.prototype.setButtonLock = function(locked) {
                this.$buttons.each(function() {
                    $(this).toggleButton(!locked);
                });
            };

            Assets.prototype.initAssets = function() {
                this.refresh(this.buildAssets);
                this.appliancesInit = true;
                return this;
            };

            Assets.prototype.kill = function() {
                var self = this,
                    url = "/api/clients/" + this.selectedID + "/?sid=" + this.selectedObj.system_id;
                //UNIBP-1708 added loding indicator while removing    
                var deleteProtectedAsset = PHD.showLoadingIndicator("body", true, "Removing...");
                var resp = PHD.Ajax.delete(url, null, deleteProtectedAsset);
                resp.done(function(data) {
                    self.selectedID = null;
                    PHD.hideLoadingIndicator(deleteProtectedAsset);
                    self.refresh(self.fetchAssets);
                });
            };

            Assets.prototype.activate = function() {
                this.isActive = true;
                if(!this.appliancesInit) {
                    this.initAssets();
                } else {
                    this.refresh(this.updateAssets);
                }
                return this;
            };

            Assets.prototype.deactivate = function() {
                this.isActive = false;
                clearInterval(this.refreshInterval);
                return this;
            };

            var AssetsTab = function(index, $panel) {
                this.index = index;
                this.$panel = $panel;
                this.$assetsArea = this.$panel.children("#assets-list");
                this.$environments = null;
                this.environmentList = {};
                this.activeEnvironment = null;
                this.isActive = false;
                this.isBootstrapped = false;
            };

            AssetsTab.prototype.bootstrap = function(data) {
                this.$environments = this.$assetsArea.find(".environment");
                this.environmentList = new Assets(this.$environments).init();
                $scope.Assets = this.environmentList;
                this.activeEnvironment = this.environmentList; //this.environmentList.activate();
                this.isBootstrapped = true;
            };

            AssetsTab.prototype.init = function() {
                var self = this;
                $(document)
                    .on("assetChange", function(event, dbid) {
                        if ($scope.Assets !== undefined) {
                            $scope.Assets.initAssets();
                        }
                    });

                return this;
            };

            AssetsTab.prototype.activate = function() {
                this.isActive = true;
                if(!this.isBootstrapped) {
                    this.bootstrap();
                }
                if(this.activeEnvironment) {
                    this.activeEnvironment.activate();
                }
                return this;
            };

            AssetsTab.prototype.deactivate = function() {
                this.isActive = false;
                if(this.activeEnvironment) {
                    this.activeEnvironment.deactivate();
                }
                return this;
            };
            
            Assets.prototype.setSelectedAssets = function(selectedId){
                var self = this;
                
                $scope.listViewFlag = true;

                this.AssetsTable = $scope.AssetsTable;
                this.$selectedAppliance = $scope.el;
                this.selectedID = selectedId;
                //this.refresh(this.updateAssets, false);

                var x = this.AssetsTable.$table[0].rows;
                for (var i = 1; i < x.length; i++) {
                    
                    var rowDetails = x[i];
                    
                    if((parseInt(x[i].dataset.dbid)) == selectedId){
                        if(!($(x[i]).hasClass("current-row"))){
                            $(x[i]).addClass("current-row");
                            $scope.selectedID = selectedId;
                            this.$selectedAppliance = $(x[i]);
                            this.selectedID = selectedId;
                        }
                        
                    }else{
                        if($(x[i]).hasClass("clickable current-row")){
                            $(x[i]).removeClass("current-row");
                        }
                    }
                }
                
                this.AssetsTable.$table[0].rows = x;
                self.updateButtons();
            };
            
            $scope.selectProtectedAssetsFromList = function(selectedId){
                var arrLength=($scope.protectedAssetsDataArr).length;

                for (var i=0; i < arrLength; i++){
                    if ($scope.protectedAssetsDataArr[i].id===selectedId){
                       $scope.selectedAssets = $scope.protectedAssetsDataArr[i];
                       $("#" + selectedId).css("background-color","#f5f5f5");
                       $scope.selectedID = selectedId;
                    }else{
                        $("#" + $scope.protectedAssetsDataArr[i].id).css("background-color","#fff");
                    }
                }
                
                Assets.prototype.setSelectedAssets(selectedId);
            };

            PHD.AssetsTab = AssetsTab;
        }

        // Initialize the controller.
        $scope.initCtrl();
    }]);