angular.module('retention',['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])

    .controller('RetentionCtrl', ['$scope', '$rootScope', '$http','ngDialog', function($scope, $rootScope, $http, ngDialog) {



        $scope.initCtrl = function(dlg){
            switch (dlg.name) {
                case 'Retention-Policy':
                    processDialog(PHD, window);
                    break;
                case 'Retention-Addition':
                    $scope.processRetentionDialog();
                    break;
                case 'Retention-Edit':
                    $scope.processEditDialog();
                    break;
            }
        };

        function processDialog(PHD, window){

            var $el = $("#retention-policy-dialog");
            var $retentionTable;
            var retentionSelect;
            var RetentionTable;
            var allRetention;
            var RetentionRowData = null;
            var base_url = "/api/retention/";
            var retentionEdit = false;

            function refreshRetentionList() {
                var retention = PHD.Ajax.get('/api/retention_policy/');
                allRetention = [];
                retention.done(function(data){

                    var retentionList = data.data;
                    /*retentionList.forEach(function(item, index) {
                     item.id = item.id;
                     item.name = item.name;
                     item.days = item.days;
                     item.weeks = item.weeks;
                     item.months = item.months;
                     item.years = item.years;
                     });*/
                    allRetention = $.merge(allRetention, retentionList);
                    RetentionTable.load(allRetention);
                });
            }

            $retentionTable = $el.find(".retention-table");
            RetentionTable = PHD.DataTable($retentionTable, {});
            refreshRetentionList();
            //console.log(RetentionTable);

            $retentionTable.on("rowselect", "tr", function(event, dbid, $el, DataTable, DataRow) {
                RetentionRowData = DataRow.data;
                PolicyName = RetentionRowData.name;

                if(RetentionRowData.days === "Forever"){
                    Days = "";
                }
                else{
                    Days = RetentionRowData.days;
                }

                if(RetentionRowData.weeks === "Forever"){
                    Weeks = "";
                }
                else{
                    Weeks = RetentionRowData.weeks;
                }

                if(RetentionRowData.months === "Forever"){
                    Months = "";
                }
                else{
                    Months = RetentionRowData.months;
                }

                if(RetentionRowData.years === "Forever"){
                    Years = "";
                }
                else{
                    Years = RetentionRowData.years;
                }
            });
        }

        $scope.launchRetentionAddition = function(){
            ngDialog.open({
                template: 'app/configure/retention/retention.html',
                name: 'Retention-Addition',
                scope: $scope,
                overlay:true,
                ngDialogStyle:'width:700px; height:620px;',
                closeByDocument: false,
                closeByEscape: false,
                showClose: false
            });
        };

        $scope.daySpinOptions = { "min": 1, "max": 365, "step": 1};
        $scope.weekSpinOptions = { "min": 1, "max": 52, "step": 1};
        $scope.monthSpinOptions = { "min": 1, "max": 12, "step": 1};
        $scope.yearSpinOptions = { "min": 1, "max": 100, "step": 1};

        $scope.processRetentionDialog = function() {
            $("#keep_days").spinner($scope.daySpinOptions);
            $("#keep_weeks").spinner($scope.weekSpinOptions);
            $("#keep_months").spinner($scope.weekSpinOptions);
            $("#keep_years").spinner($scope.yearSpinOptions);
        };

        // this can turn on and off spinners based on forever being checked or not.
        $scope.handleRetentionSpinner = function($el, elSpinner) {
            var checked = $el.is(":checked");
            elSpinner.spinner("option","disabled", checked);
        };

        $scope.processEditDialog = function () {
            // Initialize Spinners
            $scope.processRetentionDialog();

            days = weeks = months = years = "";
            $("#policy-name").val(PolicyName);
            $("#keep_days").val(Days);
            if(Days === "")  {
                $("#days-forever").prop("checked", true);
                $("#keep_days").spinner("option", "disabled", true);
                $("#weeks-forever").disable();
                $("#keep_weeks").spinner("option", "disabled", true);
                $("#months-forever").disable();
                $("#keep_months").spinner("option", "disabled", true);
                $("#years-forever").disable();
                $("#keep_years").spinner("option", "disabled", true);
            }
            $("#keep_weeks").val(Weeks);
            if(Weeks === ""){
                $("#weeks-forever").prop("checked", true);
                //$("#keep_weeks").spinner("disable");
                $("#months-forever").disable();
                //$("#keep_months").spinner("disable");
                $("#years-forever").disable();
                //$("#keep_years").spinner("disable");
            }
            $("#keep_months").val(Months);
            if(Months === "") {
                $("#months-forever").prop("checked", true);
                //$("#keep_months").spinner("disable");
                $("#years-forever").disable();
                //$("#keep_years").spinner("disable");
            }
            $("#keep_years").val(Years);
            if(Years === "") {
                //$("#keep_years").spinner("disable");
                $("#years-forever").prop("checked", true);
            }
        };

        $scope.launchRetentionEditor = function() {
            ngDialog.open({
                template: 'app/configure/retention/retention.html',
                name: 'Retention-Edit',
                scope: $scope,
                overlay:true,
                ngDialogStyle:'width:700px; height:620px;',
                closeByDocument: false,
                closeByEscape: false,
                showClose: false
            });
        };

        $scope.ShowCalendar = function(){
            ngDialog.open({
                template: 'app/configure/retention/calendarview.html',
                scope: $scope,
                overlay:true,
                ngDialogStyle:'width:500px; height:500px;',
                closeByDocument: false,
                closeByEscape: false,
                showClose: false
            });
        };

        $scope.AddRetentionInfo = function () {
            console.log("Add clicked");
            var obj={};
            var policy_name = $("#policy-name").val();

            if (policy_name != "") {
                obj.name = policy_name;
            }

            if($("#default").prop("checked")){
                obj.is_default = true;
            }
            else{
                obj.is_default = false;
            }

            obj.days = Number($("#keep_days").val());
            obj.weeks = Number($("#keep_weeks").val());
            obj.months = Number($("#keep_months").val());
            obj.years = Number($("#keep_years").val());

            if($("#days-forever").prop("checked")){
                obj.days = -1;
                obj.weeks = 0;
                obj.months = 0;
                obj.years = 0;
            }else if($("#weeks-forever").prop("checked")){
                obj.days = 0;
                obj.weeks = -1;
                obj.months = 0;
                obj.years = 0;
            }else if($("#months-forever").prop("checked")){
                obj.days = 0;
                obj.weeks = 0;
                obj.months = -1;
                obj.years = 0;
            }else if($("#years-forever").prop("checked")){
                obj.days = 0;
                obj.weeks = 0;
                obj.months = 0;
                obj.years = -1;
            }

            var base_url = "/api/retention_policy/";

            obj = JSON.stringify(obj);
            /*if(policyEdit){
             console.log("PUT called");
             base_url +=id + "/";
             resp = PHD.Ajax.put(base_url + "?sid=" +  PHD.appliance_sid, obj);
             }
             else{*/
            resp = PHD.Ajax.post(base_url + "?sid=" +  PHD.appliance_sid, obj);
            //}

            resp.done(function(data) {
                var result = data.result[0];

                if(result.code === AJAX_RESULT_SUCCESS) {
                    console.log("SUCCESS");
                    //PHD.throwNotice(data, {});
                    //PHD.currentDialog.wizard("close");
                    $(document).trigger("retentionupdate", [result.data]);
                    //PHD.currentDialog.wizard("close");
                    ngDialog.open({
                        dialogType: 'Information',
                        dialogMessage: data,
                        overlay:true
                    });
                } else if(result.code === AJAX_RESULT_ERROR) {
                    console.log("FAILURE");
                    ngDialog.open({
                        dialogType: 'ERROR',
                        dialogMessage: data,
                        overlay:true
                    });
                }
                //PHD.currentDialog.wizard("close");
            });
        };

        $scope.DaysForeverClicked = function() {
            console.log("Days forever clicked");
            $scope.handleRetentionSpinner($("#days-forever"), $("#keep_days"));
            if($("#days-forever").prop("checked")){
                console.log("Days forever enabled");
                this.days =  $("#keep_days").val();
                //$("#keep_days").spinner("disable");
                $("#keep_days").val("");
                $("#weeks-forever").disable();
                //$("#keep_weeks").spinner("disable");
                this.weeks =  $("#keep_weeks").val();
                $("#keep_weeks").val("");
                $("#months-forever").disable();
                //$("#keep_months").spinner("disable");
                this.months = $("#keep_months").val();
                $("#keep_months").val("");
                $("#years-forever").disable();
                //$("#keep_years").spinner("disable");
                this.years =  $("#keep_years").val();
                //$("#keep_years").val("");
            }
            else{
                console.log("Days forever disabled");
                //$("#keep_days").spinner("enable");
                $("#keep_days").val(this.days);
                $("#weeks-forever").enable();
                $("#keep_weeks").enable();
                //$("#keep_weeks").spinner("enable");
                $("#keep_weeks").val(this.weeks);
                $("#months-forever").enable();
                $("#keep_months").enable();
                //$("#keep_months").spinner("enable");
                $("#keep_months").val(this.months);
                $("#years-forever").enable();
                $("#keep_years").enable();
                //$("#keep_years").spinner("enable");
                $("#keep_years").val(this.years);
            }
        };

        $scope.WeeksForeverClicked = function() {
            $scope.handleRetentionSpinner($("#weeks-forever"), $("#keep_weeks"));
            if ($("#weeks-forever").prop("checked")) {
                console.log("Weeks forever enabled");
                weeks = $("#keep_weeks").val();
                $("#keep_weeks").val("");
                //$("#keep_weeks").spinner("disable");
                $("#months-forever").disable();
                //$("#keep_months").spinner("disable");
                months = $("#keep_months").val();
                $("#keep_months").val("");
                $("#years-forever").disable();
                //$("#keep_years").spinner("disable");
                years = $("#keep_years").val();
                $("#keep_years").val("");
            } else {
                console.log("Weeks forever disabled");
                //$("#keep_weeks").spinner("enable");
                $("#keep_weeks").val(weeks);
                $("#months-forever").enable();
                $("#keep_months").enable();
                //$("#keep_months").spinner("enable");
                $("#keep_months").val(months);
                $("#years-forever").enable();
                $("#keep_years").enable();
                //$("#keep_years").spinner("enable");
                $("#keep_years").val(years);
            }
        };

        $scope.MonthsForeverClicked = function() {
            $scope.handleRetentionSpinner($("#months-forever"), $("#keep_months"));
            if($("#months-forever").prop("checked")){
                console.log("Months forever enabled");
                months = $("#keep_months").val();
                $("#keep_months").val("");
                //$("#keep_months").spinner("disable");
                $("#years-forever").disable();
                //$("#keep_years").spinner("disable");
                years =  $("#keep_years").val();
                $("#keep_years").val("");
            }else{
                console.log("Months forever disabled");
                $("#keep_months").val(months);
                //$("#keep_months").spinner("enable");
                $("#years-forever").enable();
                $("#keep_years").enable();
                //$("#keep_years").spinner("enable");
                $("#keep_years").val(years);
            }
        };

        $scope.YearsForeverClicked = function() {
            if($("#years-forever").prop("checked")){
                console.log("Years forever enabled");
                years =  $("#keep_years").val();
                //$("#keep_years").spinner("disable");
                $("#keep_years").val("");
            }else{
                console.log("Years forever disabled");
                $("#keep_years").val(years);
                //$("#keep_years").spinner("enable");
            }
        };

        // Initialize the controller.
        $scope.$on('ngDialog.opened', function(event, obj) { $scope.initCtrl(obj) });
    }]);


/*(function($, PHD, window, undefined) {
 var $el = $("#retention-policy-dialog");
 var $retentionTable;
 var retentionSelect;
 var RetentionTable;
 var allRetention;
 var RetentionRowData = null;
 var base_url = "/api/retention/";
 var retentionEdit = false;


 function initForm() {

 function refreshRetentionList() {
 var retention = PHD.Ajax.get('/api/retention_policy/');
 allRetention = [];
 retention.done(function(data){

 var retentionList = data.data;
 retentionList.forEach(function(item, index) {
 item.id = item.id;
 item.name = item.name;
 item.days = item.days;
 item.weeks = item.weeks;
 item.months = item.months;
 item.years = item.years;
 });
 allRetention = $.merge(allRetention, retentionList);
 RetentionTable.load(retentionList);
 });
 }

 // Initialize table, appliance list
 $retentionTable = $el.find(".retention-table");
 RetentionTable = PHD.DataTable($retentionTable, {});
 refreshRetentionList();

 $retentionTable.on("rowselect", "tr", function(event, dbid, $el, DataTable, DataRow) {
 RetentionRowData = DataRow.data;

 if(RetentionRowData.days === "Forever"){
 Days = "";
 }
 else{
 Days = RetentionRowData.days;
 }

 if(RetentionRowData.weeks === "Forever"){
 Weeks = "";
 }
 else{
 Weeks = RetentionRowData.weeks;
 }

 if(RetentionRowData.months === "Forever"){
 Months = "";
 }
 else{
 Months = RetentionRowData.months;
 }

 if(RetentionRowData.years === "Forever"){
 Years = "";
 }
 else{
 Years = RetentionRowData.years;
 }
 });

 $(".retention-add").click(function() {
 /* $(document).trigger("launchdialog", {"action": "retentionpolicy"});
 retentionEdit = false;
 policyEdit = retentionEdit;
 console.log("add clicked");
 var edit_url = "app/configure/retention/retention.html";
 var title = "Add Retention Policy";
 PHD.wizard(edit_url, "manage-asset", {
 title: gettext(title),
 helpArticle: PHD.App.getHelpLink("editasset", true),
 width: 700,
 height: 620,
 zIndex: 1000,
 modal: true,
 open:function(event,ui){
 policyEdit;
 }
 });
 ngDialog.open({
 template: 'app/configure/retention/retention.html',
 scope: $scope,
 overlay:true,
 ngDialogStyle:'width:700px; height:620px;'
 });
 });


 $(".retention-edit").click(function() {
 retentionEdit = true;
 policyEdit = retentionEdit;
 console.log("edit clicked, id selected is " + RetentionTable.selectedID);
 $(document).trigger("launchdialog", {"action": "retentionpolicy"});
 console.log("edit clicked, id selected is " + RetentionTable.selectedID);
 var edit_url = "app/configure/retention/retention.html";
 var title = "Edit Retention Policy";
 PHD.wizard(edit_url, "manage-asset", {
 title: gettext(title),
 helpArticle: PHD.App.getHelpLink("editasset", true),
 width: 700,
 height: 620,
 zIndex: 1001,
 modal: true,
 open: function (event, ui) {
 days = weeks = months = years = "";
 $("#policy-name").val(RetentionRowData.name);
 $("#days").val(Days);
 if(Days === "")  {
 $("#days-forever").prop("checked", true);
 $("#days").spinner("disable");
 $("#weeks-forever").disable();
 $("#weeks").spinner("disable");
 $("#months-forever").disable();
 $("#months").spinner("disable");
 $("#years-forever").disable();
 $("#years").spinner("disable");
 }
 $("#weeks").val(Weeks);
 if(Weeks === ""){
 $("#weeks-forever").prop("checked", true);
 $("#weeks").spinner("disable");
 $("#months-forever").disable();
 $("#months").spinner("disable");
 $("#years-forever").disable();
 $("#years").spinner("disable");
 }
 $("#months").val(Months);
 if(Months === "") {
 $("#months-forever").prop("checked", true);
 $("#months").spinner("disable");
 $("#years-forever").disable();
 $("#years").spinner("disable");
 }
 $("#years").val(Years);
 if(Years === "") {
 $("#years").spinner("disable");
 $("#years-forever").prop("checked", true);
 }
 policyEdit;
 id = RetentionRowData.id;
 }
 });
 });


 $(".retention-delete").click(function() {
 retentionEdit = false;
 console.log("delete retention");
 if (RetentionTable.selectedID != null) {
 var id_to_delete = RetentionTable.selectedID;
 PHD.confirmDialog("<p>" + gettext("Are you sure you want to delete the selected retention Policy?") + "</p>", {
 title: gettext("Confirm Retention Deletion")
 })
 .done(function() {
 var url = base_url + id_to_delete + "?sid=" + RetentionRowData.system_id;
 PHD.Ajax
 .delete(url)
 .done(function (data) {
 RetentionTable.deleteRow(id_to_delete);

 });
 }
 )
 }
 });
 }
 */


/*
 *   DOM Ready Function

 $(function() {
 initForm();
 /* PHD.currentMiniWizard.one("dialogfocus", function() {

 });

 });

 })(jQuery, window.PHD || (window.PHD = {}), window);
 */