(function($, PHD, window, undefined) {
    
    var $form = $("#bds-form"),
        InternalDiskForm,
        NAME_REGEX = /^[a-zA-Z0-9\-\_]+$/,
        $d2d = $("#id_d2d_allocation"),
        $d2dGB = $("#id_d2d_gb"),
        $ir = $("#id_ir_allocation"),
        $irGB = $("#id_ir_gb"),
        $includedTable = $form.find(".included-disks"),
        $availableTable = $form.find(".available-disks"),
        $attached = $("#attached-disks"),
        DiskManager,
        allocationSpinnerOptions = {"min": 1, "max": 99, "step": 1},
        $storageID = $("#edit_object_id"),
        $systemID = $("#id_system"),
        paper = null,
        system_id,
        newtotal = 0;
    var MINPERCENT=0.00001;
    var Disks = function($el) {
        this.$el = $el;
        this.$selected = null;
        this.$buttons = this.$el.find(".disk-controls a");
        this.uuid = "";
    };

    Disks.prototype.gather = function() {
        this.$initial = $includedTable.find("tbody tr:not(.clickable)");
        this.$added = $includedTable.find("tbody tr.clickable");
        this.$included = this.$initial.add(this.$added);
        this.$available = $availableTable.find("tbody tr");
        if(this.$included.length) {
            this.uuid = this.$included.eq(0).data("uuid");
        }
        return this;
    };

    Disks.prototype.sumd2d = function(event, ui) {
        var adder = 0;
        if (ui !== undefined) {
            if (ui.value < $d2d.val()) {
                adder = +1;
            } else if (ui.value > $d2d.val()) {
                adder = -1;
            }
        }
        var ir = 100 - parseInt($d2d.val(), 10) + adder;
        $ir.val(ir);

        var ir_GB = Math.round((newtotal/1024 * ir)/100);
        var d2d_GB = Math.round(newtotal/1024 - ir_GB);
        $irGB.text("(" + ir_GB + " GB)");
        $d2dGB.text("(" + d2d_GB + " GB)");

        this.sum();
    };

    Disks.prototype.sumir = function(event, ui) {
        var adder = 0;
        if (ui !== undefined) {
            if (ui.value < $ir.val()) {
                adder = +1;
            } else if (ui.value > $ir.val()) {
                adder = -1;
            }
        }
        var d2d = 100 - parseInt($ir.val(), 10) + adder;
        $d2d.val(d2d);

        var d2d_GB = Math.round((newtotal/1024 * d2d)/100);
        var ir_GB = Math.round(newtotal/1024 - d2d_GB);
        $irGB.text("(" + ir_GB + " GB)");
        $d2dGB.text("(" + d2d_GB + " GB)");

        this.sum();
    };

    Disks.prototype.sum = function() {
        var d2d = parseInt($d2d.val(), 10) / 100,
            ir = parseInt($ir.val(), 10) / 100;

        total = this.$included
            .map(function(){ return $(this).data("size"); })
            .get()
            .reduce(function(prev, next){ return prev + next; }, 0);
        total = parseInt(total, 10);

        if (selectedStorage !== null) {
            total += selectedStorage.mb_size;
            newtotal = total;
        }

        this.$diskUsage.text(getDiskUsageString(this.$included.length, PHD.util.formatMB(total)));

            if (d2d > ir){
                ir =(ir > 0) ? ir : MINPERCENT;
                d2d =(d2d > 0) ? d2d : MINPERCENT;
                updatepieChart(paper, [d2d, ir], ["#5693d6", "#eae46e"]);
            } else {
                ir =(ir > 0) ? ir : MINPERCENT;
                d2d =(d2d > 0) ? d2d : MINPERCENT;
                updatepieChart(paper, [d2d, ir], ["#eae46e", "#5693d6"]);
            }

        return this;
    };

    Disks.prototype.selectRow = function(event) {
        var $row = $(event.target).closest("tr");
            
        if($row.is(".current-row") || !$row.is(".clickable")) {
            return false;
        }
        if($row.data("uuid") !== "") {
            $row = $row.closest("tbody").find("tr[data-uuid='" + $row.data("uuid") + "']");
        }
        this.$el.find(".current-row").removeClass("current-row");

        this.$selected = $row.addClass("current-row");
        return this.updateButtons();
    };

    Disks.prototype.addDisk = function() {
        this.$selected.detach().appendTo($includedTable);
        populateAttachedDiskFields();
        $form.validate().element($("#validate_disks"));
        return this.update();
    };

    Disks.prototype.removeDisk = function() {
        this.$selected.detach().appendTo($availableTable);
        populateAttachedDiskFields();
        return this.update();
    };

    Disks.prototype.resetDisks = function() {
        this.$el.find("tr.clickable").detach().appendTo($availableTable);
        populateAttachedDiskFields();
        return this.update();
    };

    Disks.prototype.refreshDisks = function() {
        var self = this;
        system_id = PHD.appliance_sid;
        var availableURL = "/api/storage/available-disks/?sid=" + system_id;

        var resp, respAvailable;
        var attached_names, unattached_names;

        resp = PHD.Ajax.get(availableURL);
        
        resp.done(function(data) {
            var info = selectedStorage;
            console.log("storage  = " + JSON.stringify(info));
            if (info != null && info.properties !== undefined) {
                //attached_names = _.pluck(info.attached_disks, "name");
                attached_names = info.properties;
                if (attached_names !== undefined) {
                    if (Array.isArray(attached_names)) {
                        attached_names.forEach(function(name, index) {
                            var obj = {};
                            obj.name = name;
                            obj.rowType = "static";
                            obj.formatted_size = "N/A";
                            obj.mb_size = 0;
                            obj.uuid = "---";
                            obj.partitioned = true;
                            obj.filesystem = true;
                            var html = rowTmpl(obj);
                            $(html).appendTo($includedTable);
                        })
                    } else {
                        // added internal.
                        var obj = {};
                        obj.name = attached_names.internal_name;
                        obj.rowType = "static";
                        obj.formatted_size = "N/A";
                        obj.mb_size = 0;
                        obj.uuid = "---";
                        obj.partitioned = true;
                        obj.filesystem = true;
                        var html = rowTmpl(obj);
                        $(html).appendTo($includedTable);
                    }
                }
                // initialize attached
                populateAttachedDiskFields();
                //var uid = value.name;
                //console.log("name = " + JSON.stringify(value));
                /*if(!$includedTable.find("[data-dbid='" + uid + "']").length) {
                    //console.log("new included disk", value.name);
                    value.rowType = "static";
                    value.formatted_size = PHD.util.formatMB(value.mb_size);
                    var html = rowTmpl(value);
                    $(html).appendTo($includedTable);
                }
                */
            }

            var available = data.attached_disks;
            if (available !== undefined) {
                unattached_names = _.pluck(available, "name");
                available.forEach(function(value, index, arr) {
                    var uid = value.name;
                    if(!$includedTable.find("[data-name='" + uid + "']").length &&
                        !$availableTable.find("[data-name='" + uid + "']").length) {
                        console.log("new available disk", value.name);
                        value.rowType = "clickable";
                        value.formatted_size = PHD.util.formatMB(value.mb_size);
                        var html = rowTmpl(value);
                        $(html).appendTo($availableTable);
                    }
                })
            }

            names = _.union(attached_names, unattached_names);
            $disks = self.$included.add(self.$available);
            $disks.each(function() {
                if(!_.contains(names, $(this).data("name"))) {
                    $(this).remove();
                }
            });

            self.update();
        });

        return this;
    };

    Disks.prototype.updateButtons = function() {

        if(this.$selected && $.contains($availableTable[0], this.$selected[0])) {
            this.$buttons.filter(".btn-add-disk")
                .removeClass("disabled")
                .on("click", $.proxy(this.addDisk, this));
        } else {
            this.$buttons.filter(".btn-add-disk").disableButton();
        }

        if(this.$selected && $.contains($includedTable[0], this.$selected[0])) {
            this.$buttons.filter(".btn-remove-disk")
                .removeClass("disabled")
                .on("click", $.proxy(this.removeDisk, this));
        } else {
            this.$buttons.filter(".btn-remove-disk").disableButton();
        }
        return this;
    };

    Disks.prototype.restrictDisks = function() {
        // TODO: handle what can be selected based on uuid/filesystem
        if(this.uuid) {
            this.$available.filter("[data-uuid!='']").removeClass("clickable").addClass("static");
        } else {
            this.$available.filter("[data-uuid!='']").removeClass("static").addClass("clickable");
        }
        return this;
    };

    Disks.prototype.update = function() {
        initTables();
        //return this.gather().restrictDisks().sum().updateButtons();
        // lmc also update the allocation buttons if present.
        this.gather().restrictDisks().sum();
        this.sumd2d();
        this.sumir();
        return this.updateButtons();
    };

    Disks.prototype.init = function() {
        this.$diskUsage = $form.find(".disk-usage");

        $d2d.on("change spinchange spin", $.proxy(this.sumd2d, this));
        $ir.on("change spinchange spin", $.proxy(this.sumir, this));

        $includedTable.on("click", ".clickable", $.proxy(this.selectRow, this));
        $availableTable.on("click", ".clickable", $.proxy(this.selectRow, this));

        this.$buttons.filter(".btn-reset-disks").on("click", $.proxy(this.resetDisks, this));
        this.$buttons.filter(".btn-refresh-disks").on("click", $.proxy(this.refreshDisks, this));

	    // lmc - add and move init function.
	    this.refreshDisks(this);

        return this.update();
    };

    function initTables() {
        $includedTable.scrollTable({"height": 151, "resize": false});
        $availableTable.scrollTable({"height": 151, "resize": false});
    }

    function initForm() {

        $form.find(".definition").popover({
            appendTo: $form,
            position: {
                my: "left bottom",
                at: "right top-15"
            }
        });

        // if adding, remove allocation pie
        if ($storageID.text() == "none") {
            $(".bds-options").hide();
        }

        $d2d.spinner(allocationSpinnerOptions);
        $ir.spinner(allocationSpinnerOptions);

        $.validator.addMethod("validate-disks", function(value, element) {
                return $attached.find("[id=attached-disks]").length;
            },
            gettext("Please add at least one disk.")
        );

        InternalDiskForm = PHD.FormController($form, {})
            .validate({
                rules: {
                    name: {
                        required: true,
                        pattern: NAME_REGEX
                    },
                    d2d: {
                        required: true,
                        min: 0,
                        max: 100,
                        digits: true
                    },
                    ir: {
                        required: true,
                        min: 0,
                        max: 100,
                        digits: true
                    }
                },
                messages: {
                    name: {
                        required: "The storage name is required"
                    },
                    d2d: {
                        required: gettext("Please enter a positive backups allocation"),
                        min: gettext("Please enter a positive backups allocation"),
                        max: gettext("Backups allocation may not exceed 100"),
                        digits: gettext("Backups allocation must be a number")
                    },
                    ir: {
                        required: gettext("Please enter a positive Instant Recovery allocation"),
                        min: gettext("Please enter a positive Instant Recovery allocation"),
                        max: gettext("Instant Recovery allocation may not exceed 100"),
                        digits: gettext("Instant Recovery allocation must be a number")
                    }
                }
            })
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                $(document).trigger("bdssave", [system_id, data]);
                PHD.currentDialog.wizard("close");

                var scope = angular.element(document).scope();
                if(scope.user.showTour) {
                    if(scope.tourHostDisabled) {
                        scope.tourHostDisabled = false;
                    }
                    window.location.href = "#";
                }
            });

        InternalDiskForm.submit = function() {
            var self = this,
                load = PHD.showLoadingIndicator("body", true, "Saving Storage...");

            this.$buttons.blur().disable();

            var submitData = form2js(this.$form.attr("id"), '.', false);

            var $editing_id = this.$form.find("#edit_object_id");
            console.log('edit id text = ' + $editing_id.text() + " and appliance id is " + PHD.appliance_sid);
            var url_sid = (PHD.appliance_sid === null) ? "/" : "/?sid=" + PHD.appliance_sid;
            var url = this.$form.attr("action");

            var storageObj = {};
            // if added disks, set "internal_name"
            //storageObj.internal_name = "";
            // get this after update so we know new size??
            var $added = $includedTable.find("tbody tr.clickable");
            var added_names = [];
            if ($added !== undefined) {
                $added.each(function(index) {
                    var name = $(this).find("[data-source=\"name\"]").html();
                    console.log("name to add is " + name);
                    added_names.push(name);
                });
                if (added_names.length > 0) {
                    var disks ={};
                    disks.internal_name = added_names.toString();
                    storageObj.properties = disks;
                }
            }

            // get IR and d2d from GB label.
            var ir = parseInt($irGB.text().match(/\d+/), 10);
            var d2d = parseInt($d2dGB.text().match(/\d+/), 10);

            var isEdit = $editing_id.text() != "none";
            var isStateless = false;
            if (selectedStorage.usage == "stateless" && selectedStorage.stateless_type === null && added_names.length > 0) {
                // Stateless storage has not been created.  We need to create it.
                isStateless = true;
                isEdit = false;
                storageObj.name = "_Stateless";
                storageObj.build_filesystem = 1;    // create stateless storage
                storageObj.usage = "stateless";
                storageObj.type = STORAGE_ADDED_INTERNAL;

                // create stateless - turn off timers.
                var scope = angular.element(document).scope();
                scope.disableTimers();
            }

            if (isEdit) {
                storageObj.type = selectedStorage.usage == "stateless" ? STORAGE_ADDED_INTERNAL : mapStringToInt(selectedStorage.type);
                storageObj = JSON.stringify(storageObj);
                console.log("Edit " + storageObj);
                if (added_names.length > 0) {
                    var storage_id = $editing_id.text();
                    url += storage_id + url_sid;
                    PHD.Ajax
                        .put(url, storageObj)
                        .done(function(data) {
                            self.$form.trigger("formsubmit", [data, self.$form, self]);
                        })
                        .always(function() {
                            self.$buttons.enable();
                            updatePieValues(d2d, ir);
                            PHD.hideLoadingIndicator(load);
                        });
                } else {
                    self.$buttons.enable();
                    // no disks added, just update pie
                    updatePieValues(d2d, ir);
                    PHD.hideLoadingIndicator(load);
                    self.$form.trigger("formsubmit", [self.$form, self]);
                }
            } else {
                if (!isStateless) {
                    storageObj.name = submitData.name;
                    storageObj.usage = submitData.usage;
                    storageObj.type = submitData.type;
                }
                storageObj = JSON.stringify(storageObj);
                console.log("Add " + storageObj);
                url += url_sid;
                PHD.Ajax
                    .post(url, storageObj)
                    .done(function(data) {
                        self.$form.trigger("formsubmit", [data, self.$form, self]);
                    })
                    .always(function() {
                        self.$buttons.enable();
                        PHD.hideLoadingIndicator(load);
                        if (isStateless) {
                            // create stateless - turn off timers.
                            var scope = angular.element(document).scope();
                            scope.enableTimers();
                        }
                    });
            }

            return this;
        };
    }


    function updatePieValues(d2d, ir) {
        var obj = {};
        obj.allowed = ir;
        obj = JSON.stringify(obj);
        // now set ir and d2d (if not virtual).
        PHD.Ajax
            .put("/api/storage/ir", obj)
            .done(function(data) {
                /*obj = {};
                obj.allowed = d2d;
                obj = JSON.stringify(obj);
                PHD.Ajax
                    .put("/api/storage/d2d", obj)
                    .done(function(data) {

                    })
                    */
            });
    }

    function initPieChart() {
        var d2d = parseInt($d2d.val(), 10) / 100,
            ir = parseInt($ir.val(), 10) / 100;

        var $pie = $("#allocation-pie");
        // no pie for IR, or for anything but internal storage.
        if ($pie.html() !== undefined) {
            paper = createpieChart("allocation-pie");
            if (d2d > ir) {
                ir =(ir > 0) ? ir : MINPERCENT;
                d2d =(d2d > 0) ? d2d : MINPERCENT;
                updatepieChart(paper, [d2d, ir], ["#5693d6", "#eae46e"]);
            } else {
                ir =(ir > 0) ? ir : MINPERCENT;
                d2d =(d2d > 0) ? d2d : MINPERCENT;
                updatepieChart(paper, [d2d, ir], ["#eae46e", "#5693d6"]);
            }
        }
    }

    function populateAttachedDiskFields() {
        $attached.html(
            $includedTable.find("tbody tr td[data-source=name]").map(function() {
                return '<input type="hidden" id="attached-disks" name="properties.attached_disks" value="' + $(this).text() + '">';
            }).get().join("")
        );
    }


    function getDiskUsageString(numDisks, totalDiskSize) {
        var fmt = ngettext("Using %(num_disks)s attached disk (%(total_disk_size)s)", "Using %(num_disks)s attached disks (%(total_disk_size)s)", numDisks);
        return interpolate(fmt, { num_disks: numDisks, total_disk_size: totalDiskSize}, true);
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        DiskManager = new Disks($form.find(".bds-disks")).init();

        PHD.currentDialog.one("wizardfocus", function() {
            initForm();
            initTables();
            initPieChart();
        });

    });

    var rowTmpl = _.template(
        '<tr class="<%= rowType %>" data-dbid="<%= name %>" data-uuid="<%= uuid %>" data-size="<%= mb_size %>">' +
            '<td data-source="name"><%= name %></td>' +
            '<td><%= uuid %></td>' +
            '<td><%= partitioned %></td>' +
            '<td><%= filesystem %></td>' +
            '<td><%= formatted_size %></td>' +
        '</tr>'
    );

    function createpieChart(holderId) {
        var r = Raphael(holderId);
        return r;
    }

    function updatepieChart(r, dataPointsArray, colorsArray) {
        if (r != null) {
            r.clear();
            if (colorsArray !== undefined) {
                var pie = r.piechart(160, 100, 90, dataPointsArray, {minPercent:MINPERCENT ,colors: colorsArray});
            } else {
                var pie = r.piechart(160, 100, 90, dataPointsArray,{minPercent:MINPERCENT});
            }
        }
    }

    function mapStringToInt(strtype) {
        var type;
        if (strtype == "internal") {
            type = STORAGE_INTERNAL
        } else if (strtype == "iscsi") {
            type = STORAGE_ISCSI;
        } else if (strtype == "nas") {
            type = STORAGE_NAS;
        } else if (strtype == "added_internal") {
            type = STORAGE_ADDED_INTERNAL;
        } else if (type == "fc") {
            type = STORAGE_FC;
        }
        return type;
    }

})(jQuery, window.PHD || (window.PHD = {}), window);
