(function($, PHD, window, undefined) {
    
    var $form = $("#bds-form"),
        CIFSForm,
        $port = $("#id_port"),
        CIFS_REGEX = /^\\\\[a-zA-Z0-9\-\_\.]+\\.+$/,
        NAME_REGEX = /^[a-zA-Z0-9\-\_]+$/,
        $storageID = $("#edit_object_id"),
        $systemID = $("#id_system"),
        portSpinnerOptions = {"min": 1, "max": 10000, "step": 1},
        $toggleCtrl = $form.find(".formset-toggle :checkbox"),
        system_id = PHD.appliance_sid;

    function initForm() {
        $form.find(".definition").popover({
            appendTo: $form,
            position: {
                my: "left bottom",
                at: "right top-15"
            }
        });

        $port.spinner(portSpinnerOptions)

        CIFSForm = PHD.FormController($form, {})
            .validate({
                rules: {
                    name: {
                        required: true,
                        pattern: NAME_REGEX
                    },
                    host: {
                        required: true
                    },
                    share: {
                        required: true
                    }
                    /*
                    path: {
                        required: true,
                        pattern: CIFS_REGEX
                    },
                    */
                },
                messages: {
                    name: {
                        required: gettext("Please name your Storage")
                    },
                    host: {
                        required: gettext("Please provide the CIFS hostname or IP address")
                    },
                    share: {
                        required: gettext("Please provide the CIFS share name")
                    }
                    /*
                    path: {
                        required: gettext("Please enter the CIFS path"),
                        pattern: gettext("Please enter a valid CIFS path")
                    },
                    */
                }
            })
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                $(document).trigger("bdssave", [system_id, data]);
                PHD.currentDialog.wizard("close");
            });
            /*
            .on("formsubmit", function(event, data) {
                    PHD.confirmDialog('<p>' + data.result[0].message + '</p>', {'title': gettext('Confirm Storage Edit')})
                        .done(function() {
                            $override.appendTo($form);
                            BDSForm.submit();
                        });
                }
            });
            */

        if($toggleCtrl.length) {
            var $toManage = $("#id_password, #id_username").prop("disabled", true);

            $toggleCtrl.on("change", function(event) {
                $toManage.prop("disabled", !$(this).prop("checked"));
            });
        }
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        PHD.currentDialog.one("wizardfocus", function() {
            initForm();
        });

    });

})(jQuery, window.PHD || (window.PHD = {}), window);
