(function($, PHD, window, undefined) {

    var $form = $("#form-account"),
        AccountForm,
        $passwordInputs = $form.find("input:password"),
        $toggleCtrl = $form.find(".toggle"),
        $icon = $toggleCtrl.find("i");

    function initForm() {
        $passwordInputs.toggleDisabled();

        AccountForm = PHD.FormController($form, {})
            .validate({
                rules: {
                    username: {
                        required: true,
                        maxlength: 32
                    },
                    /*email: {
                        required: true,
                        email: true
                    },
                    group: {
                        required: true
                    }, */
                    current_password: {
                        required: true
                    },
                    new_password: {
                        required: true,
                        minlength: 1,
                        maxlength: MAX_PASSWORD_LENGTH
                    },
                    confirm_password: {
                        minlength: 1,
                        maxlength: MAX_PASSWORD_LENGTH,
                        equalTo: "#id_password"
                    }
                },
                messages: {
                    username: {
                        required: gettext("Username is required"),
                        maxlength: gettext("Username must not be more than 32 characters")
                    },
                    /*email: {
                        required: gettext("An email address is required")
                    },
                    group: {
                        required: gettext("Company Name is required")
                    }, */
                    current_password: {
                        required: gettext("Password is required")
                    },
                    new_password: {
                        required: gettext("New Password is required"),
                        maxlength: gettext("New Password must not be more than 48 characters")
                    },
                    confirm_password: {
                        equalTo: gettext("Your new password must be entered the same in both fields")
                    }
                }
            })
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                // lmc add close.
                PHD.currentDialog.wizard("close");
                if(data.result[0].code == AJAX_RESULT_SUCCESS) {
                    $(document).trigger("accountedit", [$form.serializeArray()]);
                    PHD.currentDialog.wizard("close");
                } else {
                    PHD.throwError(data);
                }
            });
    }

    $(function() {
        initForm();

        $toggleCtrl.on("click", function(event) {
            var disabled = $icon.is(".icon-unlock");
            disabled ? $icon.alterClass("icon-unlock", "icon-lock") : $icon.alterClass("icon-lock","icon-unlock");
            $passwordInputs.prop("disabled", disabled);
        });
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
