angular.module('dashJobs', [])

    .controller('JobsDashCtrl', ['$scope', '$rootScope', '$http', function($scope, $rootScope, $http) {

        $scope.initCtrl = function() {
            processJobsWidget(PHD, window, $scope, $rootScope);
        }

        //(function($, PHD, window, undefined) {
        function processJobsWidget(PHD, window, $scope, $rootScope) {

            var $widget = $("#widget-active-jobs"),
                $prefTrigger = $widget.find(".preference-trigger"),
                $jobTable = $("#dashboard-jobs"),
                $widgetLinks = $("#active-job-links"),
                ajaxActive = false,
                activeJobType = $widgetLinks.find(".selected").data("job-type"),
                refreshRate = refreshRates.dash_active_job_refresh,
                namespace = "activejobswidget",
                JobTable, UserPreference, Timer;

            var dtOptions = {
                select: false,
                multiselect: false,
                className: "active-jobs",
                cellClasses: ["long-text truncate", "long-text truncate", null, null, null, null],
                placeholder: gettext("There are no active jobs")
            };

            /* lmc
             */
            var cellFormatter = {
                name: function (value, row) {
                    // lmc - change link for job details - TODO - pre-select 1?
                    //            return '<span class="truncates item-name" title="' + value + '"><a href="/jobs/'
                    //            return '<span class="truncates item-name" title="' + value + '"><a href="/jobs/'
                    return '<span class="truncates item-name" title="' + value + '"><a href="#/jobs/?select=' + row.id + '#0">' + value + '</a></span>';
                }
            }

            $widgetLinks.on("click", "a", function (event) {
                event.preventDefault();
                Timer.stop();
                var $but = $(this).parent();
                if (ajaxActive || $but.is(".selected")) {
                    return false;
                }

                $widgetLinks.children("li").removeClass("selected");
                activeJobType = $but.addClass("selected").data("job-type");
                // lmc
                activeJobType = activeJobType.toLowerCase();

                console.log('job type selected: ' + activeJobType);
                updateWidget(false, true);
            });

            function updateWidget(init, change) {

                if (!$rootScope.user.loggedIn) {
                    Timer.rerun();
                    return;
                }

                var url = '/api/jobs/active/' + activeJobType + '/';
                var resp;

                ajaxActive = true;

                if (init === true) {
                    JobTable = PHD.DataTable($jobTable, dtOptions).registerFormatters(cellFormatter);
                    resp = PHD.Ajax.get(url);
                } else {
                    resp = PHD.Ajax.get(url);
                }

                resp.done(function (data) {
                    if (init === true || change === true) {
                        if(JobTable !== undefined) 
						  JobTable.load(data.data);
                    } else {
                        if(JobTable !== undefined)  
						  JobTable.update(data.data, true);
                    }

                    $jobTable.scrollTable({"height": ".widget-content"});
                    ajaxActive = false;

                    if (init === true || change === true) {
                        Timer.start();
                    } else {
                        Timer.resume();
                    }
                });
            }

            UserPreference = PHD.UserPreference($prefTrigger, {
                name: gettext("Active Jobs Widget"),
                namespace: namespace,
                key: "dash_active_job_refresh",
                refresh_name: "Active job refresh",
                defaultValue: refreshRate
            });

            $(document)
                .on("login", function (event) {
                    console.log("=====>Active Jobs, caught LOGIN, name = ", event.name);
                    updateWidget(true);
                    stopAll();
                })
                .on("logout", function (event) {
                    console.log("=====>Active Jobs, LOGOUT");
                    Timer.stop();
                })
                .on("uinav.dashboard", function (event) {
                    console.log("=====>Selected Dashboard");
                })
                .on("uinav.protect", function (event) {
                    console.log("=====>Selected Protect");
                    stopAll();
                })
                .on("uinav.recover", function (event) {
                    console.log("=====>Selected Recover");
                    stopAll();
                })
                .on("uinav.jobs", function (event) {
                    console.log("=====>Selected Jobs");
                    stopAll();
                })
                .on("uinav.configure", function (event) {
                    console.log("=====>Selected Configure");
                    stopAll();
                })
                .on("uinav.reports", function (event) {
                    console.log("=====>Selected Reports");
                    stopAll();
                })
                .on("userpreferencesave." + namespace, function (event, key, value) {
                    refreshRate = value;
                    Timer.setInterval(refreshRate).reset();
                })
                .on("timertick." + namespace, function () {
                    updateWidget();
                })
                .on("timersetmanual." + namespace, function (event, $control, PageTimer) {
                    $control.show();
                })
                .on("timerunsetmanual." + namespace, function (event, $control, PageTimer) {
                    $control.hide();
                });

            function stopAll() {
                Timer.stop();
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                $(document).off("userpreferencesave." + namespace);
                $(document).off("timertick." + namespace);
                $(document).off("timersetmanual." + namespace);
                $(document).off("timerunsetmanual." + namespace);
                delete $(document);
            }

            function initialize() {
                Timer = PHD.Timer({
                    namespace: namespace,
                    interval: refreshRate,
                    refreshControl: $("#jobs-widget-preferences .timer-refresh")
                });
            }

            /*
             *   DOM Ready Function
             */
            $(function () {
                Timer = PHD.Timer({
                    namespace: namespace,
                    interval: refreshRate,
                    refreshControl: $("#jobs-widget-preferences .timer-refresh")
                });

                updateWidget(true);
            });

        }
        //})(jQuery, window.PHD || (window.PHD = {}), window);
    }]);
