angular.module('dashAlerts', [])

    .controller('AlertsDashCtrl', ['$scope', '$rootScope', '$http', function($scope, $rootScope, $http) {

        $scope.initCtrl = function() {
            processAlertsWidget(PHD, window, $scope, $rootScope);
        }

        //(function($, PHD, window, undefined) {
        function processAlertsWidget(PHD, window, $scope, $rootScope) {
            var $widget = $("#widget-alerts"),
                $prefTrigger = $widget.find(".preference-trigger"),
                $btnDismissAll = $widget.find(".btn-dismiss-all"),
                $alertsTable = $("#dashboard-alerts"),
                $alertsIcon = $("h1.alerts"),
                $alertDetail = $(),
                timestamp = 0,
                refreshRate = refreshRates.dash_alert_refresh,
                namespace = "alertswidget",
                AlertsTable, UserPreference, Timer;

            var dataTableOptions = {
                select: true,
                multiselect: false,
                className: "alert",
                cellClasses: [null, null, null, "alert-message"],
                placeholder: gettext("There are no unresolved alerts")
            };

            var alertTmpl = _.template(
                '<p><strong><%= message %></strong></p>' +
                '<% if(typeof(insert_date) !== "undefined") { %><p><label>Date:</label><span><%= moment(insert_date).format("MM/DD/YYYY hh:mm A") %></span></p><% } %>' +
                '<% if(typeof(created) !== "undefined") { %><p><label>Date:</label><span><%= moment(created).format("MM/DD/YYYY hh:mm A") %></span></p><% } %>' +
                '<% if(typeof(updated) !== "undefined") { %><p><label>Updated:</label><span><%= moment(updated).format("MM/DD/YYYY hh:mm A") %></span></p><% } %>' +
                '<% if(typeof(alert_type) !== "undefined") { %><p><label>Alert Type:</label><span><%= alert_type %></span></p><% } %>' +
                '<% if(typeof(source_name) !== "undefined") { %><p><label>Alert Source:</label><span><%= source_name %></span></p><% } %>' +
                '<% if(typeof(sname) !== "undefined") { %><p><label>Appliance:</label><span><%= sname %></span></p><% } %>' +
                '<% if(typeof(management) !== "undefined") { %><p><label>Environment:</label><span><%= management.data.ip %></span></p><% } %>' +
                '<% if(typeof(layer) !== "undefined") { %><p><label>Appliance:</label><span><%= layer.data.ip %></span></p><% } %>' +
                '<% if(typeof(inventory) !== "undefined") { %><p><label>Inventory:</label><span><%= inventory.data.name %></span></p><% } %>' +
                '<p><a href="<%= kburl %>" class="btn-alert-kb text-success" target="phdvbhelp"><i class="icon-bookalt"></i> Knowledge Base</a>' +
                '<a href="/api/alerts/<%= id %>" class="btn-dismiss-alert text-critical"><i class="icon-delete"></i> Dismiss Alert</a></p>'
            );

            var cellFormatter = {
                /*alert_type: function (value, row) {

                    var type = row.alert_type;
                    var iconclass = "icon-";


                    switch (type) {
                        case ALERT_TYPE_UNKNOWN:
                            iconclass += "questionsign";
                            break;
                        case ALERT_TYPE_LICENSE_EXPIRED:
                        case ALERT_TYPE_LICENSE_INVALID:
                            iconclass += "exclamationsign";
                            break;
                        case ALERT_TYPE_UPDATES_AVAILABLE:
                        case ALERT_TYPE_UPDATE_COMPLETE:
                            iconclass += "upload";
                            break;
                        case ALERT_TYPE_EMAIL_ERROR:
                        case ALERT_TYPE_SMTP_NOT_CONFIGURED:
                            iconclass += "emailtrace";
                            break;
                        default:
                            iconclass += "warningsign";
                    }

                    return '<i class="' + iconclass + ' alert-type-icon" title="' + value + '"></i>';
                },
                */
                severity: function (value, row) {

                    var alert_severity = row.severity;
                    var iconclass = "icon-";

                    switch (alert_severity) {
                        case ALERT_SEVERITY_NOTICE:
                            iconclass += "upload";
                            break;
                        case ALERT_SEVERITY_CRITICAL:
                            iconclass += "exclamationsign";
                            break;
                        case ALERT_SEVERITY_WARNING:
                        default:
                            iconclass += "warningsign";
                            break;
                    }

                    return '<i class="' + iconclass + ' severity-icon" title="' + alert_severity + '"></i>';
                },
                insert_date: function (value) {
                    return moment(value).format("MM/DD/YYYY hh:mm a");
                },
                created: function (value) {
                    return moment(value).format("MM/DD/YYYY hh:mm a");
                }
            };

            function updateWidget(init) {

                if (!$rootScope.user.loggedIn) {
                    Timer.rerun();
                    return;
                }
                var url = API_DIR + '/alerts/open/?timestamp=' + timestamp;

                var resp = PHD.Ajax.get(url);

                if (init === true) {
                    AlertsTable = PHD.DataTable($alertsTable, dataTableOptions).registerFormatters(cellFormatter);
                }

                resp.done(function (data) {
                    if (data && data.data !== undefined) {
                        timestamp = data.timestamp;
                        data = data.data;

                        if (init) {
                           if(AlertsTable !== undefined) AlertsTable.load(data);
                        } else {
                            PHD.updateAlerts(true, data.length);
                            if(AlertsTable !== undefined) AlertsTable.update(data, true);
                        }

                        $alertsTable
                            .scrollTable({"height": ".widget-content"});

                        if (init) {
                            Timer.start();
                        } else {
                            Timer.resume();
                        }
                    }
                });
            }

            $alertsTable
                .on("updatefinished", function (event, newRows) {
                    if (newRows) {
                        $alertsTable.sortTable();
                        $alertsIcon.animate({opacity: 0}, 500, function () {
                            $alertsIcon.animate({opacity: 1}, 500);
                        });
                    }
                })
                .on("rowselect", "tr", function (event, dbid, $row, DataTable, DataRow) {
                    DataTable.deselect();
                    if ($row.data('popover')) {
                        $row.data('popover').toggle();
                    } else {
                        var data = DataRow.data,
                            html;

                        data.kburl = alertURL(alert.source_id);
                        html = alertTmpl(data);

                        $alertDetail = $("<div>");
                        $alertDetail.html(html)
                            .on("click", ".btn-dismiss-alert", function (e) {
                                e.preventDefault();
                                if (data.severity == ALERT_SEVERITY_CRITICAL) {
                                    if ($row.data('popover')) {
                                        $row.data('popover').toggle();
                                    }
                                    PHD.confirmDialog("<p>" + gettext("This alert is critical.  Are you sure you want to dismiss it?") + "</p>", {
                                        title: gettext("Confirm Alert Dismissal")
                                    })
                                        .done(function() {
                                            doDelete($row, data, DataTable, true);
                                        }
                                    )
                                } else {
                                    doDelete($row, data, DataTable, true);
                                }
                            })
                            .popover({
                                anchor: $row,
                                appendTo: $widget,
                                popoverClass: 'alert-detail',
                                position: {
                                    my: "right top",
                                    at: "right top"
                                }
                            });

                        $row.data('popover').open();
                    }
                });

            function doDelete($row, data, DataTable, fetch) {
                var sid = data.system_id;
                var id = data.id;
                var url = "/api/alerts/" + id + '/?sid=' + sid;
                var doFetch = fetch || false;
                PHD.Ajax
                    .delete(url)
                    .done(function (data) {
                        if ($row != null && $row.data('popover')) {
                            $row.data('popover').destroy();
                        }
                        DataTable.deleteRow(id);
                        if (DataTable.dbids.length === 0) {
                            AlertsTable.showPlaceholder();
                        }
                        if (doFetch) {
                            updateWidget();
                            // fetch stats here, it will update alert count.
                            PHD.fetchStats();
                        }
                    });
            }

            function alertURL(type) {
                var url = KNOWLEDGE_BASE_URL,
                    article = ALERT_HELP_LINKS.hasOwnProperty(type) ? ALERT_HELP_LINKS[type] : ALERT_HELP_LINKS[ALERT_TYPE_UNKNOWN];

                // -- need consolidation of this!! lmc return url + article;
                return url;
            }

            function handleDismissAll(event) {
                PHD.confirmDialog("<p>" + gettext("Please take care when dismissing alerts, especially if some are critical.") + '</p>' +
                                  '<p>' + gettext("Are you sure you would like to dismiss all alerts?") + '</p>', {
                    title: gettext("Confirm Alert Dismissal")
                })
                    .done(function() {
                        AlertsTable.data.forEach(function(alert, i, array) {
                            doDelete(null, alert, AlertsTable, true);
                        });
                    });
            }

            UserPreference = PHD.UserPreference($prefTrigger, {
                name: gettext("Alerts Widget"),
                namespace: "alertswidget",
                key: "dash_alert_refresh",
                refresh_name: "Alert refresh",
                defaultValue: refreshRate
            });

            $(document)
                .on("login", function (event) {
                    console.log("=====>Alerts, caught LOGIN, name = ", event.name);
                    updateWidget(true);
                    stopAll();
                })
                .on("logout", function (event) {
                    console.log("=====>Alerts, LOGOUT");
                    Timer.stop();
                })
                .on("uinav.dashboard", function (event) {
                    console.log("=====>Selected Dashboard");
                })
                .on("uinav.protect", function (event) {
                    console.log("=====>Selected Protect");
                    stopAll();
                })
                .on("uinav.recover", function (event) {
                    console.log("=====>Selected Recover");
                    stopAll();
                })
                .on("uinav.jobs", function (event) {
                    console.log("=====>Selected Jobs");
                    stopAll();
                })
                .on("uinav.configure", function (event) {
                    console.log("=====>Selected Configure");
                    stopAll();
                })
                .on("uinav.reports", function (event) {
                    console.log("=====>Selected Reports");
                    stopAll();
                })
                .on("userpreferencesave." + namespace, function (event, key, value) {
                    console.log("=====>alerts preference save rate = " + refreshRate);
                    refreshRate = value;
                    Timer.setInterval(refreshRate).reset();
                })
                .on("timertick." + namespace, function () {
                    updateWidget();
                })
                .on("timersetmanual." + namespace, function (event, $control, PageTimer) {
                    $control.show();
                })
                .on("timerunsetmanual." + namespace, function (event, $control, PageTimer) {
                    $control.hide();
                });

            function stopAll() {
                Timer.stop();
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                $(document).off("userpreferencesave." + namespace);
                $(document).off("timertick." + namespace);
                $(document).off("timersetmanual." + namespace);
                $(document).off("timerunsetmanual." + namespace);
                delete $(document);
            }

            /*
             *   DOM Ready Function
             */
            $(function () {
                Timer = PHD.Timer({
                    namespace: namespace,
                    interval: refreshRate,
                    refreshControl: $("#alert-widget-preferences .timer-refresh")
                });

                $btnDismissAll.on("click", handleDismissAll);

                updateWidget(true);
            });

        }
        //})(jQuery, window.PHD || (window.PHD = {}), window);
    }]);
