/*
angular.module('dashboard', ['ChartAngular'])
*/
angular.module('dashboard', [])

	.controller('DashboardCtrl', ['$scope', '$rootScope', '$http', 'Page', function($scope, $rootScope, $http, Page) {
		
		Page.setTitle('Dashboard');
		
		// Initialize graph values.
		$scope.BACKUP_GRAPH_VALUES = [];
		$scope.BACKUP_GRAPH_TOOLTIPS = [];
		
		$scope.BACKUP_GRAPH2_VALUES =  [ [], [], [] ];
		$scope.BACKUP_GRAPH2_TOOLTIPS = [];
		
		$scope.BACKUP_GRAPH3_VALUES =  [ [], [], [] ];
		$scope.BACKUP_GRAPH3_TOOLTIPS = [ ];
		
		$scope.REPLICATION_GRAPH_VALUES =  [ [], [], [] ];
		$scope.REPLICATION_GRAPH_TOOLTIPS = [];
		
		$scope.RESTORE_GRAPH_VALUES =  [ ];
		$scope.RESTORE_GRAPH_TOOLTIPS = [];
		
		$scope.getSummary = function(token) {	
			// Load summary data for graphs.
			$http({
				method: 'GET',
				url: '/api/summary/days'
			})
			.success(function(data, status, headers) {
                var results = data.data;
                var avg_speed = [];
                var avg_speed_tooltips = [];
                if (results[0] !== null) {
                    var backup_speed = results[0].backup_speed;
                    if (typeof backup_speed !== 'undefined') {
                        for (var i = 0, j = 0; i < backup_speed.length; i++) {
                            var obj = backup_speed[i];
                            avg_speed[j] = obj.avg_speed;
                            avg_speed_tooltips[j] = avg_speed[j].toString() + ' ' + obj.units;
                            j++;
                        }
                    }
                }
                avg_speed = [ avg_speed ];
                $scope.BACKUP_GRAPH_VALUES = avg_speed;
                $scope.BACKUP_GRAPH_TOOLTIPS = avg_speed_tooltips;

                var read_size = [];
                var read_tooltips = [];
                var write_size = [];
                var write_tooltips = [];
                var compress_size = [];
                var compress_tooltips = [];
                if (results[1] !== null) {
                    var backup_size = results[1].backup_size;
                    if (typeof backup_size !== 'undefined') {
                        for (var i = 0, j = 0; i < backup_size.length; i++) {
                            var obj = backup_size[i];
                            read_size[j] = obj.read;
                            write_size[j] = obj.write;
                            compress_size[j] = obj.compress;
                            read_tooltips[j] = read_size[j].toString() + ' ' + obj.units;
                            write_tooltips[j] = write_size[j].toString() + ' ' + obj.units;
                            compress_tooltips[j] = compress_size[j].toString() + ' ' + obj.units;
                            j++;
                        }
                    }
                }
                $scope.BACKUP_GRAPH2_VALUES = [ read_size, write_size, compress_size ];
                $scope.BACKUP_GRAPH2_TOOLTIPS = read_tooltips.concat(write_tooltips, compress_tooltips);

                var read_speed = [];
                var read_tooltips = [];
                var write_speed = [];
                var write_tooltips = [];
                var compress_speed = [];
                var compress_tooltips = [];
                if (results[2] !== null) {
                    var backup_data_speed = results[2].backup_data_speed;
                    if (typeof backup_data_speed !== 'undefined') {
                        for (var i = 0, j = 0; i < backup_data_speed.length; i++) {
                            var obj = backup_data_speed[i];
                            read_speed[j] = obj.read;
                            write_speed[j] = obj.write;
                            compress_speed[j] = obj.compress;
                            read_tooltips[j] = read_speed[j].toString() + ' ' + obj.units;
                            write_tooltips[j] = write_speed[j].toString() + ' ' + obj.units;
                            compress_tooltips[j] = compress_speed[j].toString() + ' ' + obj.units;
                            j++;
                        }
                    }
                }
                $scope.BACKUP_GRAPH3_VALUES = [ read_speed, write_speed, compress_speed ];
                $scope.BACKUP_GRAPH3_TOOLTIPS = read_tooltips.concat(write_tooltips, compress_tooltips);

                var read_speed = [];
                var read_tooltips = [];
                var write_speed = [];
                var write_tooltips = [];
                if (results[3] !== null) {
                    var replication_speed = results[3].replication_speed;
                    if (typeof replication_speed !== 'undefined') {
                        for (var i = 0, j = 0; i < replication_speed.length; i++) {
                            var obj = replication_speed[i];
                            read_speed[j] = obj.read;
                            write_speed[j] = obj.write;
                            read_tooltips[j] = read_speed[j].toString() + ' ' + obj.units;
                            write_tooltips[j] = write_speed[j].toString() + ' ' + obj.units;
                            j++;
                        }
                    }
                }
                $scope.REPLICATION_GRAPH_VALUES =  [ read_speed, write_speed ];
                $scope.REPLICATION_GRAPH_TOOLTIPS = read_tooltips.concat(write_tooltips);

                var avg_speed = [];
                var avg_speed_tooltips = [];
                if (results[4] !== null) {
                    var restore_speed = results[4].restore_speed;
                    if (typeof restore_speed !== 'undefined') {
                        for (var i = 0, j = 0; i < restore_speed.length; i++) {
                            var obj = restore_speed[i];
                            avg_speed[j] = obj.avg_speed;
                            avg_speed_tooltips[j] = avg_speed[j].toString() + ' ' + obj.units;
                            j++;
                        }
                    }
                }
                avg_speed = [ avg_speed ];
                $scope.RESTORE_GRAPH_VALUES = avg_speed;
                $scope.RESTORE_GRAPH_TOOLTIPS = avg_speed_tooltips;

                var avg_speed = [];
                var avg_speed_tooltips = [];
                if (results[5] !== null) {
                    var archive_speed = results[5].archive_speed;
                    if (typeof archive_speed !== 'undefined') {
                        for (var i = 0, j = 0; i < archive_speed.length; i++) {
                            var obj = archive_speed[i];
                            avg_speed[j] = obj.avg_speed;
                            avg_speed_tooltips[j] = avg_speed[j].toString() + ' ' + obj.units;
                            j++;
                        }
                    }
                }
                avg_speed = [ avg_speed ];
                //$scope.RESTORE_GRAPH_VALUES = avg_speed;
                //$scope.RESTORE_GRAPH_TOOLTIPS = avg_speed_tooltips;
			})
			.error(function(data, status, headers) {
				
			});
		};
		$rootScope.getSummary = $scope.getSummary;

        /*
         * Given a specified report ID, run it without user selection.  If no days passed, assume 7 (1 week).
         */
        $scope.runReport = function(reportID, days) {
            days = days || 0;
            location.href = "#/reports/" + reportID + '/' + days;
        };

        // if we are logged in, call the summary.
		if ($scope.user.loggedIn) {
			$scope.getSummary($scope.user.token);
		}

	}]);
