angular.module('dashRecover', [])

    .controller('RecoverDashCtrl', ['$scope', '$rootScope', '$http', function($scope, $rootScope, $http) {

        $scope.initCtrl = function () {
            processRecoverWidget(PHD, window, $scope, $rootScope);
        }

        function processRecoverWidget(PHD, window, $scope, $rootScope) {


            var $recoverWidget = $("#widget-recover"),
                $recoverTrigger = $recoverWidget.find(".preference-trigger"),
                recoverRefreshRate = refreshRates.dash_restore_refresh,
                recoverNamespace = "recoverwidget",
                RecoverUserPreference,
                RecoverTimer;

            var pluralizer = {
                "restore_recent": function (count) {
                    return ngettext("Recent Restore", "Recent Restores", count);
                }
            };

            function updateWidget(init) {

                var subsystem = "/restore/";
                if (!$rootScope.user.loggedIn) {
                    RecoverTimer.rerun();
                    return;
                }

                var url = '/api/summary/counts' + subsystem;
                $.ajax(url, {
                    dataType: 'json',
                    success: function (data) {
                        $(".status-number").each(function (index) {
                            var $el = $(this),
                                key = $el.attr("id"),
                                $plural = $el.next(".plural");

                            if (data.hasOwnProperty(key)) {
                                $el.text(data[key]);
                                if ($plural.length)
                                    $plural.text(pluralizer[key](data[key]));
                            }
                        });

                        refreshRecover(init);
                    },
                    error: function () {
                        // TODO:handle error
                        //alert("Status Error");
                    }
                });
            }

            function refreshRecover(init) {
                if (init === true) {
                    RecoverTimer.start();
                } else {
                    RecoverTimer.resume();
                }
            }

            RecoverUserPreference = PHD.UserPreference($recoverTrigger, {
                name: gettext("Recover Widget"),
                namespace: "recoverwidget",
                key: "dash_restore_refresh",
                refresh_name: "Restore refresh",
                defaultValue: recoverRefreshRate
            });

            $(document)
                .on("login", function (event) {
                    console.log("=====>Status, caught LOGIN, name = ", event.name);
                    updateWidget(true);
                    stopAll();
                })
                .on("logout", function (event) {
                    console.log("=====>Status, LOGOUT");
                    stopAll();
                })
                .on("uinav.dashboard", function (event) {
                    console.log("=====>Selected Dashboard");
                })
                .on("uinav.protect", function (event) {
                    console.log("=====>Selected Protect");
                    stopAll();
                })
                .on("uinav.recover", function (event) {
                    console.log("=====>Selected Recover");
                    stopAll();
                })
                .on("uinav.jobs", function (event) {
                    console.log("=====>Selected Jobs");
                    stopAll();
                })
                .on("uinav.configure", function (event) {
                    console.log("=====>Selected Configure");
                    stopAll();
                })
                .on("uinav.reports", function (event) {
                    console.log("=====>Selected Reports");
                    stopAll();
                })
                .on("userpreferencesave.recoverwidget", function (event, key, value) {
                    recoverRefreshRate = value;
                    RecoverTimer.setInterval(recoverRefreshRate).reset();
                })
                .on("timertick." + recoverNamespace, function () {
                    updateWidget();
                })
                .on("timersetmanual." + recoverNamespace, function (event, $control, PageTimer) {
                    $control.show();
                })
                .on("timerunsetmanual." + recoverNamespace, function (event, $control, PageTimer) {
                    $control.hide();
                });


            function stopAll() {
                RecoverTimer.stop();
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                $(document).off("userpreferencesave." + recoverNamespace);
                $(document).off("timertick." + recoverNamespace);
                $(document).off("timersetmanual." + recoverNamespace);
                delete $(document);
            }
            /*
             *   DOM Ready Function
             */
            $(function () {
                RecoverTimer = PHD.Timer({
                    namespace: recoverNamespace,
                    interval: recoverRefreshRate,
                    refreshControl: $("#recover-widget-preferences .timer-refresh")
                });

                /*$(".job-explorer-pop-out").on("click", function (event) {
                    event.preventDefault();
                    PHD.popOut($(this).attr("href"), gettext("Job Explorer"), "view_job_explorer", 1024, 768);
                });
                */
                updateWidget(true);
            });
        }
    }]);
