(function($, PHD, window, undefined) {

    var $tour = $("#dashboard-tour"),
        $header = $("#tour-header"), $headerTarget = $("#widget-tour"),
        $btnclose = $("#tour-close"),
        $account = $("#tour-account"), $accountTarget = $("#header-nav .user-menu"),
        $jobs = $("#tour-jobs"), $jobsTarget = $("#nav-jobs"),
        $config = $("#tour-config"), $configTarget = $("#nav-configure"),
        $widget = $("#tour-widget"), $widgetTarget = $("#widget-storage");


    function initTour() {
        $(window).on("resize.tour",  PHD.util.debounce(positionTour));
        positionTour();
        $tour.addClass("active");
    }

    function positionTour() {
        $header.position({
            my: "center",
            at: "center",
            of: $headerTarget,
            using: positionElement
        });
        $account.position({
            my: "right top-15",
            at: "left bottom",
            of: $accountTarget,
            using: positionElement
        });
        $jobs.position({
            my: "left-30 top-10",
            at: "right center",
            of: $jobsTarget,
            using: positionElement
        });
        $config.position({
            my: "left-30 top-10",
            at: "right center",
            of: $configTarget,
            using: positionElement
        });
        $widget.position({
            my: "right-40 top+15",
            at: "center",
           <!-- at: "right top", -->
            of: $widgetTarget,
            using: positionElement
        });
    }

    function positionElement(attr, obj) {
        obj.element.element.css({
            top: attr.top,
            left: attr.left,
            position: 'absolute'
        });
    }

    function endTour() {
        $(window).off("resize.tour");
        $tour.remove();
        PHD.Ajax.post('/preferences/', "key=tour_activated&value=False");
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        console.log("------------**************Made it to the DOM***************---------");
        $btnclose.on("click", function() {
            endTour();
        });

        setTimeout(initTour, 1000);
    });

})(jQuery, window.PHD || (window.PHD = {}), window);