angular.module('dailyFeedWidgetModule',['dynamicdashboardapp','ui.dashboard','ngSanitize'])

/* getDailyFeedFactory factory class.
 * Define function to fetch unitrends forum posts from backend.
 */
.factory('getDailyFeedFactory', function ($http){
    return{
        getDailyFeed:function(url){
               var promise=$http({
               url: url, 
               method: "get"
               }).success(function(data, status, headers){

                  }).error(function(){
                   console.log("error in getting unitrends forum posts");
                  });
            return promise;
        }
    }
})

.filter('html_bind_text', ['$sce', function($sce){
        return function(text) {
            return $sce.trustAsHtml(text);
        };
}])

/* Daily Feed Widget Contorller */
.controller('DailyFeedWidgetController',function ($scope,$rootScope,$http,$timeout,getDailyFeedFactory){
    $scope.refreshKey="dash_daily_feed_refresh";
    $scope.widgetName="Daily Feed";
	$scope.dailyFeedTimer=3000;
    $scope.dropdownvalue="0";
    $scope.feeds = [];
  
    /*Function to load The Widget*/
    $rootScope.getDailyFeed = function(){
        getDailyFeedFactory.getDailyFeed("app/dynamic-dashboard/assets/data/DailyFeedData.json").then(function(result){
            $scope.feeds = result.data.data;
        });

    }
    
    //************************************** Refresh Forum Widget ************************

    /* Click Event Listener for open configure model dialog box  */
    $scope.modalShown=false;
    $scope.toggleModal=function(){
	        $scope.modalShown=!$scope.modalShown;
    };

    /* Event listener for dialogopenEvent */
    $scope.$on('dialogopenEvent', function (event, widget,index){
        if(widget.name === 'DAILY FEED'){
            $scope.toggleModal();
			$scope.dropdownvalue = $rootScope.dailyFeedTimer /1000;
			 $("[id='id_daily feedRefresh']").val($rootScope.listOfTimer[5]/1000);
			event.defaultPrevented = true;
        }
    });
    
    /* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
         if(widget.name === 'DAILY FEED'){
            $scope.getDailyFeed();
            event.defaultPrevented = true;
		    
         }
    });
    
    /*to Get User prefrence*/
	$scope.userPrefernce = function(){
	    $rootScope.manualRefreshControl($rootScope.listOfTimer[5]/1000,$scope.widgetName);
	    $("[id='IDDAILY FEED']").css("display","none");
	    $("[id='toruidDAILY FEED'] .configwidget").css("display","none");
	};

    // Load twitter widget if defined.
    $scope.loadTwitterWidget = function() {
        if (twttr !== undefined) {
            //console.log("load twitter");
            twttr.widgets.load();
        }
    };

	if ($scope.user.loggedIn){
		$scope.userPrefernce();
		$scope.getDailyFeed();
        // retry the twitter widget load if not available.
        $timeout($scope.loadTwitterWidget, 500);
    }
	
    $(document)
		.on("login", function (event){
			$scope.getDailyFeed();
            stopAll();
		})
		.on("logout", function (event) {
			stopAll();
		})
		.on("uinav.dashboard", function (event) {

		})
		.on("uinav.protect", function (event) {
			stopAll();
		})
		.on("uinav.recover", function (event) {
			stopAll();
		})
		.on("uinav.jobs", function (event) {
			stopAll();
		})
		.on("uinav.configure", function (event) {
			stopAll();
		})
		.on("uinav.reports", function (event) {
			stopAll();
		})

	function stopAll(){
	    clearInterval($rootScope.listOfTimerFunction[5]);
            $(document).off("login");
            $(document).off("logout");
            $(document).off("uinav");
            delete $(document);
	} 

});