angular.module('dynamicdashboardapp',['ui.dashboard'])

/* Factory class which inherit of WidgetDataModel from ui.dashboard module */
.factory('RandomDataModel', function ($interval, WidgetDataModel){
    function RandomDataModel(){
    }

    RandomDataModel.prototype=Object.create(WidgetDataModel.prototype);
    RandomDataModel.prototype.constructor=WidgetDataModel;

    angular.extend(RandomDataModel.prototype,{
      init: function (){
        var dataModelOptions=this.dataModelOptions;
        this.limit=(dataModelOptions && dataModelOptions.limit) ? dataModelOptions.limit : 100;

        this.updateScope('-');
        this.startInterval();
      }
     });

    return RandomDataModel;
})

/* widgetDefinitions factory class.
 * Define all widget definitations
 */
.factory('widgetDefinitions', function(RandomDataModel){
    return [
    {
        name: 'COMMUNITY',
        templateUrl: 'app/dynamic-dashboard/topforumposts/topForumPostsWidget.html',
        style:{
            width: '65%',
            height:'300px'

        },
        isshow:false
    },
    {
        name: 'BACKUP SUMMARY',
        templateUrl: 'app/dynamic-dashboard/backup/backupWidget.html',
        style:{
            width: '34%',
            height:'300px'
        },
        isshow:false
    },
    {
        name: 'ACTIVE JOBS',
        templateUrl: 'app/dynamic-dashboard/activejobs/activeJobsWidget.html',
        style:{
            width: '65%',
            height:'220px'
        },
        isshow:false
    },
    {
        name: 'DAILY FEED',
        templateUrl: 'app/dynamic-dashboard/dailyfeed/dailyFeedWidget.html',
        style:{
            width: '34%',
            height:'440px'
        },
        isshow:false
    },
    {
        name: 'STORAGE',
        templateUrl: 'app/dynamic-dashboard/storage/storageWidget.html',
        style:{
            width: '65%',
            height:'220px'
        },
        isshow:false
    }];
})

/* userWidgetPreferenceFactory factory class.
 * Define function to fetch user widget preference from backend.
 */
.factory('userWidgetPreferenceFactory', function ($http){
    return{
        getUserWidgetPreference:function(url){
               var promise=$http({
               url: url, 
               method: "get"
               }).success(function(data, status, headers){

                  }).error(function(){
                   console.log("error in getting user preference widget selection");
                  });
            return promise;
        }
    }
})

/* modalDialog directive.
 * Define pop up dialog for configure widget when click configuration button.
 */
.directive('modalDialog', function(){
    return{
    restrict: 'E',
    scope:{
      show: '='
    },
    replace: true, // Replace with the template below
    transclude: true, // we want to insert custom content inside the directive
    link: function(scope, element, attrs){
      scope.dialogStyle={};
      if (attrs.width)
        scope.dialogStyle.width=attrs.width;
      if (attrs.height)
        scope.dialogStyle.height=attrs.height;
      scope.hideModal=function(){
        scope.show=false;
      };
    },
    template: "<div class='ng-modal' ng-show='show'><div class='ng-dashboardmodeldialog-dialog' ng-style='dialogStyle'><div class='ng-dashboardmodeldialog-dialog-content' ng-transclude></div></div></div>"
    };
})

/* Dynamic Dashboard Controller is main controller for dynamic dashboard. */
.controller('DynamicDashboardController', function ($scope, $rootScope, $interval, $window, Page, widgetDefinitions, userWidgetPreferenceFactory){
    /* scope variable defination */
    $scope.tempdefaultwidget=widgetDefinitions;
    $scope.selected_widget=[];
    $scope.userWidgetPrefernce=[];  
    $scope.isDropDownBoxShow=false;
    Page.setTitle('Dashboard');
    
    /* code for persist widget while drag-drop.
   /* if(($window.localStorage != undefined) && ($window.localStorage.length != 0)){
        
        //comment if block code.
        $scope.userWidgetPrefernce.removeAll();
        var JSONobj = JSON.parse($window.localStorage.explicitSave);
        
        for(var i=0;i<(JSONobj.widgets).length;i++){
            var objWidget={};
            
            objWidget = JSONobj.widgets[i];
            objWidget.isshow:true;
            
            $scope.userWidgetPrefernce.push(objWidget);
        }
        
        $scope.$broadcast('defaultWidgetReadyEvent',$scope.userWidgetPrefernce);
        */
    /*}else{
        // call function to fetch user widget preference list and set into dashboard
         userWidgetPreferenceFactory.getUserWidgetPreference("app/dynamic-dashboard/assets/data/userWidgetPreference.json").then(
          function(result){
            for(var i=0; i < (result.data.data).length;i++){
                var objWidget={};

                if(i%2 == 0){
                    objWidget={
                        name: result.data.data[i].name,
                        style:{
                            width: '65%',
                            height:'300px'
                        },
                        isshow:true
                      };
                    if (objWidget.name == 'ACTIVE JOBS' || objWidget.name == 'STORAGE') {
                        objWidget.style = {
                            width: '65%',
                            height: '220px'
                        }
                    }
                }
                else{
                    //code for daily feed size
                     if (result.data.data[i].name=='DAILY FEED')
                     {
                        objWidget={
                         name: result.data.data[i].name,
                            style:{
                                width: '34%',
                                height:'440px',
                                float:'right',
                                "margin-left":'-5px',
                                "margin-right":'15px'
                            },
                            isshow:true
                          };
                    }
                    else
                    {
                      objWidget={
                        name: result.data.data[i].name,
                        style:{
                            width: '34%',
                            height:'300px'
                        },
                        isshow:true
                      };
                    }
                }
               $scope.userWidgetPrefernce.push(objWidget);
            }
             $scope.$broadcast('defaultWidgetReadyEvent',$scope.userWidgetPrefernce);
        });
    }*/
    
    
    /* call function to fetch user widget preference list and set into dashboard */
     userWidgetPreferenceFactory.getUserWidgetPreference("app/dynamic-dashboard/assets/data/userWidgetPreference.json").then(function(result){
        for(var i=0; i < (result.data.data).length;i++){
            var objWidget={};

            if(i%2 == 0){
                objWidget={
                    name: result.data.data[i].name,
                    style:{
                        width: '65%',
                        height:'300px'
                    },
                    isshow:true
                  };
                if (objWidget.name == 'ACTIVE JOBS' || objWidget.name == 'STORAGE') {
                    objWidget.style = {
                        width: '65%',
                        height: '220px'
                    }
                }
            }
            else{
                /*code for daily feed size*/
			     if (result.data.data[i].name=='DAILY FEED')
			     {
                    objWidget={
                     name: result.data.data[i].name,
                        style:{
                            width: '34%',
                            height:'440px',
                            float:'right',
                            "margin-left":'-5px',
                            "margin-right":'15px'
                        },
                        isshow:true
                      };
                }
                else
                {
                  objWidget={
                    name: result.data.data[i].name,
                    style:{
                        width: '34%',
                        height:'300px'
                    },
                    isshow:true
                  };
                }
            }
           $scope.userWidgetPrefernce.push(objWidget);
        }

         $scope.$broadcast('defaultWidgetReadyEvent',$scope.userWidgetPrefernce);
    });

    /* Event listener for defaultWidgetReadyEvent. */
    $scope.$on('defaultWidgetReadyEvent', function (event, userWidgetPrefernce){
	 /* reset of tempdefaultwidget Array isshow = false*/
	      for (var k = 0; k < (($scope.tempdefaultwidget).length); k++) {
		    $scope.tempdefaultwidget[k].isshow = false;
		  }
	  /* end of reseting of tempdefaultwidget */
	
        for(var i=0;i<userWidgetPrefernce.length;i++){
            $scope.dashboardOptions.addWidget(userWidgetPrefernce[i], true);
            $scope.selected_widget.push(userWidgetPrefernce[i]);

            for (var j=0; j < (($scope.tempdefaultwidget).length); j++){
                if (userWidgetPrefernce[i].name != undefined  && $scope.tempdefaultwidget[j].name === userWidgetPrefernce[i].name){
                    $scope.tempdefaultwidget[j].isshow=true;
                }
            }
        }
    });

    /* Set dashboard options and set as value of dashboard attribute in dashboard.html */
    $scope.dashboardOptions={
        widgetButtons: false,
        widgetDefinitions: $scope.tempdefaultwidget,
        defaultWidgets: $scope.userWidgetPrefernce,
        storage: $window.localStorage,
        storageId: 'explicitSave',
        explicitSave: true,  // false if want to store in local storage. 
        enableHorizontalResize:false,
        enableVerticalResize:false
    };

    /* function to remove/add widgets on page based on check/uncheck in drop-down list */
    $scope.toggleSelection=function toggleSelection(widget){
        widget.isshow=(!widget.isshow);

        if(widget.isshow === false){
          $scope.dashboardOptions.removeWidget(widget);
        }else if (widget.isshow === true){
          $scope.dashboardOptions.addWidget(widget, true);
          $scope.selected_widget.push(widget);
        }
    };

    /* Event listener of removeWidgetEvent */
    $scope.$on('removeWidgetEvent', function (event, widget){
        for (var i=0; i < (($scope.tempdefaultwidget).length); i++){
            if ( widget.name != undefined  && $scope.tempdefaultwidget[i].name === widget.name){
                $scope.tempdefaultwidget[i].isshow=false;
                break;
            }
        }

        for (var i=0; i < (($scope.selected_widget).length); i++){
            if ( widget.name != undefined  && $scope.selected_widget[i].name === widget.name){
                $scope.selected_widget[i].isshow=false;
                $scope.selected_widget.splice(i, 1);
                break;
            }
        }
    });

    /* click event function to animate widget list as slide down. */
    $('.selected-items-box').bind('click', function(e){
        e.stopPropagation();
        $('.multiple-select-wrapper .list').toggle('slideDown');
    });

    /* click event for widget list */
    $('.multiple-select-wrapper .list').bind('click', function(e){
        e.stopPropagation();
    });

    /* click event function to animate widget list as slide up. */
    $(document).bind('click', function(){
        $('.multiple-select-wrapper .list').slideUp();	
    });

    /* function for selected items. */
    $scope.getSelectedItemsOnly=function(item){
        return item.selected;
    };
})