var storageWidgetModule = angular.module('storageWidgetModule',['dynamicdashboardapp','ui.dashboard']);

storageWidgetModule.controller('storageWidgetCtrl', ['$scope', '$rootScope', '$http', function($scope, $rootScope, $http){
    
			$scope.refreshKey="dash_storage_refresh";
			$scope.widgetName="Storage";
			$scope.dropdownvalue="0";

            var $widget = $("#widget-storage"),
                $prefTrigger = $widget.find(".preference-trigger"),
                $storageTable = $("#dashboard-storage"),
                $storageTotalProgress = $("#storage-widget-total-progress"),
                refreshRate = refreshRates.dash_storage_refresh,
                namespace = "storagewidget",
                StorageTable, UserPreference,
                threshold_lookup = [];

            var dtOptions = {
                select: false,
                multiselect: false,
                className: "storage",
                cellClasses: ["long-text truncate", "long-text truncate", null, "table-icon-small", null, null]
            };


             function usageLookup(usage) {
                var icon = '<i class="icon-uui-backup' + ' icon-large text-standard" title="' + 'Backup' + '"></i> ';
                if (usage == 'archive') {
                    icon = '<i class="icon-uui-backup-copy icon-large text-standard" title="' + 'Backup Copy' + '"></i> ';
                }
                return icon;
            }

            var storage_icon_map = {};
            storage_icon_map[""] = "harddrive";
            storage_icon_map["internal"] = "harddrive";
            storage_icon_map["stateless"] = "harddrive";
            storage_icon_map["disk"] = "harddrive";
            storage_icon_map["iscsi"] = "harddrive";
            storage_icon_map["added_internal"] = "harddrive";

            function getStorageType(row) {
                var type = 'attached';
                var icon_name = 'harddrive';
                if (row.type === 'nas') {
                    if (row.properties !== undefined && row.properties != null) {
                        icon_name = type = row.properties.protocol;
			         }
                } else {
				    icon_name = storage_icon_map[row.type];
			    }
			    var icon = '<i class="icon-uui-' + icon_name + ' icon-large text-standard" title="' + type + '"></i>';
                return icon;
            }
            var cellFormatter = {
				name: function (value, row) {
                    var usageIcon = usageLookup(row.usage),
                        stoIcon = getStorageType(row);
				      return usageIcon + stoIcon+"  "+value;
                },
                mb_free: function (value, row) {
                    var percent_used = row.percent_used,
                        state = "storage-";

                    var used_allocated = "";
                    var color = "";
                    if (row.mb_size !== undefined) {
                        var sizeVal = row.mb_size;
                        var freeVal = row.mb_free;
                        if (sizeVal === 0) {
                            used_allocated = "Not Available";
                            color = "color:gray";
                            percent_used = "100%";
                        } else {
                            var size = PHD.util.formatMB(sizeVal);
                            var used = PHD.util.formatMB(sizeVal - freeVal);
                            used_allocated = "" + used + " / " + size;
                        }
                    }
                    var will_purge = row.mb_to_purge;
                    var to_display = used_allocated;
                    if (sizeVal == 0) {
                        state += "unknown";
                    } else if (freeVal !== undefined && (sizeVal > 0 && (freeVal < (0.1 * sizeVal)))) {
                        state += "warn";
                        //to_display = used_allocated + "; needs to purge for scheduled backup jobs.";
                    } else {
                        state += "ok";
                    }
                    return '<div class="progress-bar" title="' + to_display + '">' +
                        '<div class="progress-meter ' + state + '" style="width:' + percent_used + ';' + color + '"></div></div>';
                },
                status: function (value, row) {
                    var iconClass = value === "online" ? "okcircle" : "off";
                    var statusIcon = '<i class="icon-'+ iconClass +' icon-large" title="' + value + '"></i>';
                    if (row.is_purging === true) {
                        var purge_title = "Purging " + PHD.util.formatMB(row.mb_to_purge);
                        statusIcon = '<i class="icon-phd-sync icon-large" title="' + purge_title + '"></i>';
                    }
                    return '<span class="storage-status">' + statusIcon + '</span>';
                }
            };

            $rootScope.getStorageData = function(init) {
              
                var resp;

                if (init === true) {
                    StorageTable = PHD.DataTable($storageTable, dtOptions);
                    StorageTable.registerFormatters(cellFormatter);
                }
                resp = PHD.Ajax.get("/api/storage");

                resp.done(function (data) {
                    var i;
                    if (typeof data.storage !== 'undefined') {
                        if (init === true) {
                           
                            for (i = 0; i < data.storage.length; ++i) {
                                var id = data.storage[i].id;
                                threshold_lookup[id] = {
                                    warn_threshold: (typeof data.storage[i] !== 'undefined') ? data.storage[i].warn_threshold : 0,
                                    stop_threshold: (typeof data.storage[i] !== 'undefined') ? data.storage[i].stop_threshold : 0
                                }
                            }
                            StorageTable.load(data.storage);
                        } else {
                            StorageTable.update(data.storage, true);
                        }
                    }

                    $storageTable.scrollTable({"height": ".widget-content"});

                    totals = data.totals;
                    if (typeof totals !== 'undefined') {
                        $("[data-source-total]").each(function (index) {
                            var $el = $(this),
                                key = $el.attr("data-source-total");

                            if (totals.hasOwnProperty(key)) {
                                $el.text(totals[key]);
                            }
                        });

                        $storageTotalProgress
                            .attr("title", totals["used_allocated"])
                            .children(".progress-meter").css("width", totals["percent_used"] + "%");
                    }
				});
            }

            $scope.userPrefernce = function(){
                 $rootScope.manualRefreshControl($rootScope.listOfTimer[2]/1000,$scope.widgetName);
            }

           if ($scope.user.loggedIn) {
                $scope.userPrefernce();
                $scope.getStorageData(true);
            }
            $(document)
                .on("login", function (event) {
                    $scope.getStorageData(true);
                    stopAll();
                })
                .on("logout", function (event) {
                    stopAll();;
                })
                .on("uinav.dashboard", function (event) {

                })
                .on("uinav.protect", function (event) {
                    stopAll();
                })
                .on("uinav.recover", function (event) {
                    stopAll();
                })
                .on("uinav.jobs", function (event) {
                    stopAll();
                })
                .on("uinav.configure", function (event) {
                    stopAll();
                })
                .on("uinav.reports", function (event) {
                    stopAll();
                });

            function stopAll() {
                clearInterval($rootScope.listOfTimerFunction[2]);
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                delete $(document);
            }  
            
            $scope.modalShown=false;
                $scope.toggleModal=function(){
                $scope.modalShown= !$scope.modalShown;
            };
            
            $scope.widgetID;

            /* Click Event Listener for open configure model dialog box  */
            $scope.$on('dialogopenEvent', function (event, widget, index){
               
                if(widget.name === 'STORAGE'){
                    $scope.toggleModal();
                    $scope.widgetID='ID'+index;
                    $scope.dropdownvalue = $rootScope.backupTimer /1000;
                    $('#id_storageRefresh').val($rootScope.listOfTimer[2]/1000);
					event.defaultPrevented = true;
                }
            });
            
			/* Event listener for manual;Refesh */
			$scope.$on('manualRefreshEvent', function (event, widget,index){
			    if(widget.name === 'STORAGE'){
					$scope.getStorageData(true);
					event.defaultPrevented = true;
				}
			});
               
            

}]);