var topforumModule = angular.module('topForumPostsWidgetModule',['dynamicdashboardapp','ui.dashboard']);

var load=null;

topforumModule.factory('topForumFactory', function($http) {
    return {
        getForumPosts: function(method,url,enviornmentID,dataObj) {
            var params = {};
            if (enviornmentID != 0) {
                params.sid = enviornmentID;
            }
            var promise = $http({
                url: url,
                data: JSON.stringify(dataObj),
                method: method,
                params: params
            }).success(function(data, status, headers){
                PHD.hideLoadingIndicator(load);
                load=null;
            }).error(function(response){
                window.PHD.throwError({"result": [{"message": gettext(response.result[0].message)}]});
                PHD.hideLoadingIndicator(load);
                load=null;
            });
            return promise;
        }
    };
});

/* Top Forum Widget Widget Contorller */
topforumModule.controller('TopForumPostsWidgetCtrl', function ($scope,$rootScope,$http,topForumFactory){
    
    $scope.refreshKey="dash_forum_posts_refresh";
    $scope.widgetName="Post";
	$scope.forumpostTimer=3000;
    $scope.dropdownvalue="0";
    
    $scope.feeds = [];
    $scope.modalShown=false;
    $scope.isForumPostsshow=true;
    $scope.salesforce_id = null;
    $scope.userName = "";
    
    /* Click Event Listener for open configure model dialog box  */
    $scope.toggleModal=function(){
	        $scope.modalShown=!$scope.modalShown;
    };

    /* Event listener for dialogopenEvent */
    $scope.$on('dialogopenEvent', function (event, widget,index){
        if(widget.name === 'COMMUNITY'){
            $scope.toggleModal();
            //$scope.dropdownvalue = $rootScope.forumpostTimer /1000;
			$('#id_postRefresh').val($rootScope.listOfTimer[4]/1000);
			event.defaultPrevented = true;
        }
    });
    
    /* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
     if(widget.name === 'COMMUNITY'){
		$scope.getTopForumPosts();
		event.defaultPrevented = true;
		    
        }
    });
    
    /*Function to load The Widget*/
	var allUserURL ="/api/forum/users/user/";
    $rootScope.getTopForumPosts = function(){
        
    
        topForumFactory.getForumPosts('get',allUserURL,1,"").then(function(result){
            for(var i= 0; i<result.data.data.length;i++){
                if(result.data.data[i].id === 1){
                    if(result.data.data[i].credentials.salesforce_id !=null && result.data.data[i].credentials.salesforce_id!=""){
                        $scope.salesforce_id = result.data.data[i].credentials.salesforce_id;
                        $scope.userName = result.data.data[i].credentials.username;
                    }
                    if($scope.salesforce_id != null){
                        var forumPostURL =  "/api/forum/posts/";
                        topForumFactory.getForumPosts('get',forumPostURL,0,"").then(function(result){
                            if((result.data.posts).length > 0){
                                $scope.isForumPostsshow = true;
                                $scope.feeds = result.data.posts;
                            }else{
                                $scope.isForumPostsshow = false;
                                $scope.feeds = [];
                            }
                        });    
                    }
                    break;
                }
            }
         });
    }
    
    $scope.openCreateForumAccountWZ = function(){
        $("#txtEmailId").val("");// Making field blank on UI.
        $("#create_forum_password").val("");// Making field blank on UI.
        $("#create_confirm_password").val("");// Making field blank on UI.
        
        
          $("#create-forum-widget").dialog({
            modal: true,
            draggable: true,
            resizable: false,
            title:"Create a Forum Account",
            width: 450,
            height:500,
            dialogClass: 'ui-dialog-osx',
            buttons:{
                "Create Account": function(){
                    
                    if(isCreateForumFormValid()){
                    load = PHD.showLoadingIndicator("body", true, "Saving...");    
                        var forumUserURL =  "/api/forum/users/user/";
                        var account ={};

                        account.user_id =1;
                        account.email =$("#txtEmailId").val();
                        account.password =$("#create_forum_password").val();
                        account.nickname =$("#txtNickName").val();
                        account.first_name =$("#txtFirstName").val();
                        account.last_name =$("#txtLastName").val();
                       
                        topForumFactory.getForumPosts('post',forumUserURL,1,account).then(function(result){
                            topForumFactory.getForumPosts('get',allUserURL,1,"").then(function(result){
                                for(var i= 0; i<result.data.data.length;i++){
                                    if(result.data.data[i].id === 1){
                                        if(result.data.data[i].credentials.salesforce_id !=null && result.data.data[i].credentials.salesforce_id!=""){
                                            $scope.salesforce_id = result.data.data[i].credentials.salesforce_id;
                                        }
                                        if($scope.salesforce_id != null){
                                            var forumPostURL =  "/api/forum/posts/";
                                            topForumFactory.getForumPosts('get',forumPostURL,0,"").then(function(result){
                                                if((result.data.posts).length > 0){
                                                    $scope.isForumPostsshow = true;
                                                    $scope.feeds = result.data.posts;
                                                }else{
                                                    $scope.isForumPostsshow = false;
                                                    $scope.feeds = [];
                                                }
                                            });    
                                        }
                                        break;
                                    }
                                }
                                
                            }); 
                            $("#create-forum-widget").dialog("close");// once response return success then dialog will close.
                            refreshPage();//refresh dashbord page.
                        });
                        //$(this).dialog("close");
                    }
                },
                "Cancel":function(){
                    $(this).dialog("close");
                    $("#form-errors").hide();
                }
            }
        });
    }
   
    
    $scope.addForumAccount = function(){ 
        $("#txtAcEmailId").val("");// Making field blank on UI.
        $("#add_acc_password").val("");// Making field blank on UI.
        $("#confirm_acc_password").val("");// Making field blank on UI.
        $scope.toggleModal();
        $("#add-forum-widget").dialog({
            modal: true,
            draggable: true,
            resizable: false,
            title:"Add a Forum Account",
            width: 450,
            height:350,
            dialogClass: 'ui-dialog-osx',
            buttons:{
                "Add Account": function(){

                    if(isAddFormValid()){
                        load = PHD.showLoadingIndicator("body", true, "Saving...");

                        var connectNowURL = "/api/forum/authenticate/";
                        var connectNow = {};
                        connectNow.user_id = 1;
                        connectNow.email = $("#txtAcEmailId").val();
                        connectNow.password = $("#add_acc_password").val();


                        topForumFactory.getForumPosts('post',connectNowURL,1,connectNow).then(function(result){
                            topForumFactory.getForumPosts('get',allUserURL,1,"").then(function(result){
                            for(var i= 0; i<result.data.data.length;i++){
                                        if(result.data.data[i].id === 1){
                                        if(result.data.data[i].credentials.salesforce_id !=null && result.data.data[i].credentials.salesforce_id!=""){
                                                    $scope.salesforce_id = result.data.data[i].credentials.salesforce_id;
                                        }
                                        if($scope.salesforce_id != null){
                                            var forumPostURL =  "/api/forum/posts/";
                                            topForumFactory.getForumPosts('get',forumPostURL,0,"").then(function(result){
                                                if((result.data.posts).length > 0){
                                                    $scope.isForumPostsshow = true;
                                                    $scope.feeds = result.data.posts;
                                                }else{
                                                    $scope.isForumPostsshow = false;
                                                    $scope.feeds = [];
                                                }
                                            });    
                                        }
                                        break;
                                }
                                    }
                            });
                            $("#add-forum-widget").dialog("close");// once response return success then dialog will close.
                            refreshPage();//refresh dashbord page.
                        });

                    }
                },
                "Cancel":function(){
                    $(this).dialog("close");
                    $("#form-errors").hide();

                }
            }
        });
    }
    
    //************************************** Change Forum account ************************
    $scope.openChangeForumDialog = function(){
        $("#txtchangeAccEmail").val("");
        $("#change_acc_password").val("");
        $("#change_confirm_password").val("");
        $scope.toggleModal();
        $("#change-forum-acc-widget").dialog({
            modal: true,
            draggable: true,
            resizable: false,
            title:"Change Forum Account",
            width: 450,
            height:350,
            dialogClass: 'ui-dialog-osx',
            buttons:{
                "Change Account": function(){
                    if(isChangeFormValid()){
                        $(this).dialog("close");
                        
                    }
                },

                "Cancel":function(){
                    $(this).dialog("close");
                    $("#form-errors").hide();
                   
                }
            }
        });
    }
    
    
    //************************************** Refresh Forum Widget ************************
    
    /*to Get User prefrence*/
	$scope.userPrefernce = function(){
	       $rootScope.manualRefreshControl($rootScope.listOfTimer[4]/1000,$scope.widgetName);
	}
	
	
	if ($scope.user.loggedIn){
		$scope.userPrefernce();
		$scope.getTopForumPosts();
    }
	
    $(document)
		.on("login", function (event){
			$scope.getTopForumPosts();
			stopAll();
		})
		.on("logout", function (event) {
			stopAll();
		})
		.on("uinav.dashboard", function (event) {

		})
		.on("uinav.protect", function (event) {
			stopAll();
		})
		.on("uinav.recover", function (event) {
			stopAll();
		})
		.on("uinav.jobs", function (event) {
			stopAll();
		})
		.on("uinav.configure", function (event) {
			stopAll();
		})
		.on("uinav.reports", function (event) {
			stopAll();
		})

	function stopAll(){
	    clearInterval($rootScope.listOfTimerFunction[1]);
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                delete $(document);
	} 
});