var dynamicDashboardTourModel =  angular.module('tourDashModel',['tour-module', 'configAssets']);

dynamicDashboardTourModel.controller('tourDynamicDashboardCtrl', function ($scope, $rootScope,tourFactory){
   $scope.HEADER_NAVIGATION = 1;
   $scope.GLOBAL            = 2;
    $scope.TILE             = 3;
    $scope.BACKUP_SUMMARY   = 4;
    $scope.STORAGE          = 5;
    $scope.ACTIVE_JOB       = 6;
    
    var $headerTarget = $("#widget-tour-dynamic");
    $scope.$currentStep = $rootScope.user.tourStep;

    $scope.initTour = function() {
        $(window).on("resize.tour",  PHD.util.debounce($scope.positionTour));
        $scope.positionTour();
       $("#dashboard-tour").addClass("active");
    }

    $scope.positionTour = function() {
        console.log("Enter in tour position fun");
        $("#tour-header").position({
            my: "center",
            at: "center",
            of: $headerTarget,
            using: positionElement
        });
        $("#tour-global").position({
            my: "right top",
            at: "right-200 top+80",
            of: $headerTarget,
            using: positionElement,
            
        });
        $("#tour-tiles").position({
            my: "center",
            at: "center",
            of: $headerTarget,
            using: positionElement

        });
                    
         $("#tour-backup     ").position({
            my: "left top-110",
            at: "left+166 center",
            of: $headerTarget,
            using: positionElement
        });
        
        $("#tour-storage").position({
            my: "center top+125",
            at: "right-450",
            of: $headerTarget,
            using: positionElement
        });
        $("#tour-active").position({
            
            my: "center top-100",
            at: "right-450",
            of: $headerTarget,
            using: positionElement
        });

    }

    function positionElement(attr, obj) {
        obj.element.element.css({
            top: attr.top,
            left: attr.left,
            position: 'absolute'
        });
    }

    $scope.endTour = function() {
        $(window).off("resize.tour");
        $(".tour-position").css("z-index", "auto");
        $("#dashboard-tour").remove();
        $scope.$currentStep = $rootScope.user.tourStep = 1;
    
        var putData = {};
        putData['show_help_overlay'] = 'false';
        
        var prefURL = '/api/preferences/' ;
            prefURL = prefURL + $rootScope.user.name+"/";
          
            tourFactory.sync('put',prefURL,1,putData).then(function(result){
                $(".app-main").removeClass("tourHilighter");
                $("#header-nav").removeClass("tourHilighter");
            });
        
        $rootScope.user.showTour= false; 
        $scope.refreshPage();
     }

/*
* Refresh App-main page 
*/
$scope.refreshPage = function(){
        var currentPage = angular.element(document.getElementById("app"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
}
 
$scope.setNextTourStep = function () {
        if($scope.$currentStep === 6) {
            //have to set the step before moving to the next page
            $scope.$currentStep = $rootScope.user.tourStep += 1;
            //go to the protect page
            window.location.href = "#/protect/";
            setTimeout(function(){
                $("#protect-inventory-buttons").addClass("tourHilighter");
                $(".app-main").removeClass("tourHilighter");
            }, 700); 
        } else {
            $scope.reloadContent();
            $scope.$currentStep =$rootScope.user.tourStep +=1; 
            $scope.positionTour();
          
            switch (parseInt($scope.$currentStep)) {
                case $scope.HEADER_NAVIGATION:
                    setTimeout(function(){ 
                       $("#header-nav").removeClass("tourHilighter"); 
                    }, 500);
                    break;
                case $scope.GLOBAL:
                    setTimeout(function(){ 
                       $("#header-nav").addClass("tourHilighter");
                    }, 500);
                    break;
                case $scope.TILE:
                    setTimeout(function(){ 
                        $("#header-nav").removeClass("tourHilighter");
                        $(".app-main").addClass("tourHilighter");
                    }, 500);
                    break;
                case $scope.BACKUP_SUMMARY:
                    setTimeout(function(){ 
                        $(".app-main").removeClass("tourHilighter");
                        $("[id='toruidBACKUP SUMMARY']").addClass("tourHilighter");
                    }, 500);
                    break;
                case $scope.STORAGE:
                    setTimeout(function(){ 
                        $("[id='toruidBACKUP SUMMARY']").removeClass("tourHilighter");
                        $("#toruidSTORAGE").addClass("tourHilighter");
                    }, 500);
                    break;
                case $scope.ACTIVE_JOB:
                    setTimeout(function(){ 
                        $("#toruidSTORAGE").removeClass("tourHilighter");
                        $("[id='toruidACTIVE JOBS']").addClass("tourHilighter");
                    }, 600);
                    break;
                default: $scope.reloadContent();
                    break;
            }
            
        }
}
$scope.reloadContent = function(){
    var currentPage = angular.element(document.getElementById("dashboard-tour"));
    var injector = currentPage.injector();
    var route = injector.get('$route');
    route.reload();
}

$scope.setPreviousTourStep = function() {
        
    $scope.$currentStep = $rootScope.user.tourStep -=1 ;
    $scope.reloadContent();
    $scope.positionTour();

    switch (parseInt($scope.$currentStep)) {
        case $scope.HEADER_NAVIGATION:
            setTimeout(function(){ 
                $("#header-nav").removeClass("tourHilighter");
            }, 500);
            break;
        case $scope.GLOBAL:
            setTimeout(function(){ 
                $(".app-main").removeClass("tourHilighter");
                $("#header-nav").addClass("tourHilighter");
            }, 500);
            break;
        case $scope.TILE:
            setTimeout(function(){ 
                $(".app-main").addClass("tourHilighter");
            }, 500);
            break;
        case $scope.BACKUP_SUMMARY:
            setTimeout(function(){ 
                 $("[id='toruidBACKUP SUMMARY']").addClass("tourHilighter");
            }, 500);
            break;
        case $scope.STORAGE:
            setTimeout(function(){ 
                $("[id='toruidBACKUP SUMMARY']").removeClass("tourHilighter");
                $("#toruidSTORAGE").addClass("tourHilighter");
            }, 500);
            break;
        case $scope.ACTIVE_JOB:
            setTimeout(function(){ 
               // $("#toruidSTORAGE").removeClass("tourHilighter");
                $("[id='toruidACTIVE JOBS']").addClass("tourHilighter");
            }, 500);
            break;
        default:$scope.reloadContent();
            break;
    }
}

$scope.createBackupJob = function(){
    $scope.endTour();
    window.location.href = "#/protect/";
    setTimeout(function(){
        $("#backupjob a").trigger('click');
    }, 1000); 
    resetTour = true;
}    
$scope.registerHost = function(){
    $scope.endTour();
    window.location.href = "#/configure/";
    
    setTimeout(function(){
        $("#addHostBtn a").trigger('click');
    }, 1000);
    resetTour = true;
}

angular.element(document).ready(function () {
        $scope.initTour();
        $scope.positionTour();
    });
});


