(function($, PHD, window, undefined){

    var $form = $("#form-feedback"),
        feedbackForm;


    function initForm() {
        $form.find(".definition").popover({
            appendTo: $form,
            position: {
                my: "right",
                at: "right+10 center",
                collision: "flip fit",
                within: $form
            }
        });

        feedbackForm = PHD.FormController($form, {})
            .validate({
                rules: {
                    name:{
                        required: true
                    },
                    email:{
                        required: true,
                        email: true
                    },
                    message: {
                        required: true
                    }
                },
                messages: {
                    name:{
                        required: gettext("Your name is required.")
                    },
                    email:{
                        required: gettext("Enter a valid email address."),
                        email: gettext("Your email address must be in <br> the form of name@domain.com.")
                    },
                    message: {
                        required: gettext("Please include your feedback.")
                    }
                }
            })
            .on("formcancel", function(event){
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data){
                PHD.currentDialog.wizard("close");
            })
    }
    /*
     *   DOM Ready Function
     */
    $(function() {

        PHD.currentDialog.one("wizardfocus", function() {
            initForm();
        });
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
