var helpApp = angular.module('help', []);

helpApp.factory('helpFactory', function($http) {
    return {
        async: function(url, extra_params, callback) {
            var params = {};
            params.ts = Date.now();
            if (extra_params != null) {
                params = $.extend(params, extra_params);
            }
            var promise = $http({
                url: url,
                method: "get",
                params: params
            }).success(function(data) {
                console.log("success");
            }).error(function(){
                window.PHD.throwError({"result": [{"message": gettext("Cannot load help information.")}]});
                //PHD.hideLoadingIndicator(load);
            });  //1. this returns promise
            return promise;
        }
    };
});


helpApp.controller('HelpCtrl', ['$scope', '$rootScope', '$http', '$route', 'helpFactory', function($scope, $rootScope, $http, $route, helpFactory) {

        // Help functions, specific variables.

        $scope.getSupportURL = function() {
            return "http://www.unitrends.com/support";
        };

        $scope.getOnlineHelpURL = function() {
            return "https://unitrends-support.force.com/UnitrendsFree/s/article/000003568";
        };

        $scope.getKnowledgeBaseURL = function() {
            return $rootScope.isCE ? "https://unitrends-support.force.com/UnitrendsFree" : "http://www.unitrends.com/support/knowledge-base";
        };

        $scope.getVideoURL = function() {
            return "http://www.unitrends.com/resources/videos/tutorials";
        };

        $scope.getSupportTunnelURL = function(){

        };

        $scope.getFeedbackURL = function(){
            return FEEDBACK_URL + "/topic/0TO40000000PMPcGAO/Product Ideas";
        };

        $scope.getTourURL = function() {
            return "#";
        };
        $scope.startTour = function() {
            $scope.user.showTour = true;
            $route.reload();
        };

        function displayAbout(data) {
            var data = data.appliance;
            for (var i = 0; i < data.length; i++) {
                obj = data[i];
                if (obj.local) {
                    PHD.miniWizard("app/help/about.html", "About", {
                        title: "About this Appliance",
                        dialogClass: "standalone",
                        width: 500,
                        height: "auto",
                        buttons: [
                            {
                                text: gettext("Close"),
                                click: function() {
                                    $(this).dialog("close");
                                }
                            }
                        ],
                        open: function(event, ui) {
                            $("#about_system_name").val(obj.name);
                            $("#about_system_host").val(obj.host);
                            $("#about_system_version").val(obj.version);

                        }
                    });
                    break;
                }
            }
        }

        $scope.runAbout = function() {
            helpFactory.async('/api/systems/', {}).then(function(data) {
                displayAbout(data.data);
            });
        };


    // Feedback form removed 3/6/2015. The feedback function currently takes the user to the feedback forum.
        /*
         function to display the feature request/feedback form
         */
    /*    function displayFeedback(data) {
            var data = data.appliance;
            for (var i = 0; i < data.length; i++) {
                obj = data[i];
                if (obj.local) {
                    PHD.wizard("app/help/feedback.html", "Feedback", {
                        title: "Enhancement Request/Feedback",
                        dialogClass: "standalone",
                        width: 500,
                        height: 600,
                        open: function(event, ui){

                        }*/
                     /*   buttons: [
                            {
                                text: gettext("Cancel"),
                                click: function() {
                                    $(this).dialog("close");
                                }
                            },
                            {
                                text: gettext("Send Feedback"),
                                click: function() {
                                    var name = $("#name").val();
                                    var email = $("#email").val();
                                    var message = $("#message").val();

                                    if (name == '' || email == '' || message == ''){
                                        //call the error function
                                        alert("Please fill in the required fields");
                                    } else{
                                        //call the feedback API here
                                        alert("It works!");
                                    }
                                    $(this).dialog("submit");
                                }
                            }
                        ]
                    });
                    break;
                }
            }
        }*/

        /*
         function to display the request form
         */
       /* $scope.runFeedback = function() {
            helpFactory.async('/api/systems/', {}).then(function(data) {
                displayFeedback(data.data);
            });
        };*/
    }]

);
