(function($, PHD, window, undefined) {

    var $jobLogTable = $("#backup-copy-table"),
        LogTable, url;
    var $form = $("#status-form");
    var statusForm;

    function initTable() {
        var sid = PHD.appliance_sid;
        var ids = copy_ids;
        if (ids != null && ids[0] !== undefined && ids[0] == ',') {
            ids = ids.slice(1);
        }
        url = "/api/archive/status/?sid=" + sid;
        var idJSON = {};
        idJSON.archive_ids = ids.split(',').map(function(id) {
            return parseInt(id, 10);
        });
        idJSON = JSON.stringify(idJSON);

        statusForm = PHD.FormController($form, {})
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            });

        LogTable = PHD.DataGrid($jobLogTable, {
            dynamic: true,
            tableScrollOptions: {"height": "article"},
            select: false,
            sortable: true,
            sortOnLoad: true,
            sortOnHeader: true,
            cellClasses: [null, null, 'long-text truncate', null, null, null, null, null, null, null],
            classifiers: ['success']
        }).registerFormatters(cellFormatter);

        updateTable();

        function updateTable() {
            PHD.Ajax
                .post(url, idJSON)
                .done(function(data) {
                    if (data.status === undefined || data.status.length == 0) {
                        var obj = {};
                        obj.id = 0;
                        obj.success = 'none';
                        obj.backup_date = 'unknown';
                        obj.instance_description = 'The backup copies no longer exist on the appliance.';
                        data.BackupStatus = [obj];
                    }
                    LogTable.load(data.status);
                });
        }
    }

    var cellFormatter = {
        instance_description: function(value) {
            var title = _.escape(value);
            return '<span class="truncates item-name" title="' + title + '">' + value + '</span>';
        },
        success: function (value, row) {
            var iconClass = value == undefined ? 'warning' : value === true ? "success" : "error";
            return '<i class="icon-phd-'+ iconClass +' icon-large" title="' + iconClass + '"></i>';
            //return '<span class="storage-status">' + statusIcon + '</span>';
        },
        encrypted: function (value, row) {
            return (value === true) ? "Yes" : "No";
        },
        size: function (value, row) {
            return(value/1024).toFixed(2);
        }
    };

    /*
    *   DOM Ready Function
    */
    $(function() {
        initTable();
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
