(function($, PHD, window, undefined) {

    var $jobLogTable = $("#job-log-table"),
        LogTable, url;
    var $form = $("#status-form");
    var statusForm;

    function initTable() {
        var sid = PHD.appliance_sid;
        var bid = backup_ids;
        url = "/api/backups/?sid=" + sid + "&bid=" + bid;

        statusForm = PHD.FormController($form, {})
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            });

        LogTable = PHD.DataGrid($jobLogTable, {
            dynamic: true,
            tableScrollOptions: {"height": "article"},
            select: false,
            sortable: true,
            sortOnLoad: true,
            sortOnHeader: true,
            cellClasses: [null, null, "full-text"],
            classifiers: ['status']
        }).registerFormatters(cellFormatter);

        updateTable();

        function updateTable() {
            PHD.Ajax
                .get(url)
                .done(function(data) {
                    if (data.BackupStatus === undefined || data.BackupStatus.length == 0) {
                        var obj = {};
                        obj.id = 0;
                        obj.status = 'None';
                        obj.start_time = 'unknown';
                        obj.output = 'The backup(s) no longer exist on the appliance.';
                        data.BackupStatus = [obj];
                    }
                    LogTable.load(data.BackupStatus);
                });
        }
    }

    var cellFormatter = {
        output: function(value, row) {
            return 'Start Date: ' + row.start_time + '<br />' + value.replace(/\n/g, "<br />");
        }
    };

    /*
    *   DOM Ready Function
    */
    $(function() {
        initTable();
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
