(function($, PHD, window, undefined) {

    var $jobLogTable = $("#backup-now-table"),
        LogTable, url;
    var $form = $("#backup-now-form");
    var statusForm;

    var cellFormatter = {
        output: function(value, row) {
            return 'Start Date: ' + row.start_time + '<br />' + value.replace(/\n/g, "<br />");
        }
    };

    function initTable() {

        statusForm = PHD.FormController($form, {})
            .on("formcancel", function(event){
                PHD.currentDialog.wizard("close");
            })
            .on("formjump", function(event, data){
                window.location.href = "#/jobs/#0";
                PHD.currentDialog.wizard("close");
        });


        LogTable = PHD.DataTable($jobLogTable, {
            dynamic: false,
            tableScrollOptions: {"height": "article"},
            select: false,
            sortable: true,
            sortOnLoad: false,
            sortOnHeader: true,
            cellClasses: [null, null, "full-text"]
        }).registerFormatters(cellFormatter);

        function updateTable() {
            console.log("load log table with: " + JSON.stringify(backupNowReturn));
            var jobList = [];
            backupNowReturn.forEach(function(job, index) {
                var obj = job;
                obj.id = index + 1;
                obj.server_name = job.client_name != undefined ? job.client_name : job.host_name;
                obj.message = job.job_id > 0 ? "Success" : job.message;
                jobList.push(obj);
            });
            console.log("Job list is " + JSON.stringify(jobList));
            LogTable.load(jobList);
        }

        updateTable();
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        initTable();
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
