var protectTourModel =  angular.module('tourJobsModel',['tour-module']);

protectTourModel.controller('tourJobsCtrl', function ($scope, $rootScope, tourFactory){

    var $tour       = $("#jobs-tour"),
        $job        = $("#tour-job-tabs"), 
        $jobManager = $("#tour-job-manager"),
        $jobDetails = $("#tour-job-details"),
        $activJob   = $("#tour-job-active"),
        $recentJob  = $("#tour-job-recent");
    
        var $jobTarget  = $("#widget-tour-jobs");
        $scope.$currentStep = $rootScope.user.tourStep;


    $scope.initTour = function() {
        $(window).on("resize.tour",  PHD.util.debounce($scope.positionTour));
        $scope.positionTour();
        $tour.addClass("active");
    }


    $scope.positionTour = function() {
        $job.position({
            my: "left-400 center",
            at: "top+214",
            of: $jobTarget,
            using: positionElement
        });
        $jobManager.position({
            my: "left-576",
            at: "top+215",
            of: $jobTarget,
            using: positionElement
        });
        $jobDetails.position({
            my: "center",
            at: "center",
            of: $jobTarget,
            using: positionElement
        });
       $activJob.position({
            my: "left+80",
            at: "left+80 top+220",
            of: $jobTarget,
            using: positionElement
        });
        $recentJob.position({
            my: "left+200 center",
            at: "left+218 top+220",
            of: $jobTarget,
            using: positionElement
        });
    }

    function positionElement(attr, obj) {
        obj.element.element.css({
            top: attr.top,
            left: attr.left,
            position: 'absolute'
        });
    }

    $scope.endTour = function() {
        $(window).off("resize.tour");
        $(".tour-position").css("z-index", "auto");
        $tour.remove();
        $scope.$currentStep = $rootScope.user.tourStep = 1;
    
        var putData = {};
        putData['show_help_overlay'] = 'false';
        
       // PHD.Ajax.put('/api/preferences/' + $scope.user.name, JSON.stringify(putData));
        
        var prefURL = '/api/preferences/' ;
        prefURL = prefURL + $rootScope.user.name+"/";
        tourFactory.sync('put',prefURL,1,putData).then(function(result){
        });
        
        $rootScope.user.showTour= false; 
        $scope.refreshPage();
        $("#activeJob a").trigger('click');
    }

    /* 
     * Refresh App-main page
     */
     $scope.refreshPage = function(){
        var currentPage = angular.element(document.getElementById("app-main"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    $scope.reloadContent = function(){
        var currentPage = angular.element(document.getElementById("jobs-tour"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    
    $scope.setNextTourStep = function() {
        if($scope.$currentStep === 19) {
            //have to set the step before moving to the next page
            $scope.$currentStep = $rootScope.user.tourStep += 1;
            //go to the protect page
            window.location.href = "#/reports/";
            setTimeout(function(){
               $("#reprotCategories").addClass("tourHilighter");
            }, 500); 
            
        }else{
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep+=1; 
            $scope.positionTour();
            
             switch(parseInt($scope.$currentStep)) {
                    case 15:
                        setTimeout(function(){
                           $("#activeJob a").trigger('click');
                           $("#jobPane").addClass("tourHilighter");
                        }, 500); 
                        break;
                    case 16:
                        setTimeout(function(){
                            $("#managerJob a").trigger('click');
                            $("#managerJob").addClass("tourHilighter");
                            $("#jobs-manage").addClass("tourHilighter");
                            
                        }, 500);
                        break;
                    case 17:
                        setTimeout(function(){
                            $( "#active-jobs" ).addClass("tourHilighter");
                            $( "#manage-jobs" ).addClass("tourHilighter");
                            
                            
                        }, 500);
                        break;
                    case 18:
                        setTimeout(function(){
                           $("#activeJob a").trigger('click');
                           $( "#active-jobs" ).addClass("tourHilighter");
                           $("#activeJob").addClass("tourHilighter");
                        }, 500);
                     break;
                     case 19:
                        setTimeout(function(){
                            $("#recentJob a").trigger('click');
                            $("#recentJob").addClass("tourHilighter");
                            $("#jobs-history").addClass("tourHilighter");
                            
                        }, 500);
                        break;
                     default: $scope.reloadContent();
                        break;
                }
             
        }
        
    }

    $scope.setPreviousTourStep = function() {
        if(parseInt($scope.$currentStep) === 15) {
            //have to set step change before going back
            $scope.$currentStep = $rootScope.user.tourStep -=1; 
            
            //go back to the protect page
            window.location.href = "#/recover/";
            
            setTimeout(function(){
                $("#instantRecovery a").trigger('click');
                $("#instantRecovery").addClass("tourHilighter");
                $("#recover-ir").addClass("tourHilighter");
            }, 500);
        } else {
            
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep -=1; 
            $scope.positionTour();
            
                switch(parseInt($scope.$currentStep)) {
                    case 15:
                        setTimeout(function(){
                           $("#jobPane").addClass("tourHilighter");
                        }, 500); 
                        break;
                    case 16:
                        setTimeout(function(){
                            $("#managerJob a").trigger('click');
                            $("#managerJob").addClass("tourHilighter");
                            $("#jobs-manage").addClass("tourHilighter");
                        }, 500);
                        break;
                    case 17:
                        setTimeout(function(){
                            $( "#active-jobs" ).addClass("tourHilighter");
                            
                        }, 500);
                        break;
                    case 18:
                        setTimeout(function(){
                           $("#activeJob a").trigger('click');
                           $( "#active-jobs" ).addClass("tourHilighter");
                           $("#activeJob").addClass("tourHilighter");
                        }, 500);
                     break;
                     case 19:
                        setTimeout(function(){
                            $("#recentJob a").trigger('click');
                            $("#recentJob").addClass("tourHilighter");
                            $("#jobs-history").addClass("tourHilighter");
                        }, 500);
                        break;
                     default: $scope.reloadContent();
                        break;
                }
                       
        }
    }
    angular.element(document).ready(function () {
        $scope.initTour();
        $scope.positionTour();
    });
});

    
