    var loginApp = angular.module('login', []);

	loginApp.controller('LoginCtrl', ['$scope','$route', '$rootScope', '$window', '$cookieStore', '$http', 'Page',
			function($scope, $route, $rootScope, $window, $cookieStore, $http, Page) {
		console.log("*************in login contriller************");
        Page.setTitle('Login', false);
			
		$scope.credentials = {};
        $scope.loginForm = null;

		$scope.credentials.remember_me = $cookieStore.get('remember_me');
        if ($scope.credentials.remember_me !== undefined && $scope.credentials.remember_me) {
            $scope.credentials.username = $cookieStore.get('username');
            $scope.credentials.password = $cookieStore.get('password');
        }

        $scope.noReset = function() {
            window.PHD.throwError({"result": [{"message": gettext("Password reset is not support at this time.")}]});
        };

        /* called when the user clicks the "log in" button.  Validates the form, then calls the mail login function */
        $scope.loginUser = function() {
            var redirectToDash = false;
            if ($scope.loginForm && $scope.loginForm.valid()) {
                $rootScope.loginUser($scope.credentials.username, $scope.credentials.password, false, $scope.credentials.remember_me);
            }
        };

        /*
         * Wrap the existing jQuery in a function.  Call after Angular loads the page.
         */
		angular.element(document).ready(function() {
			$scope.loginForm = processLoginPage();
            // If remember-me, username and password are in cookies, see $rootScope.loginUser
		});

        function processLoginPage() {
            console.log("************in processLoginPage********");
            var $form = $(".login-form");

            $form.validate({
                rules: {
                    username: {
                        required: true,
                        maxlength: 32
                    },
                    password: {
                        required: true
                    }
                },
                messages: {
                    username: {
                        required: gettext("Username is required"),
                        maxlength: gettext("Username must not be more than 32 characters")
                    },
                    password: {
                        required: gettext("Password is required")
                    }
                }
            });

            $('.send-username').on("click", function(event) {
                event.preventDefault();
                var form = $("form.password-reset");
                form.attr("action", "/accounts/forgot_username/").submit();
            });

            $(function() {
                $("#id_username").focus();
            });

            return $form;

        }
    }
]);