(function($, PHD, window, undefined){

    var $form = $("#form_updates"),
        $updateTable = $("#system-update-table"),
        $statusTable = $("#update-status-table"),
        updatesForm,
        UpdateTable,
        StatusTable;


    function initForm() {
        $form.find(".definition").popover({
            appendTo: $form,
            position: {
                my: "left center",
                at: "right+10 center",
                collision: "flip fit",
                within: $form
            }
        });

        UpdateTable = PHD.DataGrid($updateTable, {
            dynamic: false,
            tableScrollOptions: {"height": "article"},
            select: true,
            sortable: true,
            sortOnLoad: true,
            sortOnHeader: true,
            integerIDs: false,
            cellClasses: [null, null, "full-text"],
            classifiers: ['id']
        });

        StatusTable = PHD.DataGrid($updateTable, {
            dynamic: false,
            tableScrollOptions: {"height": "article"},
            select: true,
            sortable: true,
            sortOnLoad: true,
            sortOnHeader: true,
            integerIDs: false,
            cellClasses: [null, null, "full-text"],
            classifiers: ['id']
        });

        updatesForm = PHD.FormController($form, {})

            .on("formcancel", function(event){
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data){
                data = {};

                // get /updates/status here
              //  updateStatus = data.updates;
             //   console.log(updateStatus);
             //   StatusTable.load(updateStatus);
             //   PHD.currentDialog.wizard("close");
            });

        loadUpdates();

        function loadUpdates() {
            console.log("loading systems" + JSON.stringify(updateSystems));
            UpdateTable.load(updateSystems);
        }

        updatesForm.submit = function() {
            console.log("in processUpdates function");
            PHD.currentDialog.wizard("close");
            var self = this;

            load = PHD.showLoadingIndicator("body", true, "Appliance is updating, do not reboot...")
            this.$buttons.blur().disable();

            console.log('appliance id is ' + PHD.appliance_sid);
            var url_sid = (PHD.appliance_sid === null) ? "/" : "/?sid=" + PHD.appliance_sid;
            var url = this.$form.attr("action");
            url += url_sid;
            console.log("URL is " + url);
            PHD.Ajax
                .post(url)
                .done(function(data) {
                    self.$form.trigger("formsubmit", [data, self.$form, self]);
                    console.log("in .done after post"  + data);
                })
                .always(function() {
                    self.$buttons.enable();
                    PHD.hideLoadingIndicator(load);
                });

            return this;

        }
    }
    /*
     *   DOM Ready Function
     */
    $(function() {
        PHD.currentDialog.one("wizardfocus", function() {
            initForm();
        });
    });

    })(jQuery, window.PHD || (window.PHD = {}), window);
