var optionsApp = angular.module('options', []);

optionsApp.factory('optionsFactory', function($http) {
    return {
        async: function(method,url,enviornmentID,dataObj) {
            var params = {};
            if (enviornmentID != 0) {
                params.sid = enviornmentID;
            }
            var promise = $http({
                url: url,
                data: JSON.stringify(dataObj),
                method: method,
                params: params
            }).success(function(data, status, headers){
                console.log("success");
            }).error(function(response){
                PHD.hideLoadingIndicator(load);
                window.PHD.throwError({"result": [{"message": gettext(response.result[0].message)}]});

            });
            return promise;
        }
    };
});


optionsApp.controller('OptionsCtrl', ['$scope', '$http', 'optionsFactory', function($scope, $http, optionsFactory) {

        $scope.startSync = function() {
            // need a base class or consistent way to apply credentials.
            $http.put('/api/inventory/sync')
                .success(function(data, status, headers) {
                    // this should close the drop-down
                    // update the stats, which will reduce the timer interval while running
                    window.PHD.fetchStats();
                })
                .error(function(data, status, headers) {
                    window.PHD.throwError(data);
                })
        }



        $scope.checkForUpdates = function() {
           // alert("here I am");

                load = PHD.showLoadingIndicator("#updates.html", true, "Checking for available updates...");
            optionsFactory.async('get', '/api/updates/', 0)
                .then(function(data) {
                PHD.hideLoadingIndicator(load);
                displayUpdates(data.data);
            });
        };


        function displayUpdates(data) {

            console.log("in displayUpdates", data.updates.count);
            var data = data.updates;
            updateSystems = [];
            var obj = { "count": data.count, "sname": data.sname, "id": data.sid };
            updateSystems.push(obj);
            console.log("Update systems list" + JSON.stringify(updateSystems));

                 PHD.wizard("app/options/updates.html", "Updates", {
                 title: "Available Appliance Updates",
                 dialogClass: "standalone",
                 width: 500,
                 height: "auto",

                        open: function(event, ui) {}


            })
        }


   }]

);
