(function($) {

    $(function() {
        var $langSelect = $('#select-language');

        if($langSelect.length) {
            var $langContainer = $("<div>", {
                    "class": 'language-container',
                    "html": '<div class="language-select"><span class="selected"></span></div>'
                }),
                $langMenu = $("<ul>",{"class":'language-menu'}),
                $langDrop = $langContainer.find('.language-select'),
                $selected = $langDrop.find('.selected');

            $langSelect.find("option").each(function(index) {
                var $option = $(this),
                    $langItem = $("<li>", { html: $option.html() });

                if($option.attr("selected")) {
                    $selected.html($langItem.html());
                    $langDrop.append($selected);
                }

                $langItem.on("click", function() {
                    $selected.html($option.html());
                    $langMenu.trigger("hide");

                    $langSelect.val($option.val()).trigger("change");
                });

                $langMenu.append($langItem);
            });

            $langDrop.prepend('<i class="icon-globe icon-large" title="Select a language"></i>');
            $langDrop.append('<i class="icon-caret-down"></i>');
            $langContainer.append($langMenu.hide());
            $langContainer.insertAfter($langSelect.parent());

            $langMenu
                .on("show", function() {
                    if($(this).is(":animated")) {
                        return false;
                    }

                    $langDrop.addClass("expanded");
                    $(this).slideDown(400, function() {
                        $("body").one("click.lang", function(event) {
                            event.preventDefault();
                            $langMenu.trigger("hide");
                        });
                    });

                })
                .on("hide", function() {
                    if($(this).is(":animated")) {
                        return false;
                    }

                    $("body").off("click.lang");

                    $langDrop.removeClass("expanded");
                    $(this).slideUp();

                })
                .on("toggle", function() {
                    if($langDrop.hasClass("expanded")) {
                        $(this).trigger("hide");
                    } else {
                        $(this).trigger("show");
                    }
                });

            $langDrop.on("click", function() {
                $langMenu.trigger('toggle');
            });

            $langSelect.on("change", function(event) {
                $(this).parent().submit();
            });

            $langSelect.hide();
        }        
    });

})(jQuery);