//(function($, PHD, window, undefined) {

function processProtectPage(PHD, window, $scope, $rootScope, $compile, $analytics) {
    var tabs = [],
        initialTab = $.cookie("initial_tab_protect") || 0,
        currentTabIndex = 0,
        $protectTreeContainer = $("#protect-treeview"),
        TabTimer, UserPreference,
        // lmc slugs = ['inventory', 'replicas', 'sync'];
        slugs = ['inventory'];

    // lmc - add this.
    var refreshRate = refreshRates.page_protect_refresh;
    $rootScope.ProtectTimer.refreshControl = $("#protect-page-preferences .timer-refresh");
    TabTimer = $rootScope.ProtectTimer;

    var weekday = [];
    weekday[0] = "Sunday";
    weekday[1] = "Monday";
    weekday[2] = "Tuesday";
    weekday[3] = "Wednesday";
    weekday[4] = "Thursday";
    weekday[5] = "Friday";
    weekday[6] = "Saturday";

    function getDay(day, dow) {
        var offset = day - dow;
        if (dow < day) {
            offset -= 7;    // go to prior week.
        }
        var date = moment().day(dow + offset);
        return weekday[day] + ", " + date.format(DATE_DISPLAY_FORMAT);
    }

    // lmc - move formatters to top of file, before they are referenced.
    var cellFormatter = {
        name: function (value, row) {
            return '<span class="truncates" title="' + value + '">' + value + '</span>';
        },
        controls: function (value, row) {
            // lmc - no state
            //var hvclass = getHypervisorClass(row.state.hypervisor);
            //return '<input class="inventory-checkbox '+hvclass+'" type="checkbox" name="inventory" value="' + row.state.id + '">';
            //console.log('row = ' + JSON.stringify(row));
            var hvclass = getHypervisorClass(row.hv);
            // lmc - encode name in row?
            // lmc - TODO hvclass?
            //return '<input class="inventory-checkbox '+hvclass+'" type="checkbox" name="inventory" value="' + row.id + '^' +  row.name +'">';
            return '<input class="inventory-checkbox ' + hvclass + '" type="checkbox" name="inventory" value="' + row.id + '">';
        },
        last_backups: function (value, row, key, area_type) {
            var output = "";
            var area = area_type || 'Backups';
            var dow = moment().day();
            for (i = 0; i < value.length; i++) {
                var status = "none";
                var status_summary = "";
                var obj = value[i];
                if (obj.successes !== undefined && obj.successes.count > 0) {
                    status = 'success';
                    status_summary += "Success";
                }
                if (obj.warnings !== undefined && obj.warnings.count > 0) {
                    status = 'warning';
                    status_summary += " Warnings";
                }
                if (obj.failures !== undefined && obj.failures.count > 0) {
                    status = 'error';
                    status_summary +=  " Failures";
                }
                output += '<i class="icon-phd-' + status + ' job-status-icon';
                if (status !== "none") output += ' day-result'; // so that it is clickable.
                output += '" title="';
                if (status_summary == "") {
                    output += "None" + '"';
                } else {
                    output += status_summary + '"';
                    output += '" data-day="' + getDay(obj.day, dow) + '"';
                    output += '" data-area="' + area + '"';
                    output += '" data-successes="' + obj.successes.count + '"';
                    output += '" data-successes-ids="' + obj.successes.ids.toString() + '"';
                    if (obj.warnings !== undefined) {
                        output += '" data-warnings="' + obj.warnings.count + '"';
                        output += '" data-warnings-ids="' + obj.warnings.ids.toString() + '"';
                        if (obj.warnings.count > 0 && obj.day == dow) {
                            output += '" data-warnings-today="1"';
                        }
                    } else {
                        output += '" data-warnings="0"';
                        output += '" data-warnings-ids=""';
                    }
                    output += '" data-failures="' + obj.failures.count + '"';
                    if (obj.failures.count > 0 && obj.day == dow) {
                        output += '" data-failures-today="1"';
                    }
                    output += '" data-failures-ids="' + obj.failures.ids.toString() + '"';
                    if (obj.incomplete !== undefined) {
                        output += '" data-incomplete="' + obj.incomplete.count + '"';
                        output += '" data-incomplete-ids="' + obj.incomplete.ids.toString() + '"';
                    } else {
                        output += '" data-incomplete="0"';
                        output += '" data-incomplete-ids=""';
                    }
                    if (row.name !== undefined) {
                        output += '" data-name="' + row.name + '"';
                    }
                    var a = row.id.split('_');
                    var sid = a[0];
                    output += '" data-sid="' + sid + '"';
                }
                output += "></i>";
            }

            // lmc - no sort  from url
            //output += '<span class="item status-text">' + row.sort[key] + '</span>';
            return output;
        },
        last_replications: function (value, row, key) {
            return this.last_backups(value, row, key, 'Replications');
        },
        last_archives: function (value, row, key) {
            return this.last_backups(value, row, key, 'Backup Copies (Storage)');
        },
        backup_jobs: function (value) {
            var jobs = $.map(value, function (val) {
                    return '<span class="item">' + val + '</span>';
                }),
                titles = value.length ? value.join("; ") : EMPTY_CELL_TEXT,
                output = jobs.length ? jobs.join("; ") : EMPTY_CELL_TEXT;
            return '<span class="truncates" title="' + titles + '">' + output + '</span>';
        },
        replication_jobs: function (value) {
            return this.backup_jobs(value);
        },
        archive_jobs: function (value) {
            return this.backup_jobs(value);
        }
    };

    var replicasFormatter = {
        backup: function (value, row) {
            return '<span class="truncates" title="' + value + '">' + value + '</span>';
        },
        finish_date: function (value, row) {
            return moment(value).format(DATE_DISPLAY_FORMAT + " h:mm A");
        }
    };

    var syncFormatter = {
        name: function (value, row) {
            return '<span class="truncates item-name" title="' + value + '">' + value + '</span>';
        },
        backup_date: function (value, row) {
            if (value && value !== EMPTY_CELL_TEXT) {
                return moment(value).zone(tz).format("M/D/YYYY h:mmA");
            }
            return value;
        },
        started: function (value, row) {
            if (value && value !== EMPTY_CELL_TEXT) {
                return moment.unix(value).zone(tz).format(DATE_DISPLAY_FORMAT + " h:mmA");
            }
            return value;
        }
    };

    function setPageRefresh(interval) {
        refreshRate = interval;
        /*tabs.forEach(function(tab) {
         tab.setTimerInterval(refreshRate);
         });*/
        TabTimer.setInterval(refreshRate);
    }

    function initTabs() {

        if (!$scope.user.loggedIn) {
            TabTimer.rerun();
            return;
        }

        $(".page-tab").each(function (index) {
            tabs[index] = new ProtectInventoryTab(index, $(this), slugs[index]).init();
            /*if (index === 0) {
                tabs[index] = new ProtectInventoryTab(index, $(this), slugs[index]).init();
            } else if (index === 1) {
                tabs[index] = new ProtectReplicasTab(index, $(this), slugs[index]).init();
            } else {
                tabs[index] = new ProtectSyncTab(index, $(this), slugs[index]).init();
            }*/
        });
        tabs[currentTabIndex].activate();
    }

    var ProtectInventoryTab = function (index, panel, slug) {
        this.index = index;
        this.$panel = panel;
        this.namespace = "protect" + slug;

        this.$buttons = this.$panel.find(".button-bar");
        this.$buttons.find(".btn-group-recover").flyout();

        this.$tabs = $('#protect-inventory-details');
        this.tabs = [];
        this.slugs = ['status', 'settings'];

        this.TreeViewData = null;

        this.inventoryTree = PHD.ProtectTreeView(
            $protectTreeContainer,
            $("#protect-treeview-selections")
        );

        this.inventoryTreeHeader = PHD.TreeViewHeader(
            $("#protect-treeview-header"),
            this.inventoryTree,
            "protect"
        );

        this.inventoryTreeSearch = null;

        this.currentTabIndex = 0;

        this.active = false;
    };

    ProtectInventoryTab.prototype.init = function () {
        var self = this;

        this.$tabs.tabs({
            active: 0,
            create: function (event, ui) {
                self.currentTabIndex = ui.tab.index();
                self.initTabs();
            },
            activate: function (event, ui) {
                self.currentTabIndex = ui.newTab.index();
                var selections = self.tabs[ui.oldTab.index()].deactivate();
                self.tabs[self.currentTabIndex].activate(selections);
            }
        });

        $(document)
            // Attach event handler to Hypervisor view select box changes
            .on("hypervisorviewchange.protect", function (event, views) {
                self.updateTreeView(false, views);
                self.inventoryTree.clearSelections();
            });

        return this;
    };

    ProtectInventoryTab.prototype.updateTreeView = function (views) {
        var self = this,
            load = PHD.showLoadingIndicator($protectTreeContainer),
            hypervisors = views || this.getHypervisorViews(),
            tvTask = PHD.TreeViewBuilder({
                hypervisorView: hypervisors,
                disks: 0,
                checkboxes: false,
                loader: load
            });

        tvTask
            .done(function (tree) {
                self.TreeViewData = tree.tree;
                $protectTreeContainer.html(tree.html);

                self.inventoryTreeSearch = PHD.TreeViewSearch(
                    $("#protect-treeview-find"),
                    self.inventoryTree,
                    self.inventoryTree.$container,
                    self.inventoryTree.$container.find(".tree-universe")
                );
                self.tabs.forEach(function (tab) {
                    tab.clear();
                });
            })
            .always(function () {
                PHD.hideLoadingIndicator(load);
            });
    };

    ProtectInventoryTab.prototype.getHypervisorViews = function () {
        return $("#protect-treeview-header").find("select")
            .map(function () {
                return parseInt($(this).val(), 10);
            }).get();
    };

    ProtectInventoryTab.prototype.initTabs = function () {
        var self = this;
        this.$tabs.find(".ui-tabs-panel").each(function (index) {
            self.tabs[index] = new InventoryTab(index, $(this), self.slugs[index], self).init();
        });
    };

    ProtectInventoryTab.prototype.updateButtons = function (tab) {
        var tab = tab || this.tabs[this.currentTabIndex],
            selections = tab.$selected ? tab.$selected.serialize() : null;

        if (selections != null) console.log("tab selected = " + JSON.stringify(tab.$selected.serialize()));
        this.$buttons.find("a").each(function () {
            var $but = $(this).data("selections", selections);
            PHD.buttonLogic($but, tab.$selected, tab, null, null, $analytics);
        });
    };

    ProtectInventoryTab.prototype.activate = function () {
        this.active = true;
        this.updateTreeView();

        this.tabs[this.currentTabIndex].activate();
        this.updateButtons();
    };

    ProtectInventoryTab.prototype.deactivate = function () {
        this.active = false;
    };

    var InventoryTab = function (index, panel, slug, parent) {
        this.index = this.inventoryView = index;
        this.$panel = panel;
        this.namespace = "inventory" + slug;

        this.$table = this.$panel.find("table");
        this.schema = this.$table.find("thead th").map(function () {
            return $(this).data("source");
        }).get();
        this.$checkSelectAll = this.$table.find(".check-select-all");

        this.Parent = parent;

        this.$tableMessage = this.$panel.find("#protect-inventory-table-message");

        this.data = null;

        this.InventoryTable = PHD.DataTable(this.$table, {
            select: false,
            placeholder: gettext("There are no items to display"),
            sortable: true,
            sortableCells: [false, true, (this.index === PROTECT_SETTINGS), true]
        }).registerFormatters(cellFormatter);

        this.$selected = null;
        this.selectedIDs = [];
        this.$selectedInventory = null;
        this.active = false;
        this.timestamp = 0;

        this.filterFields = [
            "backup_jobs",
            "replication_jobs",
            "archive_jobs",
            "priority",
            "bds",
            "retention",
            "credentials",
            "blocksize",
            "compression"
        ];

        this.$filters = {};
    };

    InventoryTab.prototype.init = function () {
        var self = this;

        // Show the general instruction message.
        this.$tableMessage.show();

        this.$table
            .on("change", ".inventory-checkbox", $.proxy(this.handleCheckboxChange, this))
            .on("aftercolumnfilter", $.proxy(this.handleColumnFilter, this))
            //.on("click", ".job-result", $.proxy(this.handleJobResult, this))
            .on("click", ".day-result", $.proxy(this.handleDayResult, this))
            .on("change", ".check-select-all", $.proxy(this.handleCheckSelectAll, this))
            .on("updatefinished", $.proxy(this.handleRowAddition, this))
            .sortTable()
            .filterTable();

        this.filterFields.forEach(function (value) {
            self.$filters[value] = self.$table.find('tfoot [data-source="' + value + '"] select.filter');
        });

        $(document)
            .on("inventoryselect", $.proxy(this.handleCheckboxChange, this))
            .on("inventorysettingsupdate", function (event, data) {
                if (self.inventoryView == PROTECT_SETTINGS && self.active)
                    self.update();
            });

        this.Parent.inventoryTree.$container.on("nodeclick", ".checkable", $.proxy(this.handleTreeviewSelection, this));

        return this;
    };

    InventoryTab.prototype.clear = function () {
        this.$selectedInventory = null;
        this.InventoryTable.empty();
    };

    InventoryTab.prototype.update = function (selections) {
        if (this.$selectedInventory) {

            // Hide the general instruction message.
            this.$tableMessage.hide();

            var self = this,
                dbid = this.$selectedInventory.data("dbid"),
                hvView = this.Parent.inventoryTreeHeader.getQueryString(),
                view = (self.inventoryView === PROTECT_SETTINGS) ? "settings" : "status";
            //url = "/protect/inventory/" + dbid + "/" + self.inventoryView + "/?" + hvView;
            // lmc
            url = "/api/inventory/" + dbid + "/" + view + "/?hv=" + hvView;

            var loadHash = PHD.showLoadingIndicator(this.$table.parent()),
                resp = PHD.Ajax.get(url, loadHash);

            resp.done(function (data) {
                PHD.hideLoadingIndicator(loadHash);
                var backupJobs = [],
                    BDS = [];

                self.InventoryTable.update(data.inventory, true);

                if (selections) {
                    self.selectedIDs = selections;
                    self.$table.find("[name=inventory]").prop("checked", false);
                    self.selectedIDs.forEach(function (value) {
                        self.$table.find("[value=" + value + "]").prop("checked", true);
                    });
                    self.updateSelections();
                }

                _.each(self.$filters, function ($input, key) {
                    if ($input.length) {
                        if (key.indexOf("_jobs") === -1) {
                            self.updateFilter(self.getFilterOptions("tbody td[data-source=" + key + "]"), $input);
                        } else {
                            self.updateFilter(self.getJobFilterOptions("tbody td[data-source=" + key + "]"), $input);
                        }
                    }
                });

                self.$table
                    //.sortTable()
                    .scrollTable()
                    .columnResize();

                self.Parent.updateButtons(self);
            });
        } else {
            this.$table
                //.sortTable()
                .scrollTable()
                .columnResize();
        }
    };

    InventoryTab.prototype.updateFilter = function (options, $control) {
        $control.find("option:not(.option-all)").remove();
        options.sort().forEach(function (item, index) {
            $control.append('<option value="' + item + '">' + item + '</option>');
        });
    };

    InventoryTab.prototype.getFilterOptions = function (selector) {
        var options = [];
        this.$table.find(selector).each(function () {
            if ($.inArray($(this).text(), options) === -1) {
                options.push($(this).text());
            }
        });
        return options;
    };

    InventoryTab.prototype.getJobFilterOptions = function (selector) {
        var options = [];
        this.$table.find(selector).each(function () {
            $(this).text().split(";")
                .forEach(function (val) {
                    val = val.trim();
                    if (options.indexOf(val) === -1) {
                        options.push(val);
                    }
                });
        });
        return options;
    };

    InventoryTab.prototype.updateSelections = function () {
        this.$selected = this.$table.find("[name=inventory]:checked");
        this.selectedIDs = this.$table.find("tbody :checked").map(function () {
            return $(this).val();
        }).get();
        this.Parent.updateButtons(this);
    };

    InventoryTab.prototype.handleTreeviewSelection = function (event, id) {
        event.stopPropagation();
        this.$selectedInventory = $(event.target);
        if (this.active) {
            this.update();
        }
    };

    InventoryTab.prototype.handleDayResult = function (event) {
        var $anchor = $(event.target),
            day = $anchor.data("day"),
            area = $anchor.data("area"),
            successes = $anchor.data("successes"),
            warnings = $anchor.data("warnings"),
            failures = $anchor.data("failures"),
            incomplete = $anchor.data("incomplete"),
            successes_ids = $anchor.data("successes-ids"),
            warnings_ids = $anchor.data("warnings-ids"),
            failures_ids = $anchor.data("failures-ids"),
            incomplete_ids = $anchor.data("incomplete-ids"),
            name = $anchor.data("name"),
            sid = $anchor.data("sid");

        var data = {};
        data.day = day;
        data.formatted_day = day.split(',')[1];
        data.type = area;
        data.name = name;
        data.successes = [];
        data.successes.count = successes;
        data.successes.ids = successes_ids;
        data.warnings = {};
        data.warnings.count = warnings;
        data.warnings.ids = warnings_ids;
        data.failures = {};
        data.failures.count = failures;
        data.failures.ids = failures_ids;
        data.incomplete = [];
        data.incomplete.count = incomplete;
        data.incomplete.ids = incomplete_ids;
        data.all_ids = '';
        if (successes_ids != "") {
            data.all_ids += successes_ids;
        }
        if (warnings_ids != "") {
            data.all_ids += ',' + warnings_ids;
        }
        if (failures_ids != "") {
            data.all_ids += ',' + failures_ids;
        }
        if (incomplete_ids != "") {
            data.all_ids += ',' + incomplete_ids;
        }
        data.sid = sid;
        var html = dayTmpl(data);
        html = $compile(html)($scope);
        $("<div/>").html(html).popover({
            anchor: $anchor,
            autoOpen: true,
            popoverClass: 'job-inventory-result',
            destroyOnClose: true
        });
    };

    /*InventoryTab.prototype.handleJobResult = function (event) {
        var $anchor = $(event.target),
            obj = $anchor.data("obj"),
            resp = PHD.Ajax.get("/api/backup/" + id + '/');

        resp.done(function (data) {
            data.id = id;
            var html = jobInventoryTmpl(data);
            $("<div/>").html(html).popover({
                anchor: $anchor,
                autoOpen: true,
                popoverClass: 'job-inventory-result',
                destroyOnClose: true
            });
        });
    };*/

    InventoryTab.prototype.handleCheckboxChange = function (event, $checkbox, checked) {
        this.updateSelections();
    };

    InventoryTab.prototype.handleCheckSelectAll = function (event) {
        event.preventDefault();
        this.$table.find("tbody tr:visible :checkbox")
            .prop("checked", this.$checkSelectAll.prop("checked")).trigger("change");
        this.updateSelections();
    };

    InventoryTab.prototype.handleColumnFilter = function (event) {
        this.$table.find("tbody tr:hidden :checkbox").prop("checked", false);
        this.updateSelections();
        this.Parent.updateButtons(this);
    };

    InventoryTab.prototype.handleRowAddition = function (event, newRows, DataTable) {
        if (newRows) {
            this.$table.sortTable();
        }
    };

    InventoryTab.prototype.activate = function (selections) {
        this.active = true;
        this.update(selections);
    };

    InventoryTab.prototype.deactivate = function () {
        this.active = false;
        return this.selectedIDs;
    };

    /*var ProtectReplicasTab = function (index, panel, slug) {
        this.index = index;
        this.$panel = panel;
        this.namespace = "protect" + slug;

        this.$buttons = this.$panel.find(".button-bar");

        this.$table = this.$panel.find("#replicas-table");

        this.ReplicaTable = PHD.DataTable(this.$table, {
            select: false,
            placeholder: gettext("There are no replicas in your environment"),
            sortable: true,
            sortableCells: [true, true, true, true, true, true, true, true]
        }).registerFormatters(replicasFormatter);

        this.active = false;
    };

    ProtectReplicasTab.prototype.init = function () {
        var self = this;
        this.$buttons.find("a").each(function () {
            var $but = $(this);
            PHD.buttonLogic($but, null, self);
        });
        return this;
    };

    ProtectReplicasTab.prototype.update = function () {

        var self = this,
            dbid = this.$selectedInventory.data("dbid"),
            hvView = this.Parent.inventoryTreeHeader.getQueryString();
        var load = PHD.showLoadingIndicator(self.$panel);
        var url = "/api/inventory/" + dbid + "/" + view + "/?hv=" + hvView;

        //PHD.Ajax.get('/replicas/')
        PHD.Ajax.get(url, load)
            .done(function (data) {
                self.ReplicaTable.load(data.inventory);

                self.$table
                    .scrollTable()
                    .sortTable();
            })
            .always(function () {
                PHD.hideLoadingIndicator(load);
            });
    };

    ProtectReplicasTab.prototype.activate = function () {
        this.active = true;
        this.update();
    };

    ProtectReplicasTab.prototype.deactivate = function () {
        this.active = false;
    }; */

    $(document)
        .on("uinav.dashboard", function (event) {
            console.log("=====>Selected Dashboard");
        })
        .on("uinav.protect", function (event) {
            console.log("=====>Selected Protect");
            stopAll();
        })
        .on("uinav.recover", function (event) {
            console.log("=====>Selected Recover");
            stopAll();
        })
        .on("uinav.jobs", function (event) {
            console.log("=====>Selected Jobs");
            stopAll();
        })
        .on("uinav.configure", function (event) {
            console.log("=====>Selected Configure");
            stopAll();
        })
        .on("uinav.reports", function (event) {
            console.log("=====>Selected Reports");
            stopAll();
        })
        .on("userpreferencesave.protectpage", function (event, key, value) {
            setPageRefresh(value);
        })
        .on("timersetmanual.protectpage", function (event, $control) {
            $control.show();
        })
        .on("timerunsetmanual.protectpage", function (event, $control) {
            $control.hide();
        });

    function stopAll() {
        TabTimer.stop();
        $(document).off("uinav");
        $(document).off("userpreferencesave.protectpage");
        $(document).off("timertick.protectpage");
        $(document).off("timersetmanual.protectpage");
        $(document).off("timerunsetmanual.protectpage");
        delete $(document);
    }

    /*
    var ProtectSyncTab = function(index, panel, slug) {
        this.index = index;
        this.$panel = panel;
        this.namespace = "protect" + slug;

        this.$buttons = this.$panel.find(".button-bar");

        this.$table = this.$panel.find("#sync-table");

        this.SyncTable = PHD.DataTable(this.$table, {
            select: false,
            placeholder: gettext("There are no active Sync Tasks"),
            sortable: true,
            sortableCells: [true, true, true, true, true, true, true, true]
        }).registerFormatters(syncFormatter);

        this.$selectedStorage = this.$buttons.find("#target-sync");
        this.selectedStorage = this.$selectedStorage.val();

        this.timestamp = 0;
        this.active = false;
    };
     */

    /*
    ProtectSyncTab.prototype.init = function() {
        var self = this;

        this.$buttons.find("a").each(function() {
            var $but = $(this);
            PHD.buttonLogic($but, null, self);
        });

        this.$selectedStorage.on("change", function() {
            self.selectedStorage = $(this).val();
            self.update(true, false);
        });

        this.$table
            .on("loadfinished updatefinished", function(event, newRows) {
                if(newRows) {
                    self.$table
                        .scrollTable()
                        .sortTable();
                }
            })
            .on("rowdelete", function(event) {
                self.$table
                    .scrollTable()
                    .sortTable();
            })
            .sortTable({
                sort_duration: sort_duration
            });

        $(document)
            .on("timertick.protectpage", $.proxy(this.handleTimerTick, this));

        return this;
    };

    ProtectSyncTab.prototype.handleTimerTick = function(event, timer, interval) {
        if(this.active) {
            this.update();
        }
    };

    ProtectSyncTab.prototype.update = function(resetData, resetTimer) {
        var self = this,
            load = PHD.showLoadingIndicator(self.$panel),
            timestamp = resetData ? 0 : this.timestamp,
            url = '/sync/active/?storage=' + this.selectedStorage + "&timestamp=" + timestamp;

        PHD.Ajax.get(url)
            .done(function(data) {
                //console.log(data);
                if(data.timestamp === self.timestamp) {
                    self.timestamp += 1;
                } else if(data.timestamp > self.timestamp) {
                    self.timestamp = data.timestamp;
                }

                if(resetData) {
                    self.SyncTable.load(data.objects);
                } else {
                    self.SyncTable.update(data.objects, true);
                }

                if(resetTimer) {
                    TabTimer.start();
                } else {
                    TabTimer.resume();
                }

            })
            .always(function() {
                PHD.hideLoadingIndicator(load);
            });
    };

    ProtectSyncTab.prototype.activate = function() {
        this.active = true;
        this.update(false, true);
    };

    ProtectSyncTab.prototype.deactivate = function() {
        this.active = false;
        TabTimer.stop();
    };
    */

    function handleTabChange() {
        $(document).trigger("tabchange", ["protect" + slugs[currentTabIndex]]);
    }

    /*
     *   DOM Ready Function
     */
    $(function () {
        // Quick and dirty way to change what tab opens by default via URL
        if (!isNaN(PHD.util.getHashInt())) {
            initialTab = PHD.util.getHashInt();
        }

        UserPreference = PHD.UserPreference($("#protect-page-preferences .preference-trigger"), {
            name: gettext("Protect Page"),
            namespace: "protectpage",
            key: "page_protect_refresh",
            defaultValue: refreshRate
        });

        /*TabTimer = PHD.Timer({
            namespace: "protectpage",
            interval: refreshRate,
            refreshControl: $("#protect-page-preferences .timer-refresh")
        });
        */

        $('.tabs-wrapper').tabs({
            active: initialTab,
            create: function (event, ui) {
                currentTabIndex = ui.tab.index();
                initTabs();
                handleTabChange();
            },
            activate: function (event, ui) {
                currentTabIndex = ui.newTab.index();
                $.cookie("initial_tab_protect", currentTabIndex, {expires: 365, path: '/'});
                tabs[ui.oldTab.index()].deactivate();
                tabs[currentTabIndex].activate();
                handleTabChange();
            }
        });
    });

    var dayTmpl = _.template(
        '<p><label class="day-status-day"><span><%= day %></span></label></p>' +
        '<p><label><%= type %></label></p>' +
        '<hr><label>Successes:</label><span><%= successes.count %></span>' +
        '<br/><label>Warnings:</label><span><%= warnings.count %></span>' +
        '<br/><label>Failures:</label><span><%= failures.count %></span>' +
        '<br/><label>In Progress:</label><span><%= incomplete.count %></span>' +
        '<hr>' +
        '<p><a href="" ng-click="loadStatus(<%= sid %>, \'<%= all_ids %>\', \'<%= formatted_day %>\', \'<%= name %>\', \'<%= type %>\')" class="job-log-link"><i class="icon-list-alt"></i>Details</a></p>'
    );


    var jobInventoryTmpl = _.template(
        '<p><label>Job Name:</label><span><%= data.job_name %></span></p>' +
        '<p><label>Date:</label><span><%= data.start_date %></span></p>' +
        '<p><label>Mode:</label><span><%= data.type %></span></p>' +
        '<hr><div class="disks clearfix">' +
        '<label class="disk-status-label">Disk Status:</label>' +
        '<ul class="disk-statuses">' +
        '<% _.each(data.disks, function(disk) { %>' +
        '<li><span class="disk-name"><%= disk.data.name %></span> <span class="disk-job-status"><%= disk.data.job_status %></span></li>' +
        '<% }); %>' +
        '</ul></div>' +
        '<hr>' +
        '<p><a href="/jobs/<%= state.job_id %>/log/<%= state.id %>/" class="pop-out job-log-link"><i class="icon-list-alt"></i> View Log</a></p>'
    );

    var sort_duration = function (a, b) {
        if (a.value === EMPTY_CELL_TEXT || b.value === null) {
            return 1;
        }
        if (b.value === EMPTY_CELL_TEXT || a.value === null) {
            return -1;
        }
        var aVals = a.value.split(":").map(function (val) {
                return parseInt(val, 10);
            }),
            bVals = b.value.split(":").map(function (val) {
                return parseInt(val, 10);
            });

        a = (aVals[0] * 60 * 60) + (aVals[1] * 60) + aVals[2];
        b = (bVals[0] * 60 * 60) + (bVals[1] * 60) + bVals[2];
        return a - b;
    };

    function getHypervisorClass(hvtype) {
        switch (hvtype) {
            case HYPERVISOR_HYPERV:
                return "hv-type-hyperv";
            case HYPERVISOR_VMWARE:
                return "hv-type-vmware";
            case HYPERVISOR_XEN:
                return "hv-type-xen";
            default:
                return "hv-type-unknown";
        }
    }
}
//})(jQuery, window.PHD || (window.PHD = {}), window);
