(function($, PHD, window, undefined) {

    var $form = $("#file-recovery-form"),
        FLRForm,
        $backupCatalog = $("#file-recovery-backup-table"),
        $backupFilter = $("#file-recovery-backup-filter"),
        backupCatalog, backupFilter,
        backupCatalogView = BACKUP_CATALOG_VIEW_VM;
        //$recoveryType = $("[name=recovery_type]"),
        //$credentialType = $("[name=credential_type]"),
        //currentRecoveryType = FLR_TYPE_CIFS,
        //currentCredentialType = CREDENTIAL_TYPE_NONE,
        //$credentials = $("#file-recovery-credentials");

    var options = {};
    options[BACKUP_CATALOG_VIEW_VM] = {
        unique: "backup",
        0: { multiselect: false, childselect: "first", expandonselect: true },
        1: { multiselect: false, childselect: "all", expandonselect: true },
        2: { multiselect: true, childselect: false }
    };
    options[BACKUP_CATALOG_VIEW_DATE] = {
        unique: "backup",
        0: { multiselect: false, childselect: "first", expandonselect: true },
        1: { multiselect: false, childselect: "first", expandonselect: true },
        2: { multiselect: true, childselect: false }
       /*
        lmc - merged 3rd and 4th level since UEB does not have disk FLR
        2: { multiselect: false, childselect: "all", expandonselect: true },
        3: { multiselect: true, childselect: false }
        */
    };
    options[BACKUP_CATALOG_VIEW_BDS] = {
        unique: "backup",
        0: { multiselect: false, childselect: "first", expandonselect: true },
        1: { multiselect: false, childselect: "first", expandonselect: true },
        2: { multiselect: false, childselect: "all", expandonselect: true },
        3: { multiselect: true, childselect: false }
    };
    options[BACKUP_CATALOG_VIEW_APPLIANCE] = {
        unique: "backup",
        0: { multiselect: false, childselect: "first", expandonselect: true },
        1: { multiselect: false, childselect: "first", expandonselect: true },
        2: { multiselect: false, childselect: "all", expandonselect: true },
        3: { multiselect: true, childselect: false }
    };

    function initBackupsTable() {
        backupCatalog = PHD.BackupCatalog($backupCatalog, options[backupCatalogView]);
        backupFilter = PHD.BackupFilter($backupFilter, backupCatalog);

        backupCatalog.$table.on("treeselect", ".row-select", function() {
            selections = backupCatalog.getSelectionObject();
        });

        updateBackups();

    }

    function updateBackups() {
        var load = PHD.showLoadingIndicator($backupCatalog.parent()),
            task = PHD.BackupCatalogBuilder({
                "view": backupCatalogView, 
                "vms": {
                    "show": true,
                    "checkboxes": false
                },
                "disks": {
                    "show": true,
                    "checkboxes": false
                },
                "checked": selections,
                "loader": load
            });

        task
            .done(function(data) {
                buildCatalog(data);
            })
            .always(function() {
                PHD.hideLoadingIndicator(load);
            });
    }

    function buildCatalog(data) {
        backupCatalog.load(data);
        backupCatalog.refresh(options[backupCatalogView]);
        backupFilter.refresh(data.tree).submitFilter();
    }

    /*function initOptions() {
        $recoveryType.on("change", function() {
            currentRecoveryType = $(this).val();
            handleRecoveryType(currentRecoveryType);
        });

        handleRecoveryType(currentRecoveryType);

        $credentialType.on("change", function() {
            currentCredentialType = $(this).val();
            handleCredentialOptions(currentRecoveryType, currentCredentialType);
        });

        handleCredentialOptions(currentRecoveryType, currentCredentialType);
    }
    */

    /*function handleRecoveryType(recoveryType) {
        $credentials.find("[class^=credential-option]").hide();
        $credentials
            .find(".credential-option-" + recoveryType)
            .show()
        .find("input:radio").eq(0)
            .prop("checked", true);
    }
    */

    /*function handleCredentialOptions(recoveryType, credentialType) {
        if(recoveryType == FLR_TYPE_CIFS && credentialType == CREDENTIAL_TYPE_FILE_REC_CREDS) {
            $(".credential-option-" + FLR_TYPE_CIFS).find("input:not(:radio)").prop("disabled", false);
        } else {
            $(".credential-option-" + FLR_TYPE_CIFS).find("input:not(:radio)").prop("disabled", true);
        }

        if(recoveryType == FLR_TYPE_ISCSI && credentialType == CREDENTIAL_TYPE_CUSTOM) {
            $(".credential-option-" + FLR_TYPE_ISCSI).find("input:not(:radio)").prop("disabled", false);
        } else {
            $(".credential-option-" + FLR_TYPE_ISCSI).find("input:not(:radio)").prop("disabled", true);
        }
    } */

    function initForm() {
        //$recoveryType.eq(1).prop('disabled', true);

        $.validator.addMethod("validate-catalog", function(value, element) {
                return $backupCatalog.find("input[name=backup]:checked").length > 0;
            },
            "Select at least one Backup"
        );

        FLRForm = PHD.FormController($form, {
            namespace: "flrform",
            serialize: function($form) {
                return $form.serialize() + "&" + backupCatalog.getSelections();
            }
        });

        FLRForm
            .validate({
                rules: {
                    confirm_password: {
                        equalTo: "#id_password"
                    },
                    cifs_password: {
                        minlength: 12,
                        maxlength: 16
                    },
                    cifs_confirm_password: {
                        equalTo: "#id_cifs_password"
                    }
                },
                messages: {
                    confirm_password: {
                        equalTo: gettext("Your password must be the same in both fields")
                    },
                    cifs_password: {
                        minlength: gettext("Your password must be 12 characters long")
                    },
                    cifs_confirm_password: {
                        equalTo: gettext("Your password must be the same in both fields")
                    }
                }
            })
            .on("formcancel", function(event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                data = {};
                data.result = [ {'message': 'File level recovery job successfully started.'}];
                var options = {};
                if (window.location.href.indexOf("#/protect") !== -1 || window.location.href.indexOf("#/jobs") !== -1)  {
                    console.log("options ", options);
                    options.buttons = [
                        {
                            text: gettext("View FLR"),
                            click: function() {
                                window.location.href="#/recover/#1";
                                $(this).dialog("destroy").remove();
                            }
                        }
                    ];
                }
                PHD.throwNotice(data, options);

                PHD.currentDialog.wizard("close");
            });

        FLRForm.submit = function() {
            // lmc - TODO - ned a good way to customize the standard submit.
            var self = this,
                load = PHD.showLoadingIndicator("body", true, "Starting File Level Recovery...");

            this.$buttons.blur().disable();

            //var submitData = form2js(this.$form.attr("id"), '.', false);

            var selectionObj = backupCatalog.getSelectionObject();
            console.log("selected object = " + JSON.stringify(selectionObj));

            var backups = selectionObj.backups;
            var bids = backups[0];
            var system_id = selectionObj.system_id;
            PHD.appliance_sid = system_id;

            var restoreObj = {};
            restoreObj.backup_id = bids;
            restoreObj = JSON.stringify(restoreObj);
            console.log('=== Submit form: object = ' + restoreObj);

            var sid = (PHD.appliance_sid === null) ? "" : "?sid=" + PHD.appliance_sid;
            var url = "/api/restore/files/" + sid;
            console.log("POST url is " + url);
            PHD.Ajax
                .post(url, restoreObj)
                .done(function(data) {
                    self.$form.trigger("formsubmit", [data, self.$form, self]);
                })

                .always(function() {
                    self.$buttons.enable();
                    PHD.hideLoadingIndicator(load);
                });

            return this;
        };
    }

    function initFilters() {
        $backupCatalog.on("click",".btn-dateview",  function(event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_DATE;
            updateBackups();
        });

        $backupCatalog.on("click", ".btn-vmview", function(event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_VM;
            updateBackups();
        });

        $backupCatalog.on("click", ".btn-bdsview", function(event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_BDS;
            updateBackups();
        });
        
        $backupCatalog.on("afterfilter backupcatalogload", function() {
            $backupCatalog.scrollTable({"height": "article", "resize": false});
        });
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        initBackupsTable();

        //initOptions();

        initFilters();

        initForm();
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
