function processRecoverPage(PHD, window, $rootScope, $analytics) {

    var tabs = [],
        initialTab = $.cookie("initial_tab_recover") || 0,
        currentTabIndex = 0,
        backupCatalog, backupFilter,
        pageRefresh = null,
        $backupCatalog = $("#recover-backup-table"),
        $backupFilter = $("#recover-backup-catalog-filter"),
        backupSelections,
        backupCatalogView = BACKUP_CATALOG_VIEW_VM,
        // lmc - change back to original (VM view)
        //backupCatalogView = BACKUP_CATALOG_VIEW_DATE,
        RECOVER_TAB_BACKUPS = 0,
        RECOVER_TAB_FLR = 1,
        RECOVER_TAB_IR = 2,
        DETAIL_TABLE_HEIGHT = 250,
        slugs = ['backups', 'flr', 'ir'],
        $flrTable = $("#recover-flr-table"),
        flrTreeTable;

    // lmc - add this.
    var RecoverTimer = $rootScope.RecoverTimer;

    var options = {};
    options[BACKUP_CATALOG_VIEW_VM] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: false, expandonselect: true},
        2: {multiselect: true, childselect: false}
    };
    options[BACKUP_CATALOG_VIEW_DATE] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: "all", expandonselect: true},
        2: {multiselect: true, childselect: false, expandonselect: true},
        3: {multiselect: true, childselect: false}
    };
    options[BACKUP_CATALOG_VIEW_BDS] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: "all", expandonselect: true},
        2: {multiselect: true, childselect: false, expandonselect: true},
        3: {multiselect: true, childselect: false}
    };

    $(document).on("ajaxaborted ajaxtimeout", function () {
        if (pageRefresh !== null) {
            clearInterval(pageRefresh);
        }
    });

    $(document)
        .on("timertick.recoverpage", $.proxy(refreshPage, this));

    $(document)
        .on("uinav.dashboard", function (event) {
            console.log("=====>Selected Dashboard");
            stopAll();
        })
        .on("uinav.protect", function (event) {
            console.log("=====>Selected Protect");
            stopAll();
        })
        .on("uinav.recover", function (event) {
            console.log("=====>Selected Recover");
        })
        .on("uinav.jobs", function (event) {
            console.log("=====>Selected Jobs");
            stopAll();
        })
        .on("uinav.configure", function (event) {
            console.log("=====>Selected Configure");
            stopAll();
        })
        .on("uinav.reports", function (event) {
            console.log("=====>Selected Reports");
            stopAll();
        });

    function stopAll() {
        RecoverTimer.stop();
        $(document).off("timertick.recoverpage");
        delete $(document);
    }

    function refreshPage(manual) {
        var manual = (manual === true),
            tab = tabs[currentTabIndex];
        if (manual) {
            tab.update(manual);
        } else {
            tab.update(false);
        }
    }

    function resizeTable() {
        this.adjustTableHeight(this.getAvailableVerticalSpace(".full-height"));
        this.adjustTableWidth();
    }

    function initTabs() {
        $(".ui-tabs-panel").each(function (index) {
            tabs[index] = new RecoverTab(index, $(this));
            tabs[index].initButtons();

            if (index === RECOVER_TAB_BACKUPS) {
                initBackupsTab(tabs[index]);
            } else if (index === RECOVER_TAB_FLR) {
                initFLRTab(tabs[index]);
            } else if (index === RECOVER_TAB_IR) {
                initIRTab(tabs[index]);
            }
        });
    }

    var IRFormatter = {
        /*backup_info: function (value, row) {
            return moment(value).zone(tz).format("M/D/YYYY h:mmA")
        },
        write_space_used: function (value, row) {
            return PHD.util.formatBytes(value);
        },
        started: function (value, row) {
            return moment(value).zone(tz).format("M/D/YYYY h:mmA")
        } */
    };

    var IRDetailsFormatter = {
        comment: function (value, row) {
            return '<span class="truncates item-name" title="' + value + '">' + value + '</span>';
        }
    };

    function initIRTab(tab) {
        tab.$details = tab.$panel.find(".job-detail").hide();

        tab.$sessionTable = tab.$panel.find("#ir-session-table");
        tab.$jobTable = tab.$panel.find("#ir-session-jobs-table");

        tab.$selected = $();
        tab.selectedID = null;

        tab.$selectedJob = $();
        tab.selectedJobID = null;
        tab.rowData = null;

        tab.SessionTable = PHD.DataTable(tab.$sessionTable, {
            select: true,
            placeholder: gettext("There are no active Instant Recovery VMs"),
            sortable: true,
            integerIDs: false   //lmc - e.g., 65.ir
        }).registerFormatters(IRFormatter);

        tab.JobTable = PHD.DataTable(tab.$jobTable, {
            select: true,
            placeholder: gettext("There are no jobs to display"),
            sortable: false,
            cellClasses: [null, null, null, "long-text truncate"]
        }).registerFormatters(IRDetailsFormatter);

        tab.timestamp = 0;
        tab.inventoryTimestamp = 0;
        tab.inventoryOpen = false;

        tab.$sessionTable.on("rowselect", function (event, dbid, $row, DataTable, DataRow) {
            tab.$selected = $row;
            tab.selectedID = dbid;
            tab.rowData = DataRow.data;
            tab.updateButtons();
            if (tab.inventoryOpen) {
                tab.showJobDetails();
            }
        });

        tab.showJobDetails = $.proxy(showIRJobs, tab);
        tab.hideJobDetails = $.proxy(hideIRJobs, tab);
        tab.updateJobs = $.proxy(updateIRJobs, tab);
    }

    var updateIRJobs = function (reset, sessionID) {
        if (this.inventoryOpen && this.selectedID && this.selectedID === sessionID) {
            var load = reset ? PHD.showLoadingIndicator(this.$details) : null;
            var self = this;
            var url = "/api/jobs/active/ir/" + sessionID + '/';

            var request = PHD.Ajax.get(url, load);

            request.done(function (data) {
                //PHD.hideLoadingIndicator(load);
                var irs = data.data;
                if (irs !== undefined && Array.isArray(irs)) {
                    irs.forEach(function (ir, index) {
                        if (ir.id == self.selectedID) {
                            self.inventoryTimestamp = data.timestamp;
                            var ir_array = [ ir ];
                            if (reset) {
                                self.JobTable.load(ir_array);
                            } else {
                                self.JobTable.update(ir_array, true);
                            }
                            self.$jobTable.scrollTable({"height": DETAIL_TABLE_HEIGHT});

                            self.updateButtons();
                        }
                    });
                }
            });
        }
    };

    var showIRJobs = function () {
        this.inventoryTimestamp = 0;
        if (this.$details.is(":hidden")) {
            this.$sessionTable
                .adjustTableHeight(this.$sessionTable.getAvailableVerticalSpace(".full-height") - DETAIL_TABLE_HEIGHT);
            this.$details.show("slide", {direction: "down"});
            this.inventoryOpen = true;
            this.updateJobs(true, this.selectedID);
        } else {
            this.updateJobs(true, this.selectedID);
        }
        this.updateButtons();
    };

    var hideIRJobs = function () {
        var self = this;
        this.$details.hide("slide", {direction: "down"}, function () {
            self.$sessionTable
                .adjustTableHeight(self.$sessionTable.getAvailableVerticalSpace(".full-height"));
            self.inventoryOpen = false;
            self.updateButtons();
        });
    };

    function initBackupsTab(tab) {
        backupCatalog = PHD.BackupCatalog($backupCatalog, options[backupCatalogView]);
        backupFilter = PHD.BackupFilter($backupFilter, backupCatalog);

        initFilters();

        backupCatalog.$table
            .on("treeselect", ".row-select", function () {
                backupSelections = backupCatalog.getSelections();
                tab.$buttons.find("a").each(function () {
                    var $but = $(this),
                        $selected = backupCatalog.$table.find(".row-select:checked").closest("tr");
                    $but.data("selections", backupSelections);
                    PHD.buttonLogic($but, $selected, tab, null, null, $analytics);
                });
            })
            .on("backupcatalogloadchildren", function () {
                $(this).scrollTable({"height": "article"});
            });
        tab.TreeTable = backupCatalog;
    }

    function update(tab, init) {
        init = (init === true);
        if (tab.index === RECOVER_TAB_BACKUPS) {
            updateCatalog(init);
        } else if (tab.index === RECOVER_TAB_FLR) {
            updateFLR(init, tab);
        } else if (tab.index === RECOVER_TAB_IR) {
            updateIR(init, tab);
        }
        tab.updateButtons();
    }

    function updateIR(init, tab) {
        var url = "/api/jobs/active/ir/",
            update = PHD.Ajax.get(url);

        update.done(function (data) {
            if (data.timestamp === tab.timestamp) {
                tab.timestamp += 1;
            } else {
                tab.timestamp = data.timestamp;
            }

            tab.SessionTable.update(data.data, true);
            tab.$sessionTable.scrollTable();
            RecoverTimer.stop();
            RecoverTimer.start();

            tab.updateJobs(false, tab.selectedID);

            $(window)
                .off("resize.ir")
                .on("resize.ir", PHD.util.debounce($.proxy(resizeTable, tab.$sessionTable)));

            tab.updateButtons();
        });
    }

    function updateCatalog(init) {
        if (init) {
            var selections = backupCatalog.getSelectionObject(),
                load = PHD.showLoadingIndicator($backupCatalog.parent()),
                task = PHD.BackupCatalogBuilder({
                    "view": backupCatalogView,
                    "checked": selections,
                    "loader": load
                });

            task
                .done(function (data) {
                    updateBackupsTable(data);
                    tabs[currentTabIndex].updateButtons();
                })
                .always(function () {
                    PHD.hideLoadingIndicator(load);
                });
        } else {
            console.log("BC inc update");
            // TODO: Backup Catalog incremental update?
        }
    }

    function updateBackupsTable(data) {
        backupCatalog.load(data);
        backupCatalog.refresh(options[backupCatalogView]);
        backupFilter.refresh(data.tree).submitFilter();
    }

    function updateFLR(init, tab) {
        var url = "/api/jobs/active/flr/";
        var update = PHD.Ajax.get(url);
        update.done(function (data) {
            if (init === true) {
                initFLRTable(data);
                RecoverTimer.stop();
                RecoverTimer.start();
            } else {
                var ids = tab.getFLRIds();
                updateFLRTable(data, ids);
                RecoverTimer.resume();
            }
        });
    }

    var flrTmpl = _.template(
        '<% for (var i = 0; i < data.length; i++) { %>' +
            '<% var flr = data[i]; %>' +
            '<% flr.iSCSI = (flr.available_targets !== null && flr.available_targets.indexOf("iscsi") != -1) ? "Yes" : "No"; %>' +
            '<% flr.CIFS = (flr.available_targets !== null && flr.available_targets.indexOf("smb") != -1) ? "Yes" : "No"; %>' +
            '<tr data-type="flr" flr_id="<%= flr.id %>" system-id="<%= flr.system_id %>" data-depth="0" class="level-0">' +
            '<td>' +
                '<input type="checkbox" name="flr" id="id_flr_<%= flr.id %>" value="<%= flr.id %>" class="row-select"> ' +
                '<i title="Virtual Machine" class="icon-hv-vm icon"></i>' +
                '<span class="item-name"><%= flr.asset_name %></span>' +
            '</td>' +
            '<td class="job-status-display" data-source="status"><%= flr.status %></td>' +
            '<td data-source="start_date"><%= flr.start_date %></td>' +
            '<td data-source="duration"><%= flr.duration %></td>' +
            '<td data-source="available_targets"><%= flr.iSCSI %></td>' +
            '<td data-source="available_targets"><%= flr.CIFS %></td>' +
            '</tr>' +
        '<% } %>'
    );

    // no checkbox, as no structure
    /*
     '<div class="expand-ctrl"></div>' +
     '<input type="checkbox" name="flr" id="id_flr_<%= flr.id %>" value="<%= flr.id %>" class="row-select"> ' +
     '<i title="Virtual Machine" class="icon-hv-vm icon"></i>' +
     '<span class="item-name"><%= flr.asset_name %></span>' +
     '</td>' +
     '<td data-source="status"><%= flr.status %></td>' +
     '<td data-source="start_date"><%= flr.start_date %></td>' +
     '<td data-source="available_targets"><%= flr.available_targets %></td>' +
     '</tr>' +
     */

    // stuff removed from template
    /*'<% for(var d=0;d<flr.disk.length;d++) { %>' +
     '<% var disk = flr.disk[d]; %>' +
     '<tr data-type="flrdisk" data-depth="1" class="level-1">' +
     '<td>' +
     '<i title="disk" class="icon-hv-drive icon"></i>' +
     '<span class="item-name"><%= disk.data.name %></span>' +
     '<span class="disk-size">(<%= disk.data.total_storage %>)</span>' +
     '</td>' +
     '<td></td>' +
     '<td></td>' +
     '<td></td>' +
     '</tr>' +
     '<% } %>' +
     */

    // if ids are passed in, we could optionally look to add just these.
    function getNewFLR(ids) {
        var html = "",
            url = "/api/jobs/active/flr/",
            update = PHD.Ajax.get(url);

        update.done(function (data) {
            if (ids !== undefined && ids.length > 0) {
                var new_items = [];
                data.data.forEach(function(obj, index) {
                    ids.forEach(function(id, index) {
                        if (obj.id == id) {
                            new_items.push(obj);
                        }
                    });
                });
                data.data = new_items;
            } else {
                data.objects = data.data;
            }
            //console.log("JSON return on flr is " + JSON.stringify(data.data));
            html = flrTmpl(data) + $flrTable.find("tbody").html();
            $flrTable.find("tbody").html(html);
            $flrTable.scrollTable({"height": "section"});
            flrTreeTable.refresh();
        });
    }

    function initFLRTable(data) {
        $flrTable.find("tbody").html(flrTmpl(data));
        $flrTable.scrollTable({"height": "section"});
        flrTreeTable.refresh();
    }

    function updateFLRTable(data, ids) {
        var flrs = data.data,
            create = [];

        flrs.forEach(function (flr, index) {
            var id = flr.id,
                status = flr.status,
                stateTxt = flr.status,
                detailsTxt = flr.share_details,
                durationTxt = flr.duration;

            if (detailsTxt == 'null') {
                detailsTxt = 'None';
            }

            if (!_.contains(ids, id)) {
                create.push(id);
            } else {
                $node = flrTreeTable.getNodeById("flr", id);
                if ($node !== undefined) {
                    $node.find("[data-source=status]").html(stateTxt);
                    $node.find("[data-source=duration]").html(durationTxt);
                    $node.find("[data-source=share_details]").html(detailsTxt);
                }
            }
        });

        if (create.length) {
            getNewFLR(create);
        }
    }

    function initFLRTab(tab) {
        var options = {
            0: {multiselect: false, childselect: "all"}
        }
        flrTreeTable = PHD.TreeTable($flrTable, options);

        flrTreeTable.$table.on("treeselect", ".row-select", function (event, $row, checked) {
            var queryString = flrTreeTable.getSelections();

            if (!checked) {
                $row = null;
            }

            tab.$buttons.find("a").each(function () {
                var $but = $(this);
                $but.data("selections", queryString);
                PHD.buttonLogic($but, $row, tab, null, null, $analytics);
            });
        });

        tab.TreeTable = flrTreeTable;
        //updateFLR();
    }

    var RecoverTab = function (index, panel) {
        this.index = index;
        this.$panel = panel;
        this.$buttons = this.$panel.find(".button-bar");
    };

    RecoverTab.prototype.update = function (init) {
        update(this, init);
    };

    RecoverTab.prototype.initButtons = function () {
        var tab = this;

        this.$buttons.find("a").each(function (index) {
            var $but = $(this);
            $but.data("selections", null);
            $but.data("catalog-view", backupCatalogView);
            PHD.buttonLogic($but, null, tab, null, null, $analytics);
        });
    };

    RecoverTab.prototype.updateButtons = function ($button) {
        var $rows,
            tab = this,
            $catalog = tab.index === RECOVER_TAB_BACKUPS ? $backupCatalog : $flrTable;

        if ($button !== void 0) {
            if (tab.index === RECOVER_TAB_IR) {
                PHD.buttonLogic($button, $row, tab, null, tab.rowData, $analytics);
            } else {
                PHD.buttonLogic($button, $row, tab, null, null, $analytics);
            }
        } else {
            this.$buttons.find("a").each(function (index) {
                var $but = $(this);
                if (tab.TreeTable !== void 0) {
                    $rows = $catalog.find(".row-select:checked").closest("tr");
                    $but.data("selections", tab.TreeTable.getSelections());
                } else {
                    $rows = tab.$selected;
                    $but.data("selections", "");
                }
                $but.data("catalog-view", backupCatalogView);
                if (tab.index === RECOVER_TAB_IR) {
                    PHD.buttonLogic($but, $rows, tab, null, tab.rowData, $analytics);
                } else {
                    PHD.buttonLogic($but, $rows, tab, null, null, $analytics);
                }
            });
        }
    };

    RecoverTab.prototype.getSelections = function () {
        var selections = this.TreeTable.getSelections();
        return selections;
    };

    RecoverTab.prototype.pinRows = function (id, action) {
        var ids = [id];
        if (action === "pin") {
            backupCatalog.pin(ids);
        } else {
            backupCatalog.unpin(ids);
        }

        backupCatalog.deselectAll();
    };

    var backupTmpl = _.template(
        '<table class="backup-list user-backups data-table dashboard-table">' +
        '<thead><tr>' +
        '<th>' + " Name" + '</th><th>' + "Secondary Name" + '</th><th>' + "Type" + '</th><th>' + 'Status' + '</th><th>' + "Date" + '</th>' +
        '</tr></thead><tbody>' +
        '<% for(var i=0;i<data.length;i++) { %>' +
            '<% data[i].primary_name = data[i].primary_name == undefined ? (data[i].server_instance_name == undefined ? data[i].client_name : data[i].server_instance_name) : data[i].primary_name; %>' +
            '<% data[i].secondary_name = data[i].secondary_name == undefined ? data[i].database_name : data[i].secondary_name; %>' +
            '<tr>' +
            '<td><span class="truncates"><%= data[i].primary_name %></span></td>' +
            '<td><%= data[i].secondary_name %></td>' +
            '<td><%= data[i].type %></td>' +
            '<td><%= data[i].status %></td>' +
            '<td><%= data[i].start_time %></td>' +
            '</tr>' +
        '<% } %>' +
        '</tbody></table>'
    );

    RecoverTab.prototype.confirmDelete = function (data) {
        var self = this;
        var message = '<h4 class="text-ok">' + "The following backups will be deleted:" + '</h4>';
        var system_id = 1; // lmc - TODO for grid.
        var sid = 1;    // lmc - TODO for grid.

        // add in original backup info.
        var backups = data.data;
        if (backups && backups.length) {
            ids = _.pluck(backups, 'id');
            message += backupTmpl(data);
            system_id = backups[0].system_id;
            PHD.appliance_sid = sid; // system_id;

            confirm = PHD.confirmDialog(
                message,
                {
                    title: gettext("Confirm Backup Deletion"),
                    open: function (event, ui) {
                        var $dialog = $(this);
                        $dialog.find("table.data-table").scrollTable({"height": 120, "resize": false});
                        $dialog.find(".ui-dialog-buttonset button:last-child").focus();
                        $dialog.dialog("option", "position", {my: "center", at: "center", of: window});
                    }
                }
            );

            confirm.done(function () {
                var str_ids = ids.toString();
                var sid = (PHD.appliance_sid === null) ? "" : "/?sid=" + PHD.appliance_sid;
                var url = "/api/backups/" + str_ids + sid;
                var resp = PHD.Ajax.delete(url);

                resp.done(function(data) {
                    console.log("done with backup deletion, clearing ids: " + str_ids);
                    self.deleteRows('backup', ids);
                    self.updateButtons();
                });
            });
        } else {
            message = '<h4 class="text-ok">' + "There are no backups to delete." + '</h4>';
            var options = PHD.dialogs.alert;
            $("<div/>", {
                id: "dialog-ajax-error",
                title: "Error deleting backups",
                "class": "dialog-box"
            })
                .hide()
                .appendTo("body")
                .html(message)
                .dialog(options);
        }
    };

    RecoverTab.prototype.deleteRows = function (node_type, ids) {
         ids.forEach(function (id) {
            backupCatalog.deleteNodeById(node_type, id);
         });
     };

    /*RecoverTab.prototype.deleteRows = function (nodes) {
        nodes.forEach(function (node) {
            backupCatalog.deleteNodeById(node.type, node.id);
        });
    };*/

    RecoverTab.prototype.deleteFLR = function (flr_id) {
        flrTreeTable.deleteNodeById("flr", flr_id);
        $flrTable.scrollTable({"height": "section"});
        flrTreeTable.refresh();
    };

    RecoverTab.prototype.getFLRIds = function () {
        return $flrTable
            .find("[data-type=flr]")
            .map(function () {
                //return parseInt($(this).attr("flr_id"), 10);
                //lmc - not numeric
                return $(this).attr("flr_id");
            })
            .get();
    };

    var flrDetailTmpl = _.template(
        '<table style="font-size:12px;max-width:100%;width:100%;line-height:29px">' +
        '<tr>' +
        '<td style="width:100px">' + '<strong>' + gettext('Name') + '</strong>:' + '</td>' +
        '<td> <%= instance_name %> (<%= application %> VM)' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettext('Created') + '</strong>:' + '</td>' +
        '<td> <%= start_date %> ' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettext('Appliance') + '</strong>:' + '</td>' +
        '<td> <%= system_name %> ' + '</td>' +
        '</tr>' +
        '<tr><td>&nbsp;</td><td>&nbsp;</td></tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettext('CIFS Path') + '</strong>:' + '</td>' +
        '<td> <%= share_details %> ' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td style="vertical-align:top">' + '<strong>' + gettext('iSCSI') + '</strong>:' + '</td>' +
        '<td style="white-space:normal;word-wrap:break-word;vertical-align:top"> <%= iscsi_details %> ' + '</td>' +
        '</tr>' +
        '<tr><td>&nbsp;</td><td>&nbsp;</td></tr>' +
        '<tr>' +
        '<td style="vertical-align:top">' + '<strong>' + gettext('Messages') + '</strong>:' + '</td>' +
        '<td style="white-space:normal;word-wrap:break-word;vertical-align:top"> <%= comment %> ' + '</td>' +
        '</tr>' +
        '</table>'
    );

    RecoverTab.prototype.showFLRDetails = function (id, system_id) {
        var resp, options;

        options = {
            modal: true,
            draggable: true,
            resizable: false,
            width: 550,
            height: 400,
            dialogClass: "dialog-flr-detail",
            title: gettext("File Level Recovery Details"),
            buttons: [
                {
                    text: gettext("Close"),
                    click: function () {
                        $(this).dialog("destroy").remove();
                    }
                }
            ]
        };

        resp = PHD.Ajax.get("/api/jobs/active/flr/" + id + "/?sid=" + system_id);

        resp.done(function (data) {
            // lmc - TODO - right now, we get 'em all.  Eventually we should only get one.
            if (data && data.data !== undefined) {
                var flrs = data.data;
                for (var i = 0; i < flrs.length; i++) {
                    var obj = flrs[i];
                    // find the right one.
                    if (id.indexOf(obj.id) !== -1) {
                        if (obj.share_details === null) {
                            obj.share_details = "None";
                        }
                        if (obj.iscsi_details === null) {
                            obj.iscsi_details = "N/A";
                        } else {
                            obj.iscsi_details = "Use the Windows iSCSI initiator to connect to the image, or if Linux, login to the server or VM " +
                                "to which you want to copy files and download and run the script located at " + obj.iscsi_details + '.';
                        }
                        if (obj.comment === null) {
                            obj.comment = "None";
                        }
                        $("<div>", {
                            id: "flr-detail-" + id,
                            "class": "flr-detail"
                        })
                            .html(flrDetailTmpl(obj))
                            .dialog(options);
                        break;
                    }
                }
            }
        });
    };

    function initFilters() {
        $backupCatalog.find(".btn-dateview").on("click", function (event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_DATE;
            updateCatalog(true);
        });

        $backupCatalog.find(".btn-vmview").on("click", function (event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_VM;
            updateCatalog(true);
        });

        $backupCatalog.find(".btn-bdsview").on("click", function (event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_BDS;
            updateCatalog(true);
        });

        $backupCatalog.find(".check-select-all").on("change", function (event) {
            if ($(this).prop("checked")) {
                backupCatalog.selectAll();
            } else {
                backupCatalog.deselectAll();
            }
        });

        $backupCatalog.on("afterfilter backupcatalogload", function () {
            tabs[0].updateButtons();
            $backupCatalog.scrollTable({"height": "article"});
        });
    }

    function handleTabChange() {
        tabs[currentTabIndex].update(true);
        $(document).trigger("tabchange", ["recover" + slugs[currentTabIndex]]);
    }

    function initializePage(PHD) {
        console.log('phd is ' + PHD + ' and jquery is ' + jQuery + ' and window is ' + window);
        if (!isNaN(PHD.util.getHashInt())) {
            initialTab = PHD.util.getHashInt();
        }
        $(".with-tooltip").tooltip({
            position: {
                "my": "left top",
                "at": "left bottom",
                "collision": "flip"
            },
            tooltipClass: "button-help"
        });
        $('.tabs-wrapper').tabs({
            active: initialTab,
            create: function (event, ui) {
                currentTabIndex = ui.tab.index();
                initTabs();
                handleTabChange();
            },
            activate: function (event, ui) {
                currentTabIndex = ui.newTab.index();
                $.cookie("initial_tab_recover", currentTabIndex, {expires: 365, path: '/'});
                handleTabChange();
            }
        });
    }

    initializePage(PHD);
}
