var protectTourModel =  angular.module('tourRecoverModel',['tour-module']);

protectTourModel.controller('tourRecoverCtrl', function ($scope, $rootScope, tourFactory){

    var $tour               = $("#recover-tour"),
        $backup             = $("#tour-backups"), 
        $backupOption       = $("#tour-backup-options"),
        $fileRecovery       = $("#tour-file-recovery"),
        $instantRecovery    = $("#tour-instant-recovery");
    
        var $recoverTarget  = $("#widget-tour-recover");
        $scope.$currentStep = $rootScope.user.tourStep;


    $scope.initTour = function() {
        $(window).on("resize.tour",  PHD.util.debounce($scope.positionTour));
        $scope.positionTour();
        $tour.addClass("active");
    }


    $scope.positionTour = function() {
        $backup.position({
            my: "center",
            at: "center",
            of: $recoverTarget,
            using: positionElement
        });
        $backupOption.position({
            my: "left-400 center",
            at: "top+264",
            of: $recoverTarget,
            using: positionElement
        });
        $fileRecovery.position({
            my: "left-490 center",
            at: "top+215",
            of: $recoverTarget,
            using: positionElement
        });
        $instantRecovery.position({
            my: "left-390 center",
            at: "top+215",
            of: $recoverTarget,
            using: positionElement
        });
    }

    function positionElement(attr, obj) {
        obj.element.element.css({
            top: attr.top,
            left: attr.left,
            position: 'absolute'
        });
    }

    $scope.endTour = function() {
        $(window).off("resize.tour");
        $(".tour-position").css("z-index", "auto");
        $tour.remove();
        $scope.$currentStep = $rootScope.user.tourStep = 1;
    
        var putData = {};
        putData['show_help_overlay'] = 'false';
        
       // PHD.Ajax.put('/api/preferences/' + $scope.user.name, JSON.stringify(putData));
        
        var prefURL = '/api/preferences/' ;
            prefURL = prefURL + $rootScope.user.name+"/";
            tourFactory.sync('put',prefURL,1,putData).then(function(result){
                console.log("success >> Recover");
            });
        
        $rootScope.user.showTour= false; 
        $scope.refreshPage();
    }

    /* 
     * Refresh App-main page
     */
     $scope.refreshPage = function(){
        var currentPage = angular.element(document.getElementById("app-main"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    $scope.reloadContent = function(){
        var currentPage = angular.element(document.getElementById("recover-tour"));
        var injector = currentPage.injector();
        var route = injector.get('$route');
        route.reload();
    }
    
    $scope.setNextTourStep = function() {
        if($scope.$currentStep === 14) {
            //have to set the step before moving to the next page
            $scope.$currentStep = $rootScope.user.tourStep += 1;
            //go to the protect page
            window.location.href = "#/jobs/";
            setTimeout(function(){
                $("#activeJob a").trigger('click');
                $("#jobPane").addClass("tourHilighter");
            }, 1000);
        }else{
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep+=1; 
            $scope.positionTour();
            
             switch(parseInt($scope.$currentStep)) {
                    case 11:
                        setTimeout(function(){
                            
                            $("#activeJob a").trigger('click');
                            $("#recover-backup-table").addClass("tourHilighter");
                        }, 500); 
                        break;
                    case 12:
                        setTimeout(function(){
                            $("#recover-backup-buttons").addClass("tourHilighter");
                        }, 500);
                        break;
                    case 13:
                        setTimeout(function(){
                            $("#fileLevelRecover a").trigger('click');
                            $( "#fileLevelRecover" ).addClass("tourHilighter");
                            $("#recover-flr-list" ).addClass("tourHilighter");
                        }, 500);
                        break;
                    case 14:
                        setTimeout(function(){
                            $("#instantRecovery a").trigger('click');
                            $("#instantRecovery").addClass("tourHilighter");
                            $("#recover-ir").addClass("tourHilighter");                            
                        }, 500);
                        break;
                     default: $scope.reloadContent();
                        break;
                }
             
        }
        
    }

    $scope.setPreviousTourStep = function() {
        if(parseInt($scope.$currentStep) === 11) {
            //have to set step change before going back
            $scope.$currentStep = $rootScope.user.tourStep -=1; 
            
            //go back to the protect page
            window.location.href = "#/protect/";
            
            setTimeout(function(){
                $("#protect-status-table > tfoot ").addClass("tourHilighter");
            }, 500);
        } else {
            
            $scope.reloadContent();
            $scope.$currentStep = $rootScope.user.tourStep -=1; 
            $scope.positionTour();
                       
            switch(parseInt($scope.$currentStep)) {
                    case 11:
                        setTimeout(function(){
                            $("#recover-backup-table").addClass("tourHilighter");
                        }, 500); 
                        break;
                    case 12:
                        setTimeout(function(){
                            $("#recover-backup-buttons").addClass("tourHilighter");
                        }, 500);
                        break;
                    case 13:
                        setTimeout(function(){
                            $("#fileLevelRecover a").trigger('click');
                            $( "#fileLevelRecover" ).addClass("tourHilighter");
                            $("#recover-flr-list" ).addClass("tourHilighter");
                            
                        }, 500);
                        break;
                    case 14:
                        setTimeout(function(){
                            $("#instantRecovery a").trigger('click');
                            $("#instantRecovery").addClass("tourHilighter");
                            $("#recover-ir").addClass("tourHilighter");
                            //$("#ir-session-table").addClass("tourHilighter");
                        }, 500);
                        break;
                     default: $scope.reloadContent();
                        break;
                }
        }
    }
    angular.element(document).ready(function () {
        $scope.initTour();
        $scope.positionTour();
    });
});

    
