var MINPERCENT = 0.00001;
var barWidth ;

function formatMBToGB(input)
{
     
     var str = PHD.util.formatMB(input);
     var split_value = str.split(" ");
     if (split_value[1] == 'GB')
     {
          return split_value[0];
     }
    else{
        return (input/1024).toFixed(1);
    }
    
}

reportApp.filter('nullTestFilter', function($filter) {
  return function(input) {

	  if ( input == undefined || input == null || input =="")
	  {
		  if(input===false){
			  return false;
		  }else if(parseInt(input) != 0){
			  return '--';
		  }else{
			  return input;
		  }
	  }
	  else if ( input instanceof Array)
	  {
		  return input.toString();
	  }
	  else
	  {
		  return input;
	  }
    
  };
});
reportApp.filter('warnThreshold', function($filter) {
  return function(input) {
       return (input * .75);
    
  };
});

reportApp.filter('GBFormatter', function($filter) {
	return function(input) {
		return (input).toFixed(2);
	};
});

reportApp.filter('MBToGBFormater', function($filter) {
  return function(input) {
     return formatMBToGB(input);
  };
});

reportApp.filter('convertMBtoGBFilter', function($filter) {
  return function(input) {
       return (input/1024).toFixed(2);
    
  };
});
reportApp.filter('colHoldDayFilter', function($filter) {
        return function(input) {
          var value = parseInt(input);
		return (value == -1 ? "Hold Forever" : value);
        };
    });					

String.prototype.placeHolderManipulation = function(){
	var  placeholder= this.toString() ;
	if (placeholder =='SIZE (GB)'){
		return 'Size (GB)';
	}
	else if ( placeholder == 'LAST FULL (GB)')
	{
		return 'Last Full (GB)';
	}
	else{
		return placeholder.toLocaleLowerCase();
	}
}

var headerCellTemplate = '<div class="ngHeaderSortColumn {{col.headerClass}}" ng-style="{cursor: col.cursor}" ng-class="{ ngSorted: !noSortVisible }">'+
											   '<div ng-click="col.sort($event)" ng-class="\'colt\' + col.index" class="ngHeaderText">{{col.displayName}}</div>'+
											   '<div class="ngSortButtonDown" ng-show="col.showSortButtonDown()"></div>'+
											   '<div class="ngSortButtonUp" ng-show="col.showSortButtonUp()"></div>'+
											   '<div class="ngSortPriority">{{col.sortPriority}}</div>'+
											   '</div>'+
											   '<input type="text" class="medium" ng-click="stopClickProp($event)" placeholder={{col.displayName.placeHolderManipulation()}} ng-model="col.filterText" ng-style="{ \'width\' : col.width - 14 + \'px\' }" style="position: absolute; top: 30px; bottom: 30px; left: 3px; bottom:0;"/>' +
											   '<div ng-show="col.resizable" class="ngHeaderGrip" ng-click="col.gripClick($event)" ng-mousedown="col.gripOnMouseDown($event)"></div>';
											   

var templateWithTooltip = '<div><a tooltip={{row.getProperty(col.field).toString()}} tooltip-append-to-body="true" tooltip-placement="auto" >{{row.getProperty(col.field).toString() | nullTestFilter}}</a></div>';

var teplateToNoneFilter = '<div style="height: 100%" ng-class="{green: row.getProperty(\'age\') < 30}"><div ng-style="{ \'cursor\': row.cursor }" ng-repeat="col in renderedColumns" ng-class="col.colIndex()" class="ngCell ">' +
                           '<div class="ngVerticalBar" ng-style="{height: rowHeight}" ng-class="{ ngVerticalBarVisible: !$last }"> </div>' +
                           '<div ng-cell></div>' +
						  '</div></div>';		
var clickRowTemplete = '<div  class ="ngCellTextBackupFailure" ng-click="onBackupFailureRowClick()" ng-bind="row.getProperty(col.field)"></div>';
var recoveryHistoryRowTemplete = '<div  class="ngCellTextBackupFailure" ng-click="onRecoveryHistoryReportRowClick(row);" ng-bind="row.getProperty(col.field)"></div>';

/*'<div  ng-dblclick="onDblClickRow()" ng-bind="row.getProperty(col.field)"></div>'*/
					  					 
	/*
			This Function Returns config for each Report
			1. URL for rest API,
			2. Graph/Chart Function Name if Any
			3.Table heading
			4.Column Definition Array for grids.
			Note: Need to create function for column definition for each report
                  e.g. createProtectionSummaryColDefArray()			
			*/

							
function getReportConfigs($scope, reportId,isCe){
				reportID = parseInt(reportId);
				returnParrams=[];
				columnDefArray = [];
                
			switch (reportID) {
				case $scope.LEGAL_HOLD:
					returnParrams = ['/api/reports/backup/legal_hold/',"NoChart",[""]];
					columnDefArray = createLeagaHoldBackupList();
					break;
				case $scope.PROTECTION_SUMMARY:
					if(!$scope.isCE){
						returnParrams = ['/api/reports/protection_summary/',"PieChart",["Protected Asset Summary","Unprotected Asset Summary","Backup Assets","Replicated Client","Replicated VMs","Archived Clients","Archived VMs"]];
					} else {
						returnParrams = ['/api/reports/protection_summary/',"PieChart",["Protected Asset Summary","Unprotected Asset Summary","Backups", "Backup Copies"]];
					}
					columnDefArray = createProtectionSummaryColDefArray($scope.isCE);
					break;
				case $scope.BACKUP_HISTORY:
					returnParrams = ['/api/reports/backup/history/',"NoChart",[""]];
					columnDefArray = createBackupHistoryColDefArray();
					break;
				case $scope.STORAGE_DETAILS:
					returnParrams = ['/api/reports/storage/status/',"Pie-BarChart",[""]];
				    columnDefArray = createBackupStorageColDefArray(isCe);
				  	break;
				case $scope.UPDATES:
					returnParrams = ['/api/reports/system/update_history/',"NoChart",[""]];
					columnDefArray = systUpdateHistoryColDefArray();
					break;
				case $scope.REPLICATION:
				    returnParrams = ['/api/reports/replication/capacity/',"NoChart",[""]];
					columnDefArray = replicationCapacityColDefArray();
					break;
				case $scope.ARCHIVE:
					returnParrams = ['/api/reports/archive/history/',"NoChart",[""]];
					columnDefArray = archivedGridList();
					break;
				case $scope.REPLICATION_HISTORY:
					returnParrams = ['/api/reports/replication/history/',"NoChart", [""]];
					columnDefArray = replicationHistoryList();
					break;
				case $scope.ARCHIVE_HISTORY:
					returnParrams = ['app/reports/data/protectionSummary.json',"NoChart"];
					columnDefArray = createColumnDefArray();
					break;
				case $scope.VM_STORAGE:
					returnParrams = ['app/reports/data/protectionSummary.json',"NoChart"];
					columnDefArray = createColumnDefArray();
					break;
				case $scope.SYSTEM_LOAD:
					returnParrams = ['/api/reports/system/load_history/',"Bar-Line",[""]];
			        break;					
				case $scope.REPLICATION_REPORT:
					returnParrams = ['/api/reports/replication/activity/',"NoGrid",[""]];
					break;
				case $scope.RESTORE_HISTORY:
					returnParrams = ['/api/reports/restore/history/',"NoChart",[""]];
					columnDefArray =restoreHistoryColDefArray();
					break;
				case $scope.STORAGE_DATAREDUCTION:
					returnParrams = ['/api/reports/storage/data_reduction/',"Bar-Line",[""]];
					break;
				case $scope.SYSTEM_CAPACITY:
					returnParrams = ['/api/reports/system/capacity/',"NoChart",["Protected Assets"]];
					columnDefArray = systemCapacityList();
					break;
				case $scope.REPLICATION_FOOTPRINT:
					returnParrams = ['/api/reports/replication_footprint',"NoChart",[""]];
					columnDefArray = replicationFootPrintList();
					break;	
				case $scope.BACKUP_FAILURE:
                    returnParrams = ['/api/reports/backup/failure/',"NoChart",[""]];
                    columnDefArray = createFailureBackupHistorList();
					break;
					
			     }
				 returnParrams.push(columnDefArray);
			return 	returnParrams;

		}
			/*
			  This Function createPiechart and append to the divId passed
			  as param.
		    * holderId: DivId
			* title: PieChart title
			* dataPointsArray: reportDataArray
			* colorsArray: Color of Piechart
			* legendArray: Legend of Piechart
			*/
		
		function createpieChart(holderId, title, dataPointsArray, colorsArray, legendArray) {
				var r = Raphael(holderId);
				var pie = r.piechart(120, 130, 100, dataPointsArray, {minPercent:MINPERCENT, colors: colorsArray, legend: legendArray, legendpos: "south"});
		
				r.text(120, 10, title).attr({ font: "1.5em sans-serif" });
				pie.hover(function () {
					this.sector.stop();
					this.sector.scale(1.1, 1.1, this.cx, this.cy);
		
					if (this.label) {
						this.label[0].stop();
						this.label[0].attr({ r: 7.5 });
						this.label[1].attr({ "font-weight": 800 });
					}
				}, function () {
					this.sector.animate({ transform: 's1 1 ' + this.cx + ' ' + this.cy }, 500, "bounce");
		
					if (this.label) {
						this.label[0].animate({ r: 5 }, 500, "bounce");
						this.label[1].attr({ "font-weight": 400 });
					}
				});
			}

            // This is a custom sort function to sort date strings in reports.
            function sortDates(d1, d2) {
                return Date.parse(d1) - Date.parse(d2);
            }
			
			function getCurrentTimeAndDate(){  
			    var currentDateTime;
			    var timeNow=(new Date()).toLocaleString().split(' ')[1]+" "+(new Date()).toLocaleString().split(' ')[2];
			    currentDateTime=(new Date()).toString().split(' ').splice(1,3).join(' ') +", "+ timeNow;
				return currentDateTime;
			}
			
				/*This Function create columnDefination array for Protection summary.*/
                
function createProtectionSummaryColDefArray(isCE){
    var columnArr = [];
    var protectionSummaryArr  =  [ 
        {field: 'system_name',displayName:'SYSTEM NAME',cellFilter: 'nullTestFilter'  , filter: {placeholder: 'SYSTEM NAME'}},
        {field: 'client_name',displayName:'CLIENT NAME',cellFilter: 'nullTestFilter', filter: {placeholder: 'CLIENT NAME'}},
        {field: 'instance_name',displayName:'INSTANCE NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'INSTANCE NAME'}},
		{ field: 'last_backup',displayName:'LAST BACKUP',cellFilter: 'nullTestFilter',filter: {placeholder: 'LAST BACKUP'}},
		{ field: 'next_archive_job',displayName:'ARCHIVE JOB',cellFilter: 'nullTestFilter',filter: {placeholder: 'ARCHIVE JOB'}}
    ];
    columnArr.push(protectionSummaryArr);
                    
    var unprotectedClientArr =  [
        {field: 'system_name', displayName:'APPLIANCE NAME', cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
        {field: 'client_name', displayName:'ASSET', cellFilter: 'nullTestFilter',filter: {placeholder: 'ASSET'}},
		{ field: 'instance_name', displayName:'INSTANCE', cellFilter: 'nullTestFilter',filter: {placeholder: 'INSTANCE'}}
    ];				   
	columnArr.push(unprotectedClientArr);	
								
    var backupClients  =  [
        {field: 'system_name', displayName:'APPLIANCE NAME', cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
        {field: 'client_name', displayName:'PROTECTED ASSET', cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
        { field: 'instance_name', displayName:'INSTANCE', cellFilter: 'nullTestFilter',filter: {placeholder:'INSTANCE'}},
		{ field: 'last_backup', displayName:'LAST BACKUP', cellFilter: 'nullTestFilter',filter: {placeholder: 'LAST BACKUP'}},
		/* no job returned from API { field: 'joborder', displayName:' JOB', cellFilter: 'nullTestFilter'}, */
		{ field: 'types', displayName:'MODE', cellTemplate: templateWithTooltip,filter: {placeholder: 'MODE'}}
    ];				   
	columnArr.push(backupClients);	
										   
    /*var backupVmArr  =  [ { field: 'system_name', displayName:'APPLIANCE NAME', cellFilter: 'nullTestFilter'},
    {field: 'client_name', displayName:'PROTECTED ASSET', cellFilter: 'nullTestFilter'},
    { field: 'instance_name', displayName:'INSTANCE', cellFilter: 'nullTestFilter'},
    { field: 'last_backup', displayName:'LAST BACKUP', cellFilter: 'nullTestFilter'},
    { field: 'joborder', displayName:' JOB', cellFilter: 'nullTestFilter'},
    { field: 'types', displayName:'TYPE', cellFilter: 'nullTestFilter'}
	];				   
	columnArr.push(backupVmArr);	*/
														
    var replicatedClientsArr =  [
        {field: 'system_name', displayName:'APPLIANCE NAME', cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
        {field: 'client_name', displayName:'PROTECTED ASSET', cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
        { field: 'instance_name', displayName:'INSTANCE', cellFilter: 'nullTestFilter',filter: {placeholder: 'INSTANCE'}},
		{ field: 'last_backup', displayName:'LAST BACKUP', cellFilter: 'nullTestFilter',filter: {placeholder: 'LAST BACKUP'}},
		{ field: 'joborder', displayName:' JOB', cellFilter: 'nullTestFilter',filter: {placeholder: 'JOB'}},
		{ field: 'target_name', displayName:'TARGET', cellFilter: 'nullTestFilter',filter: {placeholder: 'TARGET'}}
    ];									
        if (!isCE){				   
            columnArr.push(replicatedClientsArr);
        }
														
    var replicatedVmArr =  [
        { field: 'system_name', displayName:'APPLIANCE NAME', cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
        {field: 'client_name', displayName:'PROTECTED ASSET', cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
		{ field: 'instance_name', displayName:'INSTANCE', cellFilter: 'nullTestFilter',filter: {placeholder: 'INSTANCE'}},
		{ field: 'database_name', displayName:'LAST BACKUP', cellFilter: 'nullTestFilter',filter: {placeholder: 'LAST BACKUP'}},
		{ field: 'last_replication', displayName:'LAST REPLICATION', cellFilter: 'nullTestFilter',filter: {placeholder: 'LAST REPLICATION'}},
        { field: 'joborder', displayName:'JOB', cellFilter: 'nullTestFilter',filter: {placeholder: 'JOB'}},
		{ field: 'target_name', displayName:'TARGET', cellFilter: 'nullTestFilter',filter: {placeholder: 'TARGET'}}
    ];

    if (!isCE){				   
        columnArr.push(replicatedVmArr);	
    }	
    var archivedClientsArray =[
        {field: 'system_name', displayName:'APPLIANCE NAME', cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
        {field: 'client_name', displayName:'PROTECTED ASSET', cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
		{ field: 'instance_name', displayName:'INSTANCE', cellFilter: 'nullTestFilter',filter: {placeholder: 'INSTANCE'}},
		{ field: 'next_archive_job', displayName:'JOB', cellFilter: 'nullTestFilter',filter: {placeholder: 'TARGET'}},
		{ field: 'media', displayName:'TARGET', cellFilter: 'nullTestFilter',filter: {placeholder: 'TARGET'}}
		];
    columnArr.push(archivedClientsArray);
                                                         
    var archivedVMsArray =[
        { field: 'system_name', displayName:'APPLIANCE NAME', cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
        {field: 'client_name', displayName:'PROTECTED ASSET', cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
        { field: 'instance_name', displayName:'INSTANCE', cellFilter: 'nullTestFilter',filter: {placeholder: 'INSTANCE'}},
		{ field: 'next_archive_job', displayName:'JOB', cellFilter: 'nullTestFilter',filter: {placeholder: 'JOB'}},
		{ field: 'media', displayName:'TARGET', cellFilter: 'nullTestFilter',filter: {placeholder: 'TARGET'}}
    ];
    if (!isCE){
	       columnArr.push(archivedVMsArray);
    }
	return columnArr;
}
					
function createBackupHistoryColDefArray(){
         var reportArray = [];

         var backupHistoryArray  =  [  
                {field: 'system_name', displayName:'APPLIANCE NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
                {field: 'client_name', displayName:'PROTECTED ASSET',cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
                {field: 'id', displayName:'ID',cellFilter: 'nullTestFilter',filter: {placeholder: 'ID'}},
                {field: 'status', displayName:'STATUS',cellFilter: 'nullTestFilter',filter: {placeholder: 'STATUS'}},
                {field: 'app_name', displayName:'APPLICATION',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLICATION'}},
                {field: 'database_name', displayName:'DATABASE/VM',cellFilter: 'nullTestFilter',filter: {placeholder: 'DATABASE/VM'}},
                {field: 'type', displayName:'TYPE',cellFilter: 'nullTestFilter',filter: {placeholder: 'TYPE'}},
                {field: 'start_date', displayName:'START TIME',cellFilter: 'nullTestFilter', sortFn:sortDates,filter: {placeholder: 'START TIME'}},
                {field: 'end_date', displayName:'END TIME',cellFilter: 'nullTestFilter', sortFn:sortDates,filter: {placeholder: 'END TIME'}},
                {field: 'elapsed_time', displayName:'ELAPSED',cellFilter: 'nullTestFilter',filter: {placeholder: 'ELAPSED'}},
                {field: 'size', displayName:'SIZE (GB)',cellFilter: 'nullTestFilter',filter: {placeholder: 'SIZE (GB)'}},
                {field: 'files', displayName:'FILES',cellFilter: 'nullTestFilter',filter: {placeholder: 'FILES'}}
         ];

     reportArray.push(backupHistoryArray);
     return reportArray;


}

function systUpdateHistoryColDefArray(){
    var systUpdateHistoryColumnList = [];
    var systUpdateHistoryColumn = [
        { field: 'system_name', displayName:'APPLIANCE NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
        { field: 'start_date', displayName:'START DATE',cellFilter: 'nullTestFilter',filter: {placeholder: 'START DATE'}},
        { field: 'version_from', displayName:'START VERSION',cellFilter: 'nullTestFilter',filter: {placeholder: 'START VERSION'}},
        { field: 'end_date', displayName:'END DATE',cellFilter: 'nullTestFilter',filter: {placeholder: 'END DATE'}},
        { field: 'version_to', displayName:'END VERSION',cellFilter: 'nullTestFilter',filter: {placeholder: 'END VERSION'}},
        { field: 'status', displayName:'STATUS',cellFilter: 'nullTestFilter',filter: {placeholder: 'STATUS'}},
        { field: 'messages', displayName:'MESSAGES',cellTemplate: templateWithTooltip,filter: {placeholder: 'MESSAGES'}}
                                 ];

        systUpdateHistoryColumnList.push(systUpdateHistoryColumn);
        return systUpdateHistoryColumnList;
}
function replicationCapacityColDefArray(){
    var replicationCapacityColumnList = [];
    var replicationCapacityColumn  =  [
                {field: 'system_name', displayName:'APPLIANCE NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
                { field: 'app_name', displayName:'APPLICATION NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLICATION NAME'}},
                { field: 'client_name', displayName:'PROTECTED ASSET',cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
                { field: 'instance_name', displayName:'INSTANCE',cellFilter: 'nullTestFilter',filter: {placeholder: 'INSTANCE'}},
                { field: 'size', displayName:'SIZE (GB)',cellFilter: 'nullTestFilter',filter: {placeholder: 'SIZE (GB)'}}
    ];


    replicationCapacityColumnList.push(replicationCapacityColumn);
    return replicationCapacityColumnList;
}
						
						
					/*This Function manipulates data send by restAPI for creating Pie chart.
					 * resultData: Json Data
					*/
			
		function piChartColorMaker(result)
        {
        var colorsList=[];
        var colorSet=["#da3b3c", "#6eb43f", "#e38962"]
        var colors=[];

            var sorted = result.slice(0).sort(function(b, a) {
               return a.value - b.value;
            });

            var keys = [];
            for (var i = 0, len = sorted.length; i < len; ++i) {
                keys[i] = sorted[i].key;
            }
           
             
            if ( result.length == 3 && result[0].value == 0 && result[1].value == 0 && result[2].value == 0)
            { 
               
                colorsList.push(colorSet[0]);
                colorsList.push(colorSet[1]);
                colorsList.push(colorSet[2]);
            }
             else if ( (result.length == 3 || result.length == 2 )  && result[0].value == result[1].value )
            { 
                
                colorsList.push(colorSet[0]);
                colorsList.push(colorSet[1]);
                colorsList.push(colorSet[2]);
            }
            else
            {
                 for (i=0; i < keys.length ; i++)
                 {
                        if (keys[i] == 'success') {
                            colorsList.push(colorSet[1]);
                        } else if (keys[i] == 'failure') {
                         colorsList.push(colorSet[0]);

                        } else {
                            colorsList.push(colorSet[2]);
                        }
                }
            }
        return colorsList;
        }

        function piChartColorMakerForStorage(result)
        {
        var colorsList=[];
        var colorSet=["#6eb43f","#da3b3c"];
        var colors=[];

            var sorted = result.slice(0).sort(function(b, a) {
               return a.value - b.value;
            });

            var keys = [];
            for (var i = 0, len = sorted.length; i < len; ++i) {
                keys[i] = sorted[i].key;
            }

         for (i=0; i < keys.length ; i++)
         {		
				if (keys[i] == 'FreeStorage') {
                    colorsList.push(colorSet[0]);
                } else {
			       colorsList.push(colorSet[1]);
                }
        }
        return colorsList;
        }

       function PieChartRenderProtSummary(resultData, isCE){
        var colorlist=[];

                    var titleList =[];
                    var titles=[];
                    var title="";
                    var calcSum=0;
                    var dataPointslist=[];
                    var dataPoints=[];
                    var legendList=[];
                    var legends=[];
                    var legend="";
                    var dataPointValue="";

                    /* For VMs */
                             
                    var unProtectedAssets = parseInt(resultData.data.data.vms["unprotected"].length) +parseInt(resultData.data.data.clients["unprotected"].length); 
                    dataPointValue= (unProtectedAssets > 0) ? unProtectedAssets : MINPERCENT;
                    dataPoints.push(dataPointValue);
                   var protectedAssets = parseInt(resultData.data.data.vms["protected"].length) + parseInt(resultData.data.data.clients["protected"].length); 
                    dataPointValue= (protectedAssets > 0) ? protectedAssets : MINPERCENT;
                    dataPoints.push(dataPointValue);
                    dataPointslist.push(dataPoints);
					calcSum=parseInt(protectedAssets)+ parseInt(unProtectedAssets);
                    title="Total Assets (" + calcSum + ")";
                    titles.push(title);
                    titleList.push(titles);
                    legend  ="Unprotected Assets  (" +unProtectedAssets + ")";
                    legends.push(legend);
                    legend ="Protected Assets (" +protectedAssets +  ")";
                    legends.push(legend);
                    legendList.push(legends);
                    var result = [
                            {key: "success", value: protectedAssets},
                            {key: "failure", value: unProtectedAssets}
                            ];
                    colorlist.push(piChartColorMaker(result));
                    /*For Backup */
                     /* Setting variables to default values*/
                    dataPoints=[];
                    title="";
                    titles=[];
                    calcSum=0;
                    legends=[];
                       dataPointValue="";


                    dataPointValue= (resultData.data.data.backups.failures > 0) ? resultData.data.data.backups.failures : MINPERCENT;
                    dataPoints.push(dataPointValue);
                    dataPointValue= (resultData.data.data.backups.successes > 0) ? resultData.data.data.backups.successes : MINPERCENT;
                    dataPoints.push(dataPointValue);
                    dataPointValue= (resultData.data.data.backups.warnings > 0) ? resultData.data.data.backups.warnings : MINPERCENT;
                    dataPoints.push(dataPointValue);

                    legend  ="Errors (" +resultData.data.data.backups.failures + ")";
                    legends.push(legend);
                    legend ="Successful Backups (" +resultData.data.data.backups.successes +  ")";
                    legends.push(legend);
                    legend = "Warnings (" + resultData.data.data.backups.warnings + ")";
                    legends.push(legend);
                    legendList.push(legends);

                    dataPointslist.push(dataPoints);
					calcSum = parseInt(resultData.data.data.backups.failures)+ parseInt(resultData.data.data.backups.successes)+ parseInt(resultData.data.data.backups.warnings);
                    title="All Backups (" + calcSum + ")";

                    titles.push(title);
                    titleList.push(titles);
                        var result = [
                            {key: "success", value: resultData.data.data.backups.successes},
                            {key: "failure", value: resultData.data.data.backups.failures},
                            {key: "warning", value: resultData.data.data.backups.warnings}
                            ];
                    colorlist.push(piChartColorMaker(result));
                    
                    if(!isCE) {
						/* for Replication */
						/* Setting variables to default values*/
						dataPoints = [];
						title = "";
						titles = [];
						calcSum = 0;
						legends = [];
						dataPointValue = "";

						dataPointValue = (resultData.data.data.replicated_backups.failures > 0) ? resultData.data.data.replicated_backups.failures : MINPERCENT;
						dataPoints.push(dataPointValue);
						dataPointValue = (resultData.data.data.replicated_backups.successes > 0) ? resultData.data.data.replicated_backups.successes : MINPERCENT;
						dataPoints.push(dataPointValue);
						dataPointValue = (resultData.data.data.replicated_backups.warnings > 0) ? resultData.data.data.replicated_backups.warnings : MINPERCENT;
						dataPoints.push(dataPointValue);
						var result = [
							{key: "success", value: resultData.data.data.replicated_backups.successes},
							{key: "failure", value: resultData.data.data.replicated_backups.failures},
							{key: "warning", value: resultData.data.data.replicated_backups.warnings}
						];
						colorlist.push(piChartColorMaker(result));


						dataPointslist.push(dataPoints);

						legend = "Errors (" + resultData.data.data.replicated_backups.failures + ")";
						legends.push(legend);
						legend = "Successful Replications (" + resultData.data.data.replicated_backups.successes + ")";
						legends.push(legend);
						legend = "Warnings (" + resultData.data.data.replicated_backups.warnings + ")";
						legends.push(legend);
						legendList.push(legends);


						calcSum = parseInt(resultData.data.data.replicated_backups.failures) + parseInt(resultData.data.data.replicated_backups.successes) + parseInt(resultData.data.data.replicated_backups.warnings);
						title = "All Replications (" + calcSum + ")";
						titles.push(title);
						titleList.push(titles);
					}

	                    /* For Archive */
	                    /* Setting variables to default values*/
	                    dataPoints=[];
	                    title="";
	                    titles=[];
	                    calcSum=0;
	                    legends=[];
	                    dataPointValue="";

	                    dataPointValue= (resultData.data.data.archives.failures > 0) ? resultData.data.data.archives.failures : MINPERCENT;
	                    dataPoints.push(dataPointValue);
	                    dataPointValue= (resultData.data.data.archives.successes > 0) ? resultData.data.data.archives.successes : MINPERCENT;
	                    dataPoints.push(dataPointValue);
	                    dataPointValue= (resultData.data.data.archives.warnings > 0) ? resultData.data.data.archives.warnings : MINPERCENT;
	                    dataPoints.push(dataPointValue);

	                    dataPointslist.push(dataPoints);

	                    legend  ="Errors (" +resultData.data.data.archives.failures + ")";
	                    legends.push(legend);
	                    legend ="Successful Backup Copies (" +resultData.data.data.archives.successes +  ")";
	                    legends.push(legend);
	                    legend = "Warnings (" + resultData.data.data.archives.warnings + ")";

	                    legends.push(legend);
	                    legendList.push(legends);
	                        var result = [
	                            {key: "success", value: resultData.data.data.archives.successes},
	                            {key: "failure", value: resultData.data.data.archives.failures},
	                            {key: "warning", value: resultData.data.data.archives.warnings}
	                            ];
	                    colorlist.push(piChartColorMaker(result));
					    calcSum = parseInt(resultData.data.data.archives.failures)+parseInt(resultData.data.data.archives.successes)+parseInt(resultData.data.data.archives.warnings);

	                    title="All Backup Copies (" + calcSum + ")";
	                    titles.push(title);
	                    titleList.push(titles);

                    holderID=$("#flot_holder");

                    for (i = 0; i < titleList.length; ++i){
                                            newId = "pie-chart-holder" + i;
                                            if(!isCE){
                                            	holderID.append('<div id="' + newId + '" class="pie-chart-container"></div>');
                                            }else{
                                            	holderID.append('<div id="' + newId + '" class="pie-chart-container-isCE"></div>');
                                            }
                                            createpieChart(newId, titleList[i], dataPointslist[i], colorlist[i], legendList[i]);
                       }

            }

function createLeagaHoldBackupList(){
   var legalholdbkList = [];
        var legalHldBkData  =  [ 
        { field: 'client_name', displayName:'PROTECTED ASSET', cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
        { field: 'id', displayName:'ID',cellFilter: 'nullTestFilter',filter: {placeholder: 'ID'}},
        { field: 'app_name', displayName:'APPLICATION',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLICATION'}},
        { field: 'database_name', displayName:'DATABASE/VM',cellFilter: 'nullTestFilter',filter: {placeholder: 'DATABASE/VM'}},
        { field: 'hold_end_date', displayName:'LEGAL HOLD EXPIRATION DATE',cellFilter: 'nullTestFilter',filter: {placeholder: 'LEGAL HOLD EXPIRATION DATE'}},
    { field: 'hold_days', displayName:'HOLD DAYS', cellFilter:"colHoldDayFilter | nullTestFilter",filter: {placeholder: 'HOLD DAYS'}},
        { field: 'start_date', displayName:'BACKUP START DATE',cellFilter: 'nullTestFilter', sortFn:sortDates,filter: {placeholder: 'BACKUP START DATE'}},
        { field: 'type', displayName:'TYPE',cellFilter: 'nullTestFilter',filter: {placeholder: 'TYPE'}},
        { field: 'size', displayName:'SIZE (GB)',cellFilter: 'nullTestFilter',filter: {placeholder: 'SIZE (GB)'}}
    ];

    legalholdbkList.push(legalHldBkData);
    return legalholdbkList;
}
			
			
			
function replicationHistoryList(){
    var replHistorylist = [];
    var replHistorylistDetails  =  [ 
        { field: 'system_name', displayName:'APPLIANCE NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},				
        { field: 'client_name', displayName:'PROTECTED ASSET',cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
        { field: 'id', displayName:'ID',cellFilter: 'nullTestFilter',filter: {placeholder: 'ID'}},
        { field: 'status', displayName:'STATUS',cellFilter: 'nullTestFilter',filter: {placeholder: 'STATUS'}},
        { field: 'app_name', displayName:'APPLICATION',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLICATION'}},
        { field: 'database_name', displayName:'DATABASE/VM',cellFilter: 'nullTestFilter',filter: {placeholder: 'DATABASE/VM'}},
        { field: 'replication_start_date', displayName:'START TIME',cellFilter: 'nullTestFilter', sortFn:sortDates,filter: {placeholder: 'START TIME'}},
        { field: 'replication_end_date', displayName:'END TIME',cellFilter: 'nullTestFilter', sortFn:sortDates,filter: {placeholder: 'END TIME'}},
        { field: 'replication_elapsed_time', displayName:'ELAPSED',cellFilter: 'nullTestFilter',filter: {placeholder: 'ELAPSED'}},
        { field: 'type', displayName:'TYPE',cellFilter: 'nullTestFilter',filter: {placeholder: 'TYPE'}},
        { field: 'size', displayName:'SIZE (GB)',cellFilter: 'nullTestFilter',filter: {placeholder: 'SIZE (GB)'}},
        { field: 'replicated_size', displayName:'REPLICATED SIZE (GB)',cellFilter: 'nullTestFilter',filter: {placeholder: 'REPLICATED SIZE (GB)'}}
        /* { field: 'files', displayName:'FILES',cellFilter: 'nullTestFilter'},
        { field: 'instance_name', displayName:'INSTANCE',cellFilter: 'nullTestFilter'}, */

    ];

        replHistorylist.push(replHistorylistDetails);
        return replHistorylist;
}
function archivedGridList(){
    var archiveList = [];

    var setInfoList = [
        /*{ field: 'date', displayName:'DATE CREATED',cellFilter: 'nullTestFilter'},*/
        { field: 'description', displayName:'Description',rowTemplate:teplateToNoneFilter,cellFilter: 'nullTestFilter',filter: {placeholder: 'TYPE'}},
        { field: 'status', displayName:'Status', rowTemplate:teplateToNoneFilter,cellFilter: 'nullTestFilter',filter: {placeholder: 'TYPE'}},
        { field: 'target', displayName:'Target',rowTemplate:teplateToNoneFilter,cellFilter: 'nullTestFilter',filter: {placeholder: 'TYPE'}},
        { field: 'available', displayName:'Available', rowTemplate:teplateToNoneFilter,cellFilter: 'nullTestFilter',filter: {placeholder: 'TYPE'}},
        { field: 'is_imported', displayName:'Imported',rowTemplate:teplateToNoneFilter,cellFilter: 'nullTestFilter',filter: {placeholder: 'TYPE'}}

    ];

    archiveList.push(setInfoList);

    var archiveGridDetails = [

        { field: 'app_name', displayName:'APP NAME',cellFilter: 'nullTestFilter',  width:220,filter: {placeholder: 'APP NAME'}},
        /*{ field: 'archive_id', displayName:'ID',cellFilter: 'nullTestFilter', width:60},*/
        { field: 'archive_time', displayName: 'ARCHIVE TIME',cellFilter: 'nullTestFilter', cellFilter: 'date:\'h:mm a\'',  width:170,filter: {placeholder: 'ARCHIVE TIME'}},
        { field: 'elapsed_time', displayName:'ELAPSED TIME',cellFilter: 'nullTestFilter', width:100,filter: {placeholder: 'ELAPSED TIME'}},
        { field: 'client_name', displayName:'PROTECTED ASSET',cellFilter: 'nullTestFilter', width:220,filter: {placeholder: 'PROTECTED ASSET'}},
        { field: 'instance_description', displayName:'INSTANCE',cellFilter: 'nullTestFilter', cellTemplate: templateWithTooltip, width:400,filter: {placeholder: 'INSTANCE'}},
        { field: 'backup_time', displayName:'BACKUP DATE',cellFilter: 'nullTestFilter', width:170,filter: {placeholder: 'BACKUP DATE'}},
        { field: 'type', displayName:'TYPE',cellFilter: 'nullTestFilter', width: 160,filter: {placeholder: 'TYPE'}},
        { field: 'compressed', displayName:'COMPRESSED?',cellFilter: 'nullTestFilter', width: 110,filter: {placeholder: 'COMPRESSED?'}},
        { field: 'deduped', displayName:'DEDUPLICATED?',cellFilter: 'nullTestFilter', width: 110,filter: {placeholder: 'DEDUPLICATED?'}}
     ];
        archiveList.push(archiveGridDetails);
        return archiveList;
}
			
		function restoreHistoryColDefArray(){
			var restoreHistoryColumnList = [];
			var restoreHistoryColumn  =  [
				{ field: 'system_name', displayName:'APPLIANCE NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
				{ field: 'client_name', displayName:'HOST/SERVER',cellFilter: 'nullTestFilter',filter: {placeholder: 'HOST/SERVER'}},
				{ field: 'id', displayName:'ID',cellFilter: 'nullTestFilter',filter: {placeholder: 'ID'}}, 
				{ field: 'status', displayName:'STATUS',cellFilter: 'nullTestFilter',filter: {placeholder: 'STATUS'}},
				{ field: 'app_name', displayName:'APPLICATION NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLICATION NAME'}}, 
				{ field: 'database_name', displayName:'ASSET',cellFilter: 'nullTestFilter',filter: {placeholder: 'ASSET'}},
				{ field: 'start_date', displayName:'START TIME',cellFilter: 'nullTestFilter', sortFn:sortDates,filter: {placeholder: 'START TIME'}},
				{ field: 'end_date', displayName:'END TIME',cellFilter: 'nullTestFilter', sortFn:sortDates,filter: {placeholder: 'END TIME'}},
				{ field: 'elapsed_time', displayName:'ELAPSED TIME',cellFilter: 'nullTestFilter',filter: {placeholder: 'ELAPSED TIME'}},
				{ field: 'files', displayName:'# FILES',cellFilter: 'nullTestFilter',filter: {placeholder: 'FILES'}}

			];
			restoreHistoryColumnList.push(restoreHistoryColumn);
			return restoreHistoryColumnList;
		}


function createBackupStorageColDefArray(isCe){

    var backupStorageColumnList = [];

     if (isCe == true)
     {
    var backupStoragesubColumn   =  [
        { field: 'name', displayName:'NAME',enableFiltering: false},
        {
            field: 'mb_size',
            displayName:'ALLOCATED STORAGE (GB)',
            cellFilter: 'MBToGBFormater',
            enableFiltering: false
        },
        { 
            field: 'mb_free',
            displayName:'FREE STORAGE (GB)',
            cellFilter: 'MBToGBFormater',
            enableFiltering: false
        },
        { field: 'mb_used', displayName:'TOTAL BACKUP DATA (GB)',cellFilter: 'MBToGBFormater',enableFiltering: false},
        { field: 'daily_growth_rate', displayName:'DAILY GROWTH',enableFiltering: false}
                                     
    ];	  
    backupStorageColumnList.push(backupStoragesubColumn);
      }
    else
    {
    var backupStoragesubColumn   =  [
        { field: 'name', displayName:'NAME',enableFiltering: false},
        { field: 'mb_size', displayName:'ALLOCATED STORAGE (GB)',cellFilter: 'MBToGBFormater',enableFiltering: false},
        { field: 'mb_free', displayName:'FREE STORAGE (GB)',cellFilter: 'MBToGBFormater',enableFiltering: false},
        { field: 'mb_used', displayName:'TOTAL BACKUP DATA (GB)',cellFilter: 'MBToGBFormater',enableFiltering: false},
        { field: 'daily_growth_rate', displayName:'DAILY GROWTH',enableFiltering: false}, 
        { field: 'dedup', displayName:'DEDUPE RATIO',enableFiltering: false} 
    ];	   
    backupStorageColumnList.push(backupStoragesubColumn);
    }
return backupStorageColumnList;

}
			
            /* For creating Bar chart Data*/

			function createBarChartData(result){
			  //console.log(result.data.data);
						var griddata = result.data.data;
				        var tempValFreeSpaceArray = [];
						var tempValUsedSpaceArray = [];
						var tempvalueArray = [];
						var dateArray=[];
						var barTitleList=[];
                        var tooltipArray = [ ];
                        var colorArray = 	[
                            null,
                            null,
                            null
                        ];
                    var barTitle =	["Storage Totals (98.4 GB)"];
						for(var j=0;j<griddata[0].size_history.length;j++){
							var freeSpace = 0;
							var usedSpace = 0;
							var day = '';
						  for(var k=0;k<griddata.length;k++){
						    var usedSize = griddata[k].size_history[j].mb_used;
						    var freeSize = griddata[k].size_history[j].mb_free;
						    day = griddata[k].size_history[j].day;
							freeSpace += (freeSize / 1024);
							usedSpace += (usedSize / 1024);
						  }
						  	tempValFreeSpaceArray.push(parseFloat(freeSpace.toFixed(1))); 
							tempValUsedSpaceArray.push(parseFloat(usedSpace.toFixed(1)));
							tooltipArray.push(freeSpace.toFixed(1)+"GB free,"+usedSpace.toFixed(1)+"GB used");
							dateArray.push(day.substring(5,day.length).replace("-","/"));
											
						}
						    tempvalueArray.push(tempValUsedSpaceArray);
							tempvalueArray.push(tempValFreeSpaceArray);
						
							barTitleList.push(barTitle);
							holderID=$("#flot_holder");
							for (var i = 0; i < barTitleList.length; ++i){
							                    newId = "backup-graph" + i; 
											    holderID.append('<div id="' + newId + '" class="graph-container-huge"><div class="bar-chart-legend"><div class="chart-free-space"><div></div>Free Storage</div><div class="chart-used-space"><div></div>Used Storage</div></div></div>');
												buildBarChart(newId, tempvalueArray, tooltipArray, dateArray, colorArray);
	                        }
						
		
			}

            function PieChartForBackupStorage(result){
			
					var dataPoints=[];
                    var title="";
                    var titles=[];
                    var calcSum=0;
                    var legends=[];
                    var dataPointValue1;
					var dataPointValue2;
					var dataPointslist =[];
					var legendList=[];
					var colorlist=[];
					var titleList =[];
					/* var freeData =  (result.data.data[0].mb_free)/(1024*1024*1024);
					var availData = (result.data.data[0].mb_size)/(1024*1024*1024); */
					
					var freeData =  0;
					var availData = 0;

					for(var i=0; i<result.data.data.length;i++){
						freeData +=  (result.data.data[i].mb_free);
						availData += (result.data.data[i].mb_used);
					}
					
					
					dataPointValue1= (freeData > 0) ? freeData : MINPERCENT;
                    dataPoints.push(dataPointValue1);
                    dataPointValue2= (availData > 0) ? availData : MINPERCENT;
                    dataPoints.push(dataPointValue2);
                    dataPointslist.push(dataPoints); 
					  
				  
					legend ="Free Storage (" +formatMBToGB(freeData) +  " GB)";
                    legends.push(legend);
				    legend  ="Used Storage (" +formatMBToGB(availData) + " GB)";
                    legends.push(legend);
                    legendList.push(legends);
					
                    var result = [
								  {key: "FreeStorage", value:freeData},
								  {key: "UsedStorage", value: availData}
                                ];
                    colorlist.push(piChartColorMakerForStorage(result));
					calcSum = parseFloat(freeData + availData);
                    title="Storage Totals (" + formatMBToGB(calcSum) + " GB)";
                    titles.push(title);
                    titleList.push(titles);

                    holderID=$("#flot_holder");

                    for (i = 0; i < titleList.length; ++i){
                                            newId = "pie-chart-holder" + i;
                                            holderID.append('<div id="' + newId + '" class="pie-chart-container"></div>');
                                            createpieChart(newId, titleList[i], dataPointslist[i], colorlist[i], legendList[i]);
                       } 
		
		}

			function labelBarChart(r, bc, labels, attrs) {
				// Label a bar chart bc that is part of a Raphael object r
				// Labels is an array of strings. Attrs is a dictionary
				// that provides attributes such as fill (text color)
				// and font (text font, font-size, font-weight, etc) for the
				// label text.
				for (var i = 0; i < bc.bars[0].length; i++) {
					var bar = bc.bars[0][i];
					var gutter_y = bar.w * 0.4;
					var label_x = bar.x;
					var label_y = bar.y + bar.h + gutter_y;
					var label_text = labels[i];
		
					r.text(label_x, label_y, label_text).attr(attrs);
				}
			}
		
			function buildBarChart(target, values, tooltips, dates, colorOverrides) {
				var options = { width: 900, height: 200, y_offset: 20 },
					overrideColor,
					barOver = function () {
						var y = [];
						for (var i = this.bars.length; i--;) {
							y.push(this.bars[i].y);
						}
						this.flag = r.popup(this.bars[0].x, Math.min.apply(Math, y), tooltips[parseInt((this.bars[0].x - 58) /  27)]).insertBefore(this);
					},
					barOut = function () {
						this.flag.animate({opacity: 0}, 300, function () {this.remove();});
					};
				var r = Raphael(target, options.width, options.height);
				var bc = r.barchart(42, options.y_offset, options.width - 72, options.height - options.y_offset, values, { stacked:true, type:'soft', colors:['#80bc3d', '#ccc'] }).hoverColumn(barOver, barOut);
				 $("    #" + target + " svg path").each(function(index) {
					if (index % 2 == 1) {
						overrideColor = colorOverrides[parseInt(index / 2)];
						if (overrideColor) {
							$(this).attr("fill", overrideColor);
						}
					}
				}); 
		
				labelBarChart(r, bc, dates, { fill: "black", font: "8px sans-serif" } );
		
				return bc;
			}
			/*Adding function for Data reduction*/

				  /* function to calculate the width of
				   * barChart based on the no. of bars we
				   * need to show in the Barchart 
				   */
				function barChartWidthAssigner(datalength)
                        {
                            var barchartWidth=(datalength*35);

                            if (barchartWidth <= 1500)

                           {
                               return barchartWidth;

                            }
                            else  
                            {
                             var svgWidth= (barchartWidth+350)+"px";
                             console.log(svgWidth);
                             $('#flot_holder').css("width",svgWidth);
                             $('#bar-chart-container').css("width",svgWidth);
                             return barchartWidth;
                            }



                        }


					function labelDataReductionBarChart(r, bc, labels, attrs) {
						// Label a bar chart bc that is part of a Raphael object r
						// Labels is an array of strings. Attrs is a dictionary
						// that provides attributes such as fill (text color)
						// and font (text font, font-size, font-weight, etc) for the
						// label text.

						for (var i = 0; i<bc.bars.length; i++) {
							var bar = bc.bars[i];
							barWidth =bar.w;
                            if (i % 2==0)
                            {
							var gutter_y = bar.w * 0.4;
							var label_x = bar.x
							var label_y = bar.y + bar.h + gutter_y;
							var label_text = labels[i];
							var label_attr = { fill:  "black", font: "9px sans-serif" };

							r.text(label_x, label_y, label_text).attr(label_attr);
                            }
						}

					}
                function dateAxisLabel(calcDate)
                        {
                               return calcDate.toLocaleDateString().substring(0,(calcDate.toLocaleDateString().length-4)) +             calcDate.toLocaleDateString().substring(calcDate.toLocaleDateString().length-2);
                        }

			
			
			function lineOverBarDataReduction(resultData, isCE) {

                var dateRangeValues=[];
				var deDuplicationValues=[];
				var dataReductionValues=[];
                var barchartWidth = barChartWidthAssigner(resultData.data.length);
										  
				for (i = 0; i < resultData.data.length ; i++) {
                    var dateString = resultData.data[i].date;
                    var calcDate = new Date(dateString);
                    var dayAxis =dateAxisLabel(calcDate);

                    dateRangeValues.push(dayAxis);
                    deDuplicationValues.push(resultData.data[i].dedup);
                    dataReductionValues.push(resultData.data[i].data_reduction);
                }
					holderID=$("#flot_holder");
					console.log("holderID:::"+holderID);
					holderID.append('<div id="bar-chart-container"> </div>');
					$('#bar-chart-container').css("height","700px");
                //$('#bar-chart-container').css("margin-left","100px")
                               
								
                var r = Raphael('bar-chart-container');
                //Raphael.g.axis(85,230,100,1,null,4,2,["Today", "Yesterday", "Tomorrow", "Future"], null, 1, r);
                /* params
                     1 and 2nd param xaxis and yaxis  co-ordinate from bottom left
                     3rd length
                     4rth min
                     5th max
                     6th step
                     7th varaint 0,1,2,3
                     8th labels
                     9th type
                     10th dashline ( 1 if needed 0 if didn't)
                     11th rapahel object
                */

                //var attr = {font:'12px Verdana', 'text-anchor':'start', 'font-weight':'bold'};

                var attr = {'font-size':'14px', 'font-family':'Verdana', 'text-anchor':'start', 'font-weight':'bold'};
                var legend_attr = {'font-size':'12px', 'font-family':'Verdana', 'text-anchor':'start', 'font-weight':'normal'};

                if (!isCE) {
                    var lineMax = deDuplicationValues.length === 0 ? 0.01: Math.max.apply(Math,deDuplicationValues);
                    var lineMin = deDuplicationValues.length === 0 ? 0 : Math.min.apply(Math,deDuplicationValues);

                    Raphael.g.axis(140, 457, 360, lineMin, lineMax, 30, 1, null, 1, 1, r);
                    r.text(10, 250, "Deduplication Ratio").attr(attr).rotate(270);
                }

                var barMaxValue = dataReductionValues.length === 0 ? 0 : Math.max.apply(Math,dataReductionValues);

                if (barMaxValue == 0) { /*assigning minimum values*/
                    for (var i = 0; i < dataReductionValues.length ; i++) {
                        dataReductionValues[i]=0.01;
                    }
                    barMaxValue = 0.01;
                }
                             
                var fin = function () {
                        var barValue = this.bar.value;
                        this.flag = r.popup(this.bar.x, this.bar.y, barValue  || "0").insertBefore(this).attr({stroke:"#fff",fill:"#000"});
                },
                fout = function () {
                        this.flag.animate({opacity: 0}, 300, function () {this.remove();});
                };

                var bc = r.barchart(150, 80, barchartWidth, 400, dataReductionValues, {stacked: false,type: "soft"}).hover(fin, fout);
                    bc.attr({fill: "#EE8833"});
                labelDataReductionBarChart(r, bc,dateRangeValues,{ fill:  "blue", font: "8px sans-serif" });
                    /* Code For Over lapping Line */
                var axisArray=[];
                var stepsForAxis=deDuplicationValues.length;
                for (i=0; i < deDuplicationValues.length ; i++){
                    axisArray.push(i);
                }

                var widthOffSet = 0;
                if (deDuplicationValues.length > 15){
                    widthOffSet = (deDuplicationValues.length * 0.233);
                }else{
                    widthOffSet = -(deDuplicationValues.length * 0.2);
                }

                if (!isCE) {
                    var lines = r.linechart((150 + (barWidth/2)), 87, ((barchartWidth-barWidth) + widthOffSet), 380,
                        [axisArray,axisArray], [deDuplicationValues],
                        { nostroke: false, axis: "0 0 0 0", symbol: "circle", smooth: false, axisystep :6, colors:["#629632"]}).hover(function(){
                            var lineValue =this.value;
                            this.flag = r.popup(this.x,this.y,lineValue || "0").insertBefore(this).attr({stroke:"#000",fill:"#629632"});
                        }, function(){this.flag.animate({opacity: 0}, 300, function () {this.remove();});});

                    lines.symbols.attr({ r: 4});
                    lines.lines[0].animate({"stroke-width": 4}, 1000);
                    lines.symbols[0].attr({stroke: "#2C6700"});
                }

                r.rect(241, 500, 10, 10).attr({fill: '#EE8833',stroke:'#EE8833'});
                r.text(271, 505, "Data Reduction Ratio").attr(legend_attr);

                if (!isCE) {
                    r.rect(351, 500, 10, 10).attr({fill: '#629632',stroke:'#629632'});
                    r.text(401, 505, "Deduplication Ratio").attr(legend_attr);
                }
                   
                var lineXAxisValue = 150 + barchartWidth + widthOffSet + 10;
                Raphael.g.axis(lineXAxisValue, 458, 360, 0, barMaxValue, 30, 3, null, 1, 1, r);
                r.text(lineXAxisValue - 20, 243, "Data Reduction Ratio").attr(attr).rotate(270);

			}
			
			
function systemCapacityList(){
    var capacityList = [];
    var vmsCapacityDetailsList = [
        { field: 'system_name', displayName:'APPLIANCE NAME',filter: {placeholder: 'APPLIANCE NAME'}},
        { field: 'name', displayName: 'NAME',filter: {placeholder: 'NAME'}},
        { field: 'hypervisor', displayName:'HYPERVISOR' ,cellFilter: 'nullTestFilter',filter: {placeholder: 'HYPERVISOR'}},
        { field: 'last_full', displayName:'LAST FULL (GB)',cellFilter: 'GBFormatter',filter: {placeholder: 'LAST FULL (GB)'}}
    ];
    capacityList.push(vmsCapacityDetailsList);

   /* var clientsCapacityDetailsList = [
        { field: 'system_name', displayName:'APPLIANCE NAME'},
        { field: 'name', displayName: 'NAME'},
        { field: 'last_full', displayName:'LAST FULL (GB)',cellFilter: 'nullTestFilter'}


    ];
    capacityList.push(clientsCapacityDetailsList);*/
    return capacityList;
}
			
function replicationFootPrintList(){
			 var footPrintList = [];
             var footPrintArray  =  [  
                    {field: 'local_system_name', displayName:'APPLIANCE',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE'}},
                    { field: 'local_system_version', displayName:'VERSION',cellFilter: 'nullTestFilter',filter: {placeholder: 'VERSION'}},
                    { field: 'report_date', displayName:'REPORT DATE',cellFilter: 'nullTestFilter',filter: {placeholder: 'REPORT DATE'}},
                    { field: 'system_name', displayName:'SOURCE APPLIANCE',cellFilter: 'nullTestFilter',filter: {placeholder: 'SOURCE APPLIANCE'}},
                    { field: 'data_size', displayName:'REPLICATED DATA SIZE',cellFilter: 'nullTestFilter',filter: {placeholder: 'REPLICATED DATA SIZE'}}
             ];

				footPrintList.push(footPrintArray);
				return footPrintList;
			}

function createFailureBackupHistorList(){
			 var failureList = [];
         var failurebackupHistorList  =  [  
                {field: 'system_name', displayName:'APPLIANCE NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'APPLIANCE NAME'}},
                { field: 'client_name', displayName:'PROTECTED ASSET',cellFilter: 'nullTestFilter',filter: {placeholder: 'PROTECTED ASSET'}},
                { field: 'database_name', displayName:'VM NAME',cellFilter: 'nullTestFilter',filter: {placeholder: 'VM NAME'}},
                { field: 'id', displayName:'ID',cellFilter: 'nullTestFilter',filter: {placeholder: 'ID'}},
                { field: 'start_date', displayName:'DATE',cellFilter: 'nullTestFilter', sortFn:sortDates,filter: {placeholder: 'DATE'}},
                { field: 'end_date', displayName:'END TIME',cellFilter: 'nullTestFilter', sortFn:sortDates,filter: {placeholder: 'END TIME'}},
                { field: 'elapsed_time', displayName:'ELAPSED',cellFilter: 'nullTestFilter',filter: {placeholder: 'ELAPSED'}},
                { field: 'type', displayName:'TYPE',cellFilter: 'nullTestFilter',filter: {placeholder: 'TYPE'}},
                { field: 'size', displayName:'SIZE (GB)',cellFilter: 'nullTestFilter | MBToGBFormater',filter: {placeholder: 'SIZE'}}
         ];
												  
    failureList.push(failurebackupHistorList);
    return failureList;
}

			/* Load Chart Code Starts Here*/


					/*  function scaling Formula:
					Old range       New Range
					 [min ,max]   to   [a ,b]
					 f(x) = [ ( (a-b) ( x-min) / (max -min) ) + a ]
					 */
					function sclaingFormula(oldMin,oldMax,newMin,newMax,value)
					  { 
						  var scaledValue;
							 
						  scaledValue= (((newMax - newMin) * (value - oldMin))/(oldMax -oldMin)) + newMin;
						  return scaledValue;

					  }
									
/* 

Scale data will scaleUp or scaleDown data for new Yaxis range i.e. warningThreshold,overloadThreshold,errorThreshold and maxYvalue
								 */

function scaleDataforLoad(data , warningThreshold,overloadThreshold,errorThreshold,maxYvalue )
            {
                var yAxisData;
                var scaledDataArray=[];
                var newMin;
                var newMax;
                var oldMin;
                var oldMax;

              for (i =0 ; i < data.length ; i++)
              {



               if (data[i] <= warningThreshold )

                { 
                    oldMin = 0;
                    oldMax = warningThreshold;
                    newMin = 0;
                    NewMax=2.3;
                yAxisData=sclaingFormula(oldMin,oldMax,newMin,NewMax,data[i]);
              }


            else if ( data[i] <= overloadThreshold )
            {

                    oldMin = warningThreshold;
                    oldMax = overloadThreshold;
                    newMin = 2.3;
                    NewMax=4.7;
                yAxisData=sclaingFormula(oldMin,oldMax,newMin,NewMax,data[i]);

            }


            else if (data[i] > overloadThreshold)
            {

                    oldMin = overloadThreshold;
                    oldMax = maxYvalue;
                    newMin = 4.7;
                    NewMax =7;
                    yAxisData = sclaingFormula(oldMin,oldMax,newMin,NewMax,data[i]);

            }

            else{
            yAxisData=data[i];
            }
            scaledDataArray.push(yAxisData);
              }
            return scaledDataArray;
            }
    /* 
        Plots  line graph for a particular system load on three horizontal bar
        denoting noraml,warning and error state.

    */             

function plotSytemLoadGraph(resultdata)
{
var xAxisValuse=[];
var yAixsValues=[];
var yAxisScalevalue=[]; 
var overloadThreshold=125;
var warningThreshold=125;
var overload=resultdata.overload_threshold;
var warning=resultdata.warning_threshold;
var error=(overload-warning)+overload;
var errorThreshold=((overloadThreshold - warningThreshold) + overloadThreshold);
for (i =0 ; i < resultdata.data.length ; i++)
{
    dateInMili= resultdata.data[i].day +" " + resultdata.data[i].time;
    var d = new Date(dateInMili);
    xAxisValuse.push(d.getTime());
    yAxisScalevalue.push(resultdata.data[i].load);
}
maxYvalue = Math.max.apply(Math,yAxisScalevalue);        
yAixsValues=  scaleDataforLoad(yAxisScalevalue,warning,overload,error,maxYvalue);   

    holderID=$("#flot_holder");
    //$holderID.removeClass("hidden");
    holderID.append('<div id="bar-chart-container"> </div>');
    $('#bar-chart-container').css("height","700px");
    $('#bar-chart-container').css("margin-left","100px")

    var r = Raphael('bar-chart-container');
    var maxValue = Math.max.apply(Math,yAixsValues) * 50;
    //4rth Param height of HBARoverloadThreshold
    var overLoadChart = r.hbarchart(100, 400, 1200, warningThreshold, [[500]],{stacked: false, colors:["rgb(149,175,149)"], "gutter":"0%"});

    var warningChart =r.hbarchart(100, 400-overloadThreshold, 1200, overloadThreshold, [[500]],{stacked: false, colors:["rgb(200,200,149)"], "gutter":"0%"});

    var errorChart =r.hbarchart(100, 400 -(overloadThreshold +errorThreshold), 1200, errorThreshold, [[500]],{stacked: false, colors:["rgb(200,149,149)"], "gutter":"0%"});


           var x = 80;
           var y = 400 -(overloadThreshold +errorThreshold);
           var xlen = 900;
           var ylen =  errorThreshold + 288;
           var gutter = 20;
           var xdata = [0, 2, 4,6];

/* two lines are drawn first tranparent line to provide the access to Horizontal bar from 0,7
   and second one denoting the system load*/
         var loadChart = r.linechart(80, y-19, 1240, ylen, [xAxisValuse ,xAxisValuse], [[0,1,2,7],yAixsValues], {
            gutter   : gutter,
            nostroke : false,
            axis     : "0 0 1 0",
            smooth   : false,
            shade    : true,
            colors   : ["transparent","blue"]
         });
       /*adding labels for differnt levels */
            r.text(670, 100, "Appliance Load").attr({ font: "1.5em sans-serif" ,"font-weight": "bold" });
    
        r.rect(400, ylen + 175, 8,14).attr({fill: 'rgb(0,0,255)',stroke:'rgb(0,0,255)'});
                        r.text(442, ylen + 183, "Load Level").attr({ font: "1.2em sans-serif" ,"font-weight": "bold" });	
        r.rect(485, ylen + 175, 8,14).attr({fill: 'rgb(149,175,149)',stroke:'rgb(0,0,0)'});
                        r.text(525, ylen + 183, "Ideal Area").attr({ font: "1.2em sans-serif", "font-weight": "bold" });	
        r.rect(565, ylen + 175, 8,14).attr({fill: 'rgb(200,200,149)',stroke:'rgb(0,0,0)'});
                        r.text(615, ylen + 183, "Warning Area").attr({  font: "1.2em sans-serif","font-weight": "bold"});
        r.rect(665, ylen + 175, 8,14).attr({fill: 'rgb(200,149,149)',stroke:'rgb(0,0,0)'});
                        r.text(708, ylen + 183, "Alarm Area").attr({  font: "1.2em sans-serif","font-weight": "bold" });
        var xdata = 70 ; 
        var attr = {font:'12px Verdana','text-anchor':'start'}; 
        r.text( xdata, 330, "Load").attr(attr).rotate(90).attr({ "font-weight": "bold" }); 
        loadChart.shades[1].attr({ opacity: 1 });
        var axisItems = loadChart.axis[0].text.items;

        for( var i = 0, l = axisItems.length; i < l; i++ ) {
          var date = new Date(parseInt(axisItems[i].attr("text")));
          var dateAxis= date.toLocaleDateString()
            if (i + 1 < axisItems.length)
            {
                var date2 = new Date(parseInt(axisItems[i + 1].attr("text"))) ;
                var dateAxis2= date2.toLocaleDateString();
                if (dateAxis2 == dateAxis)
                { 
                    axisItems[i].attr("text","");
                }
                else
                {
                     axisItems[i].attr("text",dateAxis);
                }
             }
            else
            {
             axisItems[i].attr("text",dateAxis);
            }
        }
}

/*function failureDetailsDialog(){
    $("#faulureDialog").dialog({
        modal: true,
        draggable: true,
        resizable: false,
        title:"Failure Report Detail",
        width: 450,
        height:350,
        dialogClass: 'ui-dialog-osx',
        buttons:{
		    "Close":function(){
			    $(this).dialog("close");
               }
        }
    });
}*/