(function($, PHD, window, undefined) {
    var $form = $("#form-archive-backups"),
        ArchiveForm,
        EmailTable;

    function initForm() {
        ArchiveForm = PHD.FormController($form, {})
            .validate({
                rules: {
                    name: {
                        required: true
                    }
                },
                messages: {
                    name: {
                        required: gettext("Job Name is required")
                    }
                }
            })
            .on("formcancel", function() {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function(event, data) {
                if(data.result[0].code === AJAX_RESULT_SUCCESS) {
                    PHD.throwNotice(data);
                    PHD.currentDialog.wizard("close");
                } else if(data.result[0].code === AJAX_RESULT_ERROR) {
                    PHD.throwError(data);
                }
            });

        EmailTable = PHD.EmailTable($form);

        //EmailTable.$table.scrollTable({"height":".modal-form-box", "resize": false});
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        // Initialize form validation and event handlers
        PHD.currentDialog.one("wizardfocus", initForm);
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
