(function($, PHD, window, undefined) {
    
    var $form = $("#upload-hotfix-form"),
        $btnSubmit = $form.find("[data-action=submit]"),
        $btnCancel = $form.find("[data-action=cancel]"),
        $uploadProgressBar = $("#upload-progress-bar"),
        $uploadProgressMeter = $uploadProgressBar.find(".progress-meter"),
        UPLOAD_FILE_REGEXP = /^(.+)?phdvb-\d+\.\d+\.\d+(\.\d+)?\.phd$/i;

    function progressDisplay(progressVal) {
        $uploadProgressBar.attr("title", progressVal);
        $uploadProgressMeter.css("width", progressVal);
    }

    function updateProgress(e) {
        var done = e.position || e.loaded, total = e.totalSize || e.total;
        var progressVal = (Math.floor(done / total * 1000) / 10) + '%';
        progressDisplay(progressVal);
    }

    function initForm() {
        $form.validate({
            errorLabelContainer: "#dialog-error-list",
            errorContainer: "#dialog-errors",
            showErrors: function(errorMap, errorList) {
                $("#dialog-errors").find(".summary")
                    .html(gettext("Correct the following errors:"));
                this.defaultShowErrors();
            },
            rules: {
                hotfix_file: {
                    required: true,
                    //pattern: UPLOAD_FILE_REGEXP
                }
            },
            messages: {
                hotfix_file: {
                    required: gettext("Please select a file to upload"),
                    //pattern: ERR_INVALID_UPDATE_FILENAME
                }
            }
        });

        $btnCancel.on("click", function(event) {
            PHD.currentDialog.wizard("close");
        });

        $btnSubmit.on("click", function(event) {
            event.preventDefault();
            var url = $form.attr("action");

            if($form.valid()) {
                var xhr = new XMLHttpRequest();

                /*
                oReq.addEventListener("error", transferFailed, false);
                oReq.addEventListener("abort", transferCanceled, false);
                */

                xhr.addEventListener('progress', updateProgress, false);

                if (xhr.upload) {
                    xhr.upload.onprogress = updateProgress;
                }

                xhr.onreadystatechange = function(e) {
                    if (4 == this.readyState && xhr.status == 200) {
                        data = $.parseJSON(xhr.responseText);
                        if(data.result[0].code == AJAX_RESULT_SUCCESS) {
                            window.location.href = '/maintenance_mode/';
                        } else {
                            progressDisplay('0%');
                            PHD.throwError(data);
                        }
                    }
                };

                xhr.open('post', $form.attr('action'), true);
                var fd = new FormData;
                fd.append('csrfmiddlewaretoken', $form.find("input[name='csrfmiddlewaretoken']").val());
                fd.append('hotfix_file', document.getElementById('id_hotfix_file').files[0]);
                xhr.send(fd);
            }
        });
    }

    /*
    *   DOM Ready Function
    */
    $(function() {
        PHD.currentDialog.one("wizardfocus", function() {
            initForm();
        });

    });

})(jQuery, window.PHD || (window.PHD = {}), window);
