(function($, PHD, window, undefined) {

    var $appContainer = $(".app"),
        $appNav = $(".app-nav"),
        $navCollapse = $(".nav-collapse a"),
        $navIcons = $(".app-nav .nav-icon");


    /*
	move to AngularJS.

    function setCollapseButton(collapsed) {
        $navCollapse.find("i").toggleClass("icon-arrowleft", !collapsed);
        $navCollapse.find("i").toggleClass("icon-arrowright", collapsed);

        if(collapsed) {
            $navIcons.tooltip("enable");
            $navCollapse.attr("title", gettext("Expand Left Navigation"));
        } else {
            $navIcons.tooltip("disable");
            $navCollapse.attr("title", gettext("Collapse Left Navigation"));
        }
    }

    function handleNavCollapse(event) {
        var collapsed = $appContainer.hasClass("nav-collapsed"),
            newNavState = collapsed ? "nav-expanded": "nav-collapsed";

        event.preventDefault();
        $appContainer.toggleClass("nav-collapsed", !collapsed);
        $appContainer.toggleClass("nav-expanded", collapsed);
        setCollapseButton(newNavState === "nav-collapsed");

        PHD.Ajax.session("nav", newNavState);
    }
    */

    /*
    *   DOM Ready Function
    */
    $(function() {

        // call global DOM Ready function
        PHD.DOMReady();

        document.addEventListener("click", function(e) {
            if(e.button === 1) {
                e.preventDefault();
                e.stopPropagation();
            }
        }, true);

        $appNav.find(".nav-item").on("click", function(event) {
            event.preventDefault();
            PHD.Ajax.safeabort();
            window.location.href = $(this).attr("href");
        });

        // Initialize tooltips for site navigation; disabled by default
        $navIcons.tooltip({
            position: {
                my: "left+20 center",
                at: "left top"
            },
            track: true
        }).tooltip("disable");

        // If the navigation is collapsed, enable the tooltips
        //setCollapseButton($appContainer.hasClass("nav-collapsed"));

        // Set up event handlers for fancy text inputs
        $('body')
            .on('keydown paste change', ".control-group.fancy input", function() { 
                $(this).each(function() { PHD.toggleLabel.call(this, 20); });
            })
            .on('focusin', ".control-group.fancy input", function() {
                $(this).prev('span').animate({ opacity: .25 }, { duration: 350 });
            })
            .on('focusout', ".control-group.fancy input", function() {
                $(this).prev('span').animate({ opacity: 1 }, { duration: 350 });
            })
            // Handle job log pop-out links
            .on("click", ".pop-out", function(e) {
                e.preventDefault();
                PHD.popOut($(this).attr("href"), "Job Log", "view_job_log");
            });

        // Set up event handler for navigation collapsing
	    // lmc
        //$(".nav-collapse a").on("click", handleNavCollapse);

        // Trigger a custom event when the navigation expand/collapse animation has ended
        $(".app-nav .nav-collapse").on("webkitTransitionEnd oTransitionEnd otransitionend transitionend msTransitionEnd", function(e) {
            e.stopPropagation();
            $(document).trigger("navshift");
        });

        $(".dropdown-menu").on("click", ".menu-root", function(e) {
            console.log("click drop-down menu root");
            e.preventDefault();
            e.stopPropagation();
            if (this.name == "")
            {
                 var scope = $("[ng-controller=GlobalCtrl]").scope();
                
                if (scope.modalShown == true)
                {
               
                       scope.modalShown=false;
                    $('.ng-alertmodeldialog-dialog').css("display","none");
                    
                }
                
            }
            
            var $el = $(this).toggleClass("open").next("ul").toggle();
            $("html, .dropdown-menu .menu-root").one("click", function(e) {
                console.log("in dropdown, remove open class, el = " + $el.html());
                $el.hide().prev("a").removeClass("open");
            });
        });

        $(".dropdown-menu").on("click", ".menu-subroot", function(e) {
            e.preventDefault();
            e.stopPropagation();
            console.log('in menu sub-root')
            var $el = $(this).toggleClass("open").next("ul").toggle();
            $("html, .dropdown-menu .menu-subroot").one("click", function(e) {
                $el.hide().prev("a").removeClass("open");
            });
        });

       /*  $(".alerts-menu").on("click", function() {
            if(parseInt($(".alert-count").text(), 10) > 0) {
                window.location.href="/";
            }
        }); */

        $(".btn-language-select").on("click", function(event) {
            event.preventDefault();
            // get the language first.
            var scope = $("[ng-controller=GlobalCtrl]").scope();
            var username = scope.user.name;
            var key = "language";
            PHD.Ajax.get("/api/preferences/" + username + "/" + key + "/")
                .done(function(data) {
                    var preferences = data.data;
                    var language = preferences[0][key];
                    function selectLanguage($dialog) {
                        console.log("on open, language is " + language);
                        $dialog.find("#select-language").val(language);
                    }
                    PHD.miniWizard("app/preferences/language.html", "language-select", {
                        title: gettext("Set Language"),
                        dialogClass: "dialog-language-select",
                        width: 200,
                        height: "auto",
                        buttons: [
                            {
                                text: gettext("Submit"),
                                type: "submit",
                                click: function () {
                                    // lmc: call API then close form.
                                    //  $(this).find("form").submit();
                                    var putData = {};
                                    $el = $(this).find("#select-language");
                                    putData[key] = $(this).find("#select-language").val();
                                    PHD.Ajax.put('/api/preferences/' + username + '/', JSON.stringify(putData))
                                        .done(function (data) {
                                            var scope = $("[ng-controller=GlobalCtrl]").scope();
                                            scope.$broadcast('update-language', putData[key]);
                                        });
                                    $(this).dialog('close');
                                }
                            },
                            {
                                text: gettext("Cancel"),
                                type: "button",
                                click: function () {
                                    $(this).dialog('close');
                                }
                            }
                        ]
                    }, false, selectLanguage)
                })
        });

        $(".btn-user-edit").on("click", function(event) {
            event.preventDefault();
            var scope = $("[ng-controller=GlobalCtrl]").scope();
            var username = scope.user.name;
            PHD.wizard('app/configure/users/edit.html', "edit-account", {
                title: gettext("Edit Account Details"),
                dialogClass: "dialog-edit-account dialog-modal-form",
                helpArticle: PHD.App.getHelpLink("account", true),
                width: 400,
                height: 500,
                open: function(event, ui) {
                    $("#id_name").val(username);
                    $("#edit_object_id").text(1); //scope.user.id);
                }
            });
        });

        $(document).on("launchdialog", function(event, params) {
            var qs = params.hasOwnProperty("dbid") ? "?inventory=" + params.dbid : "";
            switch(params.action.toLowerCase()) {
                case "backup":
                    PHD.wizard("app/joborders/backup/backup.html" + qs, "add-job", {
                        title: gettext("Create Backup Job"),
                        dialogClass: "dialog-add-job dialog-modal-form",
                        helpArticle: PHD.App.getHelpLink("backup", true),
                        beforeClose: function(event, ui) {
                            $(".backup-job-popover").remove();
                            $(".datepicker input:text").datepicker("destroy");
                            $(".ui-spinner-input").spinner("destroy");
                        }
                    });
                    break;
                case "restore":
                    //PHD.wizard("/joborder/restore/" + qs, "restore-vms",
		            // lmc
                    PHD.wizard("app/joborders/recover/recover.html" + qs, "restore-vms", {
                        title: gettext("Create Recover Job"),
                        helpArticle: PHD.App.getHelpLink("restore", true),
                        dialogClass: "dialog-restore dialog-modal-form"
                    });
                    break;
                case "replicate":
                    //PHD.wizard("/joborder/replication/", "replicate-vms",
		            // lmc
                    PHD.wizard("app/joborders/replication/replication.html" + qs, "restore-vms", {
                        title: gettext("Create Replication Job"),
                        helpArticle: PHD.App.getHelpLink("restore", true),
                        dialogClass: "dialog-replication dialog-modal-form"
                    });
                    break;
                case "recoverfiles":
                    PHD.wizard("/joborder/filerecovery/" + qs, "recover-files", {
                        title: gettext("Recover Files"),
                        helpArticle: PHD.App.getHelpLink("filerecovery", true),
                        dialogClass: "dialog-recover-files dialog-modal-form"
                    });
                    break;
                case "rollback":
                    PHD.wizard("/joborder/rollback/" + qs, "rollback-vms", {
                        title: gettext("Create Rollback Recovery Job"),
                        helpArticle: PHD.App.getHelpLink("rollback", true),
                        dialogClass: "dialog-rollback dialog-modal-form"
                    });
                    break;
                case "retention":
                    //PHD.wizard("/inventory/retention/", "manage-retention", {
		            // lmc TODO
                    PHD.wizard("app/configure/retention/retentionpolicy.html", "manage-retention", {
                        title: gettext("Manage Retention Policies"),
                        dialogClass: "dialog-manage-retention dialog-modal-form",
                        helpArticle: PHD.App.getHelpLink("retention", true),
                        width: 500,
                        height: 550
                    });
                    break;
                default:
                    break;
            }
        });

        var kbLink = "Knowledge Base";
        var kbResult = kbLink.link("https://unitrends-support.force.com/UnitrendsFree/s/article/000003589");

        var ie = gettext("You are using a web browser that is not currently supported. Some features may not function " +
            "properly and you may encounter issues including data loss. " +
            "To view a list of supported browsers, visit the " + kbResult +
            ".  Do you want to Continue?");
        if(bowser.msie && !$.cookie("ok_with_ie")) {
            PHD.confirmDialog("<p>" + ie + "<p>", {})
                .done(function() {
                    $.cookie("ok_with_ie", true, {expires: 1, path: '/'});
                })
                .fail(function() {
                    window.location.assign("https://phdtechsupport.zendesk.com/entries/23380279");
                });
        }
        
    });

    

})(jQuery, window.PHD || (window.PHD = {}), window);
