(function($, PHD, window, undefined) {

    var namespace = "maintenancemode",
        Timer;

    function checkIfUpgradeDone(init) {
        var resp = PHD.Ajax.get("/maintenance_mode/check_if_complete/");

        resp.done(function(data) {
            if (data.upgrade_done) {
                alert(gettext("The software upgrade is complete. You will be redirected to the dashboard after clicking OK."));
                window.location.href = '/';
            }

            if(init) {
                Timer.start();
            }
        });
    }

    $(document)
        .on("timertick." + namespace, function() {
            checkIfUpgradeDone();
        });

    /*
    *   DOM Ready Function
    */
    $(function() {
        // Repress any error that may occur due to the presentation server getting re-started.
        // Need to restart time in error handler because it will be stopped otherwise.
        $.ajaxSetup({
            cache: false,
            error: function(jqXHR, textStatus, errorThrown) {
                Timer.start();
            }
        });

        Timer = PHD.Timer({
            namespace: namespace,
            interval: 10000,
            pauseOnBroadcast: false,
            stopOnAjaxAbort: false
        });

        checkIfUpgradeDone(true);
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
