(function($, PHD, window, undefined) {
    
    /*
    *   Exports an object that converts integer constants to class names
    */

    var lookup = {
        get: function(key, num, prefix) {
            if(num === false || num === true) {
                num = num === false ? 0 : 1;
            }
            var state;
		    // lmc add prefix
	        if (prefix != null) {
                state = this.hasOwnProperty(prefix + key) ? this[prefix + key][num] :
                        this.hasOwnProperty(key) ? this[key][num] : "";
	        } else {
                state = this.hasOwnProperty(key) ? this[key][num] : "";
            }
            return state;
        }
    };

    lookup.alert_type = {};
    lookup.alert_type[ALERT_TYPE_UNKNOWN] = "alert-type-unknown";
    lookup.alert_type[ALERT_TYPE_OTHER] = "alert-type-other";
    lookup.alert_type[ALERT_TYPE_LICENSE_EXPIRED] = "alert-type-license-expired";
    lookup.alert_type[ALERT_TYPE_LICENSE_INVALID] = "alert-type-license-invalid";
    lookup.alert_type[ALERT_TYPE_UPDATES_AVAILABLE] = "alert-type-updates-available";
    lookup.alert_type[ALERT_TYPE_BDS_CONNECTIVITY] = "alert-type-bds-connectivity";
    lookup.alert_type[ALERT_TYPE_BDS_LOW_SPACE] = "alert-type-bds-low-space";
    lookup.alert_type[ALERT_TYPE_VBA_CONNECTIVITY] = "alert-type-vba-connectivity";
    lookup.alert_type[ALERT_TYPE_BACKUP_WINDOW] = "alert-type-backup-window";
    lookup.alert_type[ALERT_TYPE_BACKUP_NO_CBT] = "alert-type-backup-no-cbt";
    lookup.alert_type[ALERT_TYPE_BACKUP_FULL] = "alert-type-backup-full";
    lookup.alert_type[ALERT_TYPE_HYPERVISOR_SNAPSHOT] = "alert-type-hypervisor-snapshot";
    lookup.alert_type[ALERT_TYPE_HYPERVISOR_LOGIN] = "alert-type-hypervisor-login";
    lookup.alert_type[ALERT_TYPE_UNPROTECTED_VM] = "alert-type-unprotected-vm";
    lookup.alert_type[ALERT_TYPE_FLR] = "alert-type-flr";
    lookup.alert_type[ALERT_TYPE_INVENTORY_SYNC] = "alert-type-inventory-sync";
    lookup.alert_type[ALERT_TYPE_UPDATE_COMPLETE] = "alert-type-update-complete";
    lookup.alert_type[ALERT_TYPE_EMAIL_ERROR] = "alert-type-email-error";
    lookup.alert_type[ALERT_TYPE_SMTP_NOT_CONFIGURED] = "alert-type-smtp-not-configured";

    /* lmc */
    lookup.severity = {};
    lookup.severity[ALERT_SEVERITY_NOTICE] = "severity-notice";
    lookup.severity[ALERT_SEVERITY_WARNING] = "severity-warning";
    lookup.severity[ALERT_SEVERITY_CRITICAL] = "severity-critical";

    lookup.backup_mode = {};
    lookup.backup_mode[BACKUP_MODE_VIRTUAL_FULL] = "backup-mode-virtual-full";
    lookup.backup_mode[BACKUP_MODE_FULL_AND_INC] = "backup-mode-full-and-inc";

    lookup.bds_type = {};
    lookup.bds_type[BDS_TYPE_BACKUP] = "bds-type-backup";
    lookup.bds_type[BDS_TYPE_REPLICATION] = "bds-type-replication";
    lookup.bds_type[BDS_TYPE_CLOUD_CACHE] = "bds-type-cloud-cache";
    lookup.bds_type[BDS_TYPE_IR_CACHE] = "bds-type-ir-cache";
    lookup.bds_type[BDS_TYPE_ARCHIVE] = "bds-type-archive";
    lookup.bds_type[BDS_TYPE_SYNC] = "bds-type-sync";

    lookup.connection_status = {};
    lookup.connection_status[CONN_STATUS_ON] = 'connection-status-powered-on';
    lookup.connection_status[CONN_STATUS_OFF] = 'connection-status-powered-off';
    lookup.connection_status[CONN_STATUS_CANNOT_CONNECT] = 'connection-status-cannot-connect';
    lookup.connection_status[CONN_STATUS_UNKNOWN] = 'connection-status-unknown';

    lookup.enabled = {};
    lookup.enabled[FALSE] = "enabled-false";
    lookup.enabled[TRUE] =  "enabled-true";

    lookup.job_enabled = {};
    lookup.job_enabled[FALSE] = "job-enabled-false";
    lookup.job_enabled[TRUE] =  "job-enabled-true";

    /*lookup.download_status = {};
    lookup.download_status[SUPPORTFILE_STATUS_REQUESTED] = 'download-status-requested';
    lookup.download_status[SUPPORTFILE_STATUS_READY] = 'download-status-ready';
    lookup.download_status[SUPPORTFILE_STATUS_FAILED] = 'download-status-failed';
    lookup.download_status[SUPPORTFILE_STATUS_DELETING] = 'download-status-deleting';
    lookup.download_status[SUPPORTFILE_STATUS_DELETED] = 'download-status-deleted'; */

    lookup.instant_state = {};
    lookup.instant_state[INSTANT_VM_STATE_UNKNOWN] = 'instant-state-unknown';
    lookup.instant_state[INSTANT_VM_STATE_CREATING] = 'instant-state-creating';
    lookup.instant_state[INSTANT_VM_STATE_ACTIVE] = 'instant-state-active';
    lookup.instant_state[INSTANT_VM_STATE_ENDING] = 'instant-state-ending';
    lookup.instant_state[INSTANT_VM_STATE_ENDED] = 'instant-state-ended';
    lookup.instant_state[INSTANT_VM_STATE_ERROR] = 'instant-state-error';
    lookup.instant_state[INSTANT_VM_STATE_SEEDING] = 'instant-state-seeding';
    lookup.instant_state[INSTANT_VM_STATE_READY] = 'instant-state-ready';
    lookup.instant_state[INSTANT_VM_STATE_COMPLETING] = 'instant-state-completing';
    lookup.instant_state[INSTANT_VM_STATE_COMPLETED] = 'instant-state-completed';

    lookup.inventory_type = {};
    lookup.inventory_type[INV_TYPE_DISK] = 'inventory-type-drive';
    lookup.inventory_type[INV_TYPE_VM] = 'inventory-type-vm';
    lookup.inventory_type[INV_TYPE_FOLDER] = 'inventory-type-folder';
    lookup.inventory_type[INV_TYPE_RESOURCE_POOL] = 'inventory-type-resource-pool';
    lookup.inventory_type[INV_TYPE_HOST] = 'inventory-type-host';
    lookup.inventory_type[INV_TYPE_DATACENTER] = 'inventory-type-datacenter';
    lookup.inventory_type[INV_TYPE_ENVIRONMENT] = 'inventory-type-environment';
    lookup.inventory_type[INV_TYPE_UNIVERSE] = 'inventory-type-universe';
    lookup.inventory_type[INV_TYPE_CLUSTER] = 'inventory-type-cluster';
    lookup.inventory_type[INV_TYPE_VM_TEMPLATE_FOLDER] = 'inventory-type-template-folder';
    lookup.inventory_type[INV_TYPE_TAG] = 'inventory-type-tag';
    lookup.inventory_type[INV_TYPE_TEMPLATE] = 'inventory-type-template';
    lookup.inventory_type[INV_TYPE_VAPP] = 'inventory-type-vapp';
    lookup.inventory_type[INV_TYPE_FOLDER_ROOT] = 'inventory-type-folder-root';
    lookup.inventory_type[INV_TYPE_TAG_ROOT] = 'inventory-type-tag-root';
    lookup.inventory_type[INV_TYPE_XEN_POOL] = 'inventory-type-xen-pool';
    lookup.inventory_type[INV_TYPE_COMPUTE_RESOURCE] = 'inventory-type-compute-resource';
    lookup.inventory_type[INV_TYPE_VAPP_ROOT] = 'inventory-type-vapp-root';
    lookup.inventory_type[INV_TYPE_CDROM] = 'inventory-type-cdrom';
    lookup.inventory_type[INV_TYPE_NIC] = 'inventory-type-nic';
    lookup.inventory_type[INV_TYPE_USB] = 'inventory-type-usb';
    lookup.inventory_type[INV_TYPE_SNAP] = 'inventory-type-snap';
    lookup.inventory_type[INV_TYPE_DATASTORE] = 'inventory-type-datastore';
    lookup.inventory_type[INV_TYPE_JOB] = 'inventory-type-job';
    lookup.inventory_type[INV_TYPE_DISCOVERED_VMS] = 'inventory-type-discovered-vms';
    lookup.inventory_type[INV_TYPE_GENERIC] = 'inventory-type-generic';

    lookup.is_management = {};
    lookup.is_management[0] = 'is-management-no';
    lookup.is_management[1] = 'is-management-yes';
    lookup.is_engine = {};
    lookup.is_engine[0] = 'is-engine-no';
    lookup.is_engine[1] = 'is-engine-yes';
    lookup.is_presentation = {};
    lookup.is_presentation[0] = 'is-presentation-no';
    lookup.is_presentation[1] = 'is-presentation-yes';

    lookup.job_state = {};
    /*
    lookup.job_state[JOB_STATE_UNKNOWN] = "job-state-unknown";
    lookup.job_state[JOB_STATE_QUEUED] = "job-state-queued";
    lookup.job_state[JOB_STATE_PAUSED] = "job-state-paused";
    lookup.job_state[JOB_STATE_RUNNING] = "job-state-running";
    lookup.job_state[JOB_STATE_PAUSING] = "job-state-pausing";
    lookup.job_state[JOB_STATE_CANCELING] = "job-state-canceling";
    lookup.job_state[JOB_STATE_FINISHED] = "job-state-finished";
    lookup.job_state[JOB_STATE_CANCELED] = "job-state-canceled";
    lookup.job_state[JOB_STATE_IDLE] = "job-state-idle";
    */


    lookup.job_status = {};
    /*
    lookup.job_status[JOB_STATUS_UNKNOWN] = "job-status-unknown";
    lookup.job_status[JOB_STATUS_SUCCESS] = "job-status-success";
    lookup.job_status[JOB_STATUS_WARNING] = "job-status-warning";
    lookup.job_status[JOB_STATUS_ERROR] = "job-status-error";
    lookup.job_status[JOB_STATUS_CRITICAL] = "job-status-critical";
    lookup.job_status[JOB_STATUS_PARTIAL_SUCCESS] = "job-status-partial-success";
    lookup.job_status[JOB_STATUS_NONE] = "job-status-none";
    */
    /* lmc translate based on status */
    lookup.job_status['Paused'] = "job-status-paused";
    lookup.job_status["Queued"] = "job-status-queued";
    lookup.job_status["Connecting"] = "job-status-running";
    lookup.job_status["Active"] = "job-status-running";
    lookup.job_status["DB Update"] = "job-status-running";
    lookup.job_status["Cancelled"] = "job-status-canceled job-status-error";
    lookup.job_status["Warning"] = "job-status-finished job-status-partial-success";
    lookup.job_status["Successful"] = "job-status-finished job-status-success";
    lookup.job_status['error'] = "job-status-finished job-status-error";
    lookup.job_status["Error"] = "job-status-finished job-status-error";
    lookup.job_status["Complete"] = "job-status-finished";
    lookup.job_status["Process Terminated"] = "job-status-finished job-status-error";
    lookup.job_status["Unknown"] = "job-status-unknown";
    lookup.job_status["Incomplete/Cancelled"] = "job-status-finished";
    lookup.job_status["available"] = "job-status-finished job-status-success";
    lookup.job_status["Available"] = "job-status-finished job-status-success";

    lookup.job_type = {};
    lookup.job_type[JOB_TYPE_UNKNOWN] = "job-type-unknown";
    lookup.job_type[JOB_TYPE_BACKUP] = "job-type-backup";
    lookup.job_type[JOB_TYPE_RESTORE] = "job-type-restore";
    lookup.job_type[JOB_TYPE_ROLLBACK] = "job-type-rollback";
    lookup.job_type[JOB_TYPE_REPLICATION] = "job-type-replication";
    lookup.job_type[JOB_TYPE_NCDP] = "job-type-ncdp";
    lookup.job_type[JOB_TYPE_INSTANT_RESTORE] = "job-type-instant-restore";
    lookup.job_type[JOB_TYPE_LINK] = "job-type-link";
    lookup.job_type[JOB_TYPE_DELETE] = "job-type-delete";
    lookup.job_type[JOB_TYPE_BDSIO] = "job-type-bdsio";
    lookup.job_type[JOB_TYPE_VERIFY] = "job-type-verify";
    lookup.job_type[JOB_TYPE_ORPHAN_HUNT] = "job-type-orphan-hunt";
    lookup.job_type[JOB_TYPE_SNAPSHOT_HUNT] = "job-type-snapshot-hunt";
    lookup.job_type[JOB_TYPE_HYPERVISOR] = "job-type-hypervisor";
    lookup.job_type[JOB_TYPE_BACKUP_DISK] = "job-type-backup-disk";
    lookup.job_type[JOB_TYPE_RESTORE_DISK] = "job-type-restore-disk";
    lookup.job_type[JOB_TYPE_ARCHIVE] = "job-type-archive";
    lookup.job_type[JOB_TYPE_ARCHIVE_DISK] = "job-type-archive-disk";
    lookup.job_type[JOB_TYPE_IR_START] = "job-type-ir-start";
    lookup.job_type[JOB_TYPE_IR_SEED] = "job-type-ir-seed";
    lookup.job_type[JOB_TYPE_IR_MOTION] = "job-type-ir-motion";
    lookup.job_type[JOB_TYPE_IR_END] = "job-type-ir-end";
    /* lmc TODO */
    lookup.job_type["backup"] = "job-type-backup";
    lookup.job_type["restore"] = "job-type-restore";
    lookup.job_type["replication"] = "job-type-replication";
    lookup.job_type["archive"] = "job-type-archive";
    lookup.job_type["instant recovery"] = "job-type-restore";

    /*
    lookup.log_type = {};
    lookup.log_type[LOG_LEVEL_EMERGENCY] = 'Emergency';
    lookup.log_type[LOG_LEVEL_ALERT] = 'Alert';
    lookup.log_type[LOG_LEVEL_CRITICAL] = 'Critical';
    lookup.log_type[LOG_LEVEL_ERROR] = 'Error';
    lookup.log_type[LOG_LEVEL_WARNING] = 'Warning';
    lookup.log_type[LOG_LEVEL_NOTICE] = 'Notice';
    lookup.log_type[LOG_LEVEL_INFO] = 'Info';
    lookup.log_type[LOG_LEVEL_DEBUG] = 'Debug';
    */

    lookup.log_level = {};
    lookup.log_level[LOG_LEVEL_EMERGENCY] = 'log-level-emergency';
    lookup.log_level[LOG_LEVEL_ALERT] = 'log-level-alert';
    lookup.log_level[LOG_LEVEL_CRITICAL] = 'log-level-critical';
    lookup.log_level[LOG_LEVEL_ERROR] = 'log-level-error';
    lookup.log_level[LOG_LEVEL_WARNING] = 'log-level-warning';
    lookup.log_level[LOG_LEVEL_NOTICE] = 'log-level-notice';
    lookup.log_level[LOG_LEVEL_INFO] = 'log-level-info';
    lookup.log_level[LOG_LEVEL_DEBUG] = 'log-level-debug';

    lookup.recovery_type = {};
    lookup.recovery_type[RECOVERY_JOB_TYPE_ROLLBACK] = "recovery-job-type-rollback";
    lookup.recovery_type[RECOVERY_JOB_TYPE_STANDARD] = "recovery-job-type-standard";
    lookup.recovery_type[RECOVERY_JOB_TYPE_INSTANT] = "recovery-job-type-instant";

    /*lookup.save_status = {};
    lookup.save_status[SAVE_STATUS_PENDING] = "save-status-pending";
    lookup.save_status[SAVE_STATUS_SAVED] = "save-status-saved";
    lookup.save_status[SAVE_STATUS_SAVED_ERRORS] = "save-status-saved-errors";
    lookup.save_status[SAVE_STATUS_ERRORS] = "save-status-errors";
    lookup.save_status[SAVE_STATUS_DELETED] = "save-status-deleted";
    */

    lookup.schedule_type = {};
    lookup.schedule_type[SCHEDULE_TYPE_NOW] = "schedule-type-now";
    //lookup.schedule_type[SCHEDULE_TYPE_RUN_ONCE] = "schedule-type-run-once";
    //lookup.schedule_type[SCHEDULE_TYPE_ON_DEMAND] = "schedule-type-on-demand";
    lookup.schedule_type[SCHEDULE_TYPE_SCHEDULED] = "schedule-type-scheduled";

    /*lookup.send_status = {};
    lookup.send_status[SUPPORTFILE_SEND_STATUS_REQUESTED] = 'send-status-requested';
    lookup.send_status[SUPPORTFILE_SEND_STATUS_SENT] = 'send-status-sent';
    lookup.send_status[SUPPORTFILE_SEND_STATUS_UPLOAD_FAILED] = 'send-status-upload-failed';
    lookup.send_status[SUPPORTFILE_SEND_STATUS_GENERATION_FAILED] = 'send-status-generation-failed';*/

    /*lookup.supportfile_type = {};
    lookup.supportfile_type[SUPPORTFILE_TYPE_DOWNLOAD] = 'supportfile-type-download';
    lookup.supportfile_type[SUPPORTFILE_TYPE_SEND] = 'supportfile-type-send';
    lookup.supportfile_type[SUPPORTFILE_TYPE_SCHEDULED] = 'supportfile-type-scheduled';
    lookup.supportfile_type[SUPPORTFILE_TYPE_RETRY] = 'supportfile-type-retry'; */

    /*lookup.sync_status = {};
    lookup.sync_status[SYNC_STATUS_PENDING] = "sync-status-pending";
    lookup.sync_status[SYNC_STATUS_ACTIVE] = "sync-status-active";
    lookup.sync_status[SYNC_STATUS_ERROR] = "sync-status-error"; */

    lookup.system = {};
    lookup.system[FALSE] = "system-false";
    lookup.system[TRUE] = "system-true";

    lookup.version_info = {};
    lookup.version_info[VERSION_UP_TO_DATE] = "version-up-to-date";
    lookup.version_info[VERSION_NOT_UP_TO_DATE] = "version-not-up-to-date";
    lookup.version_info[VERSION_UPDATE_IN_PROGRESS] = "version-update-in-progress";

    PHD.StateLookup = lookup;

})(jQuery, window.PHD || (window.PHD = {}), window);
