var TreeViewData, nodeTmpl, headerTmpl, childTmpl, 
    checkboxes = true,
    output = "",
    INV_TYPE_CDROM              = 19,
    INV_TYPE_CLUSTER            = 9,
    INV_TYPE_COMPUTE_RESOURCE   = 17,
    INV_TYPE_DATACENTER         = 6,
    INV_TYPE_DATASTORE          = 23,
    INV_TYPE_DISCOVERED_VMS     = 25,
    INV_TYPE_DISK               = 1,
    INV_TYPE_ENVIRONMENT        = 7,
    INV_TYPE_FOLDER             = 3,
    INV_TYPE_FOLDER_ROOT        = 14,
    INV_TYPE_GENERIC            = 99,
    INV_TYPE_HOST               = 5,
    INV_TYPE_JOB                = 24,
    INV_TYPE_NIC                = 20,
    INV_TYPE_NONE               = -1,
    INV_TYPE_RESOURCE_POOL      = 4,
    INV_TYPE_SNAP               = 22,
    INV_TYPE_TAG                = 11,
    INV_TYPE_TAG_ROOT           = 15,
    INV_TYPE_TEMPLATE           = 12,
    INV_TYPE_UNIVERSE           = 8,
    INV_TYPE_USB                = 21,
    INV_TYPE_VAPP               = 13,
    INV_TYPE_VAPP_ROOT          = 18,
    INV_TYPE_VM                 = 2,
    INV_TYPE_VM_TEMPLATE_FOLDER = 10,
    INV_TYPE_XEN_POOL           = 16,
    INV_TYPE_LOOKUP = {};

    INV_TYPE_LOOKUP[INV_TYPE_CDROM] = ["cdrom", "CD-ROM"];
    INV_TYPE_LOOKUP[INV_TYPE_CLUSTER] = ["cluster", "Cluster"];
    INV_TYPE_LOOKUP[INV_TYPE_COMPUTE_RESOURCE] = ["compute_resource", "Compute Resource"];
    INV_TYPE_LOOKUP[INV_TYPE_DATACENTER] = ["datacenter", "Data Center"];
    INV_TYPE_LOOKUP[INV_TYPE_DATASTORE] = ["datastore", "Data Store"];
    INV_TYPE_LOOKUP[INV_TYPE_DISCOVERED_VMS] = ["discovered_vms", "Discovered VMs"];
    INV_TYPE_LOOKUP[INV_TYPE_DISK] = ["drive", "Drive"];
    INV_TYPE_LOOKUP[INV_TYPE_ENVIRONMENT] = ["environment", "Environment"];
    INV_TYPE_LOOKUP[INV_TYPE_FOLDER] = ["folder", "Folder"];
    INV_TYPE_LOOKUP[INV_TYPE_FOLDER_ROOT] = ["folder_root", "Folder Root"];
    INV_TYPE_LOOKUP[INV_TYPE_GENERIC] = ["generic", "Generic"];
    INV_TYPE_LOOKUP[INV_TYPE_HOST] = ["host", "Host"];
    INV_TYPE_LOOKUP[INV_TYPE_JOB] = ["job", "Job"];
    INV_TYPE_LOOKUP[INV_TYPE_NIC] = ["nic", "NIC"];
    INV_TYPE_LOOKUP[INV_TYPE_RESOURCE_POOL] = ["resource_pool", "Resource Pool"];
    INV_TYPE_LOOKUP[INV_TYPE_SNAP] = ["snap", "Snapshot"];
    INV_TYPE_LOOKUP[INV_TYPE_TAG] = ["tag", "Tag"];
    INV_TYPE_LOOKUP[INV_TYPE_TAG_ROOT] = ["tag_root", "Tag Root"];
    INV_TYPE_LOOKUP[INV_TYPE_TEMPLATE] = ["template", "Template"];
    INV_TYPE_LOOKUP[INV_TYPE_UNIVERSE] = ["universe", "Global"];
    INV_TYPE_LOOKUP[INV_TYPE_USB] = ["usb", "USB"];
    INV_TYPE_LOOKUP[INV_TYPE_VAPP] = ["vapp", "vApp"];
    INV_TYPE_LOOKUP[INV_TYPE_VAPP_ROOT] = ["vapp_root", "vApp Root"];
    INV_TYPE_LOOKUP[INV_TYPE_VM] = ["vm", "Virtual Machine"];
    INV_TYPE_LOOKUP[INV_TYPE_VM_TEMPLATE_FOLDER] = ["template_folder", "VM Template Folder"];
    INV_TYPE_LOOKUP[INV_TYPE_XEN_POOL] = ["xen_pool", "Xen Pool"];

self.addEventListener('message', function(e) {
    importScripts('../../vendor/underscore/underscore-min.js');
    initTemplates();
    var root;
    // Morph the inventory based on how many nodes are returned.
    if (e.data.inventory != null && e.data.inventory.length > 0) {
        if (e.data.inventory.length == 1) {
            root = e.data.inventory[0];
        } else {
            root = { "hv": 0, "id": "0_0", "name": "Global", "type": 8, "nodes": e.data.inventory};
        }
    } else {
        root = { "hv": 0, "id": "0_0", "name": "Empty", "type": 8, "nodes": []};
    }

    TreeViewData = root;
    // driven by protect vs restore.  On protect, false.
    //checkboxes = e.data.inventory.checkboxes;
    checkboxes = e.data.checkboxes;
    output = render({ "node": TreeViewData, "children": (TreeViewData.nodes !== null) }, 0);
    self.postMessage({
        "html": output,
        "tree": TreeViewData
    });
}, false);

function render(item, depth, last, dots) {
    var html = "",
        last = (typeof last === 'undefined') ? true : last,
        dots = (typeof dots === 'undefined') ? [] : dots;

    item.node.depth = depth;
    item.node.t = nodeType(item.node.type);
    item.node.type = [item.node.type, INV_TYPE_LOOKUP[item.node.type][0], INV_TYPE_LOOKUP[item.node.type][1]];
    item.node.dots = dots;
    item.last = last;

    // Don't show checkbox on Universe node.
    item.checkboxes = (checkboxes && (item.node.hv != 0));

    item.node.cache = "";

    item.node.cache += nodeTmpl(item.node);

    item.node.cache += headerTmpl(item);

    html += item.node.cache;

    if(item.node.nodes) {
        var childContainer = childTmpl({expand: (!depth)});
        html += childContainer;
        item.node.cache += (childContainer + "</div>");
        dots = buildDots(item, dots.slice(0,depth), depth);
        _.each(item.node.nodes, function(value, index, arr) {
            var last = (arr.length - index === 1);
            html += render({
                "node":value, 
                "children": (value.nodes !== null && value.nodes.length > 0),   // null or empty array means no children.
                "last": last
            }, depth+1, last, dots);
        });
        html += "</div>";
    }

    item.node.cache += "</div>";
    html += "</div>";
    return html;
}

function initTemplates() {
    nodeTmpl = _.template(
    '<div class="checkable<% if(!hv) { %> tree-universe<% } %>" data-dbid="<%= id %>" data-node="<%= t %>" data-type="<%= type[0] %>">'
    );

    // lmc - temporarily, do not display checkboxes for disks, until we can exclude from a job.
    // see 'if (checkboxes && (node.type[2] != "Drive"))'.  The && clause can be removed once exclusions work.
    headerTmpl = _.template(
        '<div class="header clearfix">' +
        '<% for(var i=0;i<(node.depth-1);i++) { %><i class="dots <%= node.dots[i] %>"></i><% } %>' +
        '   <% if (last && node.depth) { %><i class="dots last"></i><% } else if(node.depth) { %><i class="dots full"></i><% } %>' +
        '   <% if (children) { %><i class="expand-ctrl<% if(!node.depth){ %> expanded<% } %>"></i><% } else { %><i class="dots straight"></i><% } %>' +
        '   <% if (checkboxes && (node.type[2] != "Drive")) { %><i class="checkbox"></i><% } %>' +
        '   <% if (node.type[0] === 7) { %>' +
        '   <img src="assets/images/types/hvdark<%= node.hv %>.png" alt="<%= node.type[2] %>" title="<%= node.type[2] %>" width="16" height="16">' +
        '   <% } else { %>' + 
        '   <i class="icon-hv-<%= node.type[1] %> icon" alt="<%= node.type[2] %>" title="<%= node.type[2] %>"></i>' +
        '   <% } %>' +
        '   <span class="item-name"><%= node.name %></span>' +
        '</div>'
        );

    childTmpl = _.template(
        '<div class="children<% if(expand) { %> open<% } %>">'
        );
}

function buildDots(parent, dots, depth) {
    if(dots.length < depth) {
        if(parent.last) {
            dots.push("no-fill");
        }
        else {
            dots.push("left");
        }
    }
    return dots;
}

function nodeType(t) {
    if(t === INV_TYPE_VM || t === INV_TYPE_TEMPLATE) {
        return "vm";
    } else if(t === INV_TYPE_DISK) {
        return "disk";
    } else if (t == INV_TYPE_COMPUTE_RESOURCE) {
        return "computer";
    } else {
        return "container";
    }
}
